/* MoveOperation.c generated by valac 0.56.14, the Vala compiler
 * generated from MoveOperation.vala, do not modify */

/*-
 * Copyright 2018-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: David Hewitt <davidmhewitt@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <camel/camel.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define MAIL_MOVE_OPERATION_TIMEOUT_DURATION 5
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MOVE_ERROR (move_error_get_type ())

#define MAIL_TYPE_MOVE_OPERATION (mail_move_operation_get_type ())
#define MAIL_MOVE_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_MOVE_OPERATION, MailMoveOperation))
#define MAIL_MOVE_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_MOVE_OPERATION, MailMoveOperationClass))
#define MAIL_IS_MOVE_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_MOVE_OPERATION))
#define MAIL_IS_MOVE_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_MOVE_OPERATION))
#define MAIL_MOVE_OPERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_MOVE_OPERATION, MailMoveOperationClass))

typedef struct _MailMoveOperation MailMoveOperation;
typedef struct _MailMoveOperationClass MailMoveOperationClass;
typedef struct _MailMoveOperationPrivate MailMoveOperationPrivate;
typedef enum  {
	MAIL_MOVE_OPERATION_MOVE_TYPE_ARCHIVE,
	MAIL_MOVE_OPERATION_MOVE_TYPE_MOVE,
	MAIL_MOVE_OPERATION_MOVE_TYPE_TRASH,
	MAIL_MOVE_OPERATION_MOVE_TYPE_VTRASH
} MailMoveOperationMoveType;

#define MAIL_MOVE_OPERATION_TYPE_MOVE_TYPE (mail_move_operation_move_type_get_type ())
enum  {
	MAIL_MOVE_OPERATION_0_PROPERTY,
	MAIL_MOVE_OPERATION_NUM_PROPERTIES
};
static GParamSpec* mail_move_operation_properties[MAIL_MOVE_OPERATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MailMoveOperationNewData MailMoveOperationNewData;
#define __vala_CamelURL_free0(var) ((var == NULL) ? NULL : (var = (_vala_CamelURL_free (var), NULL)))

#define MAIL_BACKEND_TYPE_SESSION (mail_backend_session_get_type ())
#define MAIL_BACKEND_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_BACKEND_TYPE_SESSION, MailBackendSession))
#define MAIL_BACKEND_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_BACKEND_TYPE_SESSION, MailBackendSessionClass))
#define MAIL_BACKEND_IS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_BACKEND_TYPE_SESSION))
#define MAIL_BACKEND_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_BACKEND_TYPE_SESSION))
#define MAIL_BACKEND_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_BACKEND_TYPE_SESSION, MailBackendSessionClass))

typedef struct _MailBackendSession MailBackendSession;
typedef struct _MailBackendSessionClass MailBackendSessionClass;
typedef struct _MailMoveOperationSetDstFolderForUriData MailMoveOperationSetDstFolderForUriData;
typedef struct _MailMoveOperationCollectThreadMessagesData MailMoveOperationCollectThreadMessagesData;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _MailMoveOperationFinishData MailMoveOperationFinishData;
enum  {
	MAIL_MOVE_OPERATION_UNDONE_SIGNAL,
	MAIL_MOVE_OPERATION_NUM_SIGNALS
};
static guint mail_move_operation_signals[MAIL_MOVE_OPERATION_NUM_SIGNALS] = {0};

typedef enum  {
	MOVE_ERROR_DST_FOLDER_NOT_FOUND,
	MOVE_ERROR_FAILED
} MoveError;
#define MOVE_ERROR move_error_quark ()

struct _MailMoveOperation {
	GObject parent_instance;
	MailMoveOperationPrivate * priv;
};

struct _MailMoveOperationClass {
	GObjectClass parent_class;
};

struct _MailMoveOperationPrivate {
	CamelFolder* src_folder;
	CamelFolder* dst_folder;
	MailMoveOperationMoveType move_type;
	GeeArrayList* moved_messages;
	guint timeout_id;
};

struct _MailMoveOperationNewData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GType object_type;
	MailMoveOperation* self;
	CamelFolder* _src_folder;
	MailMoveOperationMoveType _move_type;
	GeeArrayList* threads;
	GVariant* dst_folder_full_name;
	guint n_messages_moved;
	CamelFolder* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _thread_list;
	gint _thread_size;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _thread_index;
	gint _tmp5_;
	gint _tmp6_;
	CamelFolderThreadNode* thread;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	CamelFolderThreadNode* _tmp9_;
	gchar* archive_folder_uri;
	gchar* _tmp10_;
	gboolean _tmp11_;
	const gchar* _tmp12_;
	GError* _tmp13_;
	CamelStore* store;
	CamelFolder* _tmp14_;
	CamelStore* _tmp15_;
	CamelStore* _tmp16_;
	CamelStore* _tmp17_;
	CamelFolder* _tmp18_;
	CamelStore* _tmp19_;
	const gchar* _tmp20_;
	CamelFolder* _tmp21_;
	CamelFolder* _tmp22_;
	CamelStore* _vala1_store;
	CamelFolder* _tmp23_;
	CamelStore* _tmp24_;
	CamelStore* _tmp25_;
	CamelStore* _tmp26_;
	CamelStore* _tmp27_;
	CamelFolder* _tmp28_;
	CamelStore* _tmp29_;
	CamelFolder* _tmp30_;
	CamelFolder* _tmp31_;
	GError* _tmp32_;
	gboolean _tmp33_;
	CamelFolder* _tmp34_;
	GError* _tmp35_;
	CamelFolder* _tmp36_;
	CamelFolder* _tmp37_;
	GError* _tmp38_;
	MailMoveOperation* _tmp39_;
	GeeArrayList* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	GeeArrayList* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	GError* _inner_error0_;
};

struct _MailMoveOperationSetDstFolderForUriData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailMoveOperation* self;
	gchar* uri;
	gboolean result;
	CamelURL* url;
	CamelURL* _tmp0_;
	CamelURL* _tmp1_;
	CamelURL* _tmp2_;
	CamelURL* _tmp3_;
	CamelService* service;
	gchar* parsed_folder_name;
	CamelURL* _tmp4_;
	const gchar* _tmp5_;
	CamelURL* _tmp6_;
	const gchar* _tmp7_;
	gchar* uid;
	gboolean _tmp8_;
	CamelURL* _tmp9_;
	const gchar* _tmp10_;
	CamelURL* _tmp11_;
	const gchar* _tmp12_;
	CamelURL* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	CamelURL* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	CamelURL* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	MailBackendSession* _tmp23_;
	const gchar* _tmp24_;
	CamelService* _tmp25_;
	gboolean _tmp26_;
	CamelURL* _tmp27_;
	const gchar* _tmp28_;
	CamelURL* _tmp29_;
	const gchar* _tmp30_;
	CamelURL* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	CamelService* _tmp38_;
	CamelService* _tmp39_;
	const gchar* _tmp40_;
	CamelFolder* _tmp41_;
	CamelService* _tmp42_;
	const gchar* _tmp43_;
	CamelFolder* _tmp44_;
	CamelFolder* _tmp45_;
	GError* _inner_error0_;
};

struct _MailMoveOperationCollectThreadMessagesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailMoveOperation* self;
	CamelFolderThreadNode* thread;
	GeeArrayList* _tmp0_;
	CamelMessageInfo* _tmp1_;
	CamelFolderThreadNode* child;
	CamelFolderThreadNode* _tmp2_;
	CamelFolderThreadNode* _tmp3_;
	CamelFolderThreadNode* _tmp4_;
	CamelFolderThreadNode* _tmp5_;
	CamelFolderThreadNode* _tmp6_;
};

struct _MailMoveOperationFinishData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailMoveOperation* self;
	MailMoveOperation* _tmp0_;
	GeeArrayList* _message_list;
	GeeArrayList* _tmp1_;
	gint _message_size;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _message_index;
	gint _tmp5_;
	gint _tmp6_;
	CamelMessageInfo* message;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	CamelMessageInfo* _tmp9_;
	GeeArrayList* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GPtrArray* message_uids;
	GPtrArray* _tmp13_;
	GeeArrayList* _vala1__message_list;
	GeeArrayList* _tmp14_;
	gint _vala1__message_size;
	GeeArrayList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _vala1__message_index;
	gint _tmp18_;
	gint _tmp19_;
	CamelMessageInfo* _vala1_message;
	GeeArrayList* _tmp20_;
	gpointer _tmp21_;
	GPtrArray* _tmp22_;
	CamelMessageInfo* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	CamelFolder* _tmp27_;
	CamelFolder* _tmp28_;
	gboolean _tmp29_;
	CamelFolder* _tmp30_;
	GPtrArray* _tmp31_;
	CamelFolder* _tmp32_;
	GError* _tmp33_;
	CamelFolder* _tmp34_;
	CamelFolder* _tmp35_;
	GeeArrayList* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	GError* _inner_error0_;
};

static gint MailMoveOperation_private_offset;
static gpointer mail_move_operation_parent_class = NULL;
static gint mail_move_operation_n_messages_queued;
static gint mail_move_operation_n_messages_queued = 0;
static MailMoveOperation* mail_move_operation_last_move_operation;
static MailMoveOperation* mail_move_operation_last_move_operation = NULL;
static GtkSpinner* mail_move_operation_spinner;
static GtkSpinner* mail_move_operation_spinner = NULL;

VALA_EXTERN GQuark move_error_quark (void);
VALA_EXTERN GType move_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType mail_move_operation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailMoveOperation, g_object_unref)
VALA_EXTERN GType mail_move_operation_move_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void mail_move_operation_undo_last_move (void);
static void mail_move_operation_update_queue (gint change);
VALA_EXTERN void mail_move_operation_bind_spinner (GtkSpinner* _spinner);
static void mail_move_operation_construct_data_free (gpointer _data);
VALA_EXTERN void mail_move_operation_new (CamelFolder* _src_folder,
                              MailMoveOperationMoveType _move_type,
                              GeeArrayList* threads,
                              GVariant* dst_folder_full_name,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
VALA_EXTERN MailMoveOperation* mail_move_operation_new_finish (GAsyncResult* _res_,
                                                   guint* n_messages_moved,
                                                   GError** error);
VALA_EXTERN void mail_move_operation_construct (GType object_type,
                                    CamelFolder* _src_folder,
                                    MailMoveOperationMoveType _move_type,
                                    GeeArrayList* threads,
                                    GVariant* dst_folder_full_name,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
VALA_EXTERN MailMoveOperation* mail_move_operation_construct_finish (GAsyncResult* _res_,
                                                         guint* n_messages_moved,
                                                         GError** error);
static gboolean mail_move_operation_construct_co (MailMoveOperationNewData* _data_);
static void mail_move_operation_collect_thread_messages (MailMoveOperation* self,
                                                  CamelFolderThreadNode* thread,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void mail_move_operation_collect_thread_messages_finish (MailMoveOperation* self,
                                                         GAsyncResult* _res_);
static void mail_move_operation_new_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_);
static gchar* mail_move_operation_get_archive_folder_uri (MailMoveOperation* self);
static void mail_move_operation_set_dst_folder_for_uri (MailMoveOperation* self,
                                                 const gchar* uri,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static gboolean mail_move_operation_set_dst_folder_for_uri_finish (MailMoveOperation* self,
                                                            GAsyncResult* _res_,
                                                            GError** error);
static gboolean __lambda24_ (MailMoveOperation* self);
static void mail_move_operation_finish (MailMoveOperation* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
static void mail_move_operation_finish_finish (MailMoveOperation* self,
                                        GAsyncResult* _res_,
                                        GError** error);
static void __lambda25_ (MailMoveOperation* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda25__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gboolean ___lambda24__gsource_func (gpointer self);
static void mail_move_operation_set_dst_folder_for_uri_data_free (gpointer _data);
static gboolean mail_move_operation_set_dst_folder_for_uri_co (MailMoveOperationSetDstFolderForUriData* _data_);
static void _vala_CamelURL_free (CamelURL* self);
VALA_EXTERN GType mail_backend_session_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailBackendSession, g_object_unref)
VALA_EXTERN MailBackendSession* mail_backend_session_get_default (void);
static void mail_move_operation_set_dst_folder_for_uri_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
VALA_EXTERN gchar* mail_backend_session_get_archive_folder_uri_for_service (MailBackendSession* self,
                                                                CamelService* service);
static void mail_move_operation_collect_thread_messages_data_free (gpointer _data);
static gboolean mail_move_operation_collect_thread_messages_co (MailMoveOperationCollectThreadMessagesData* _data_);
static void mail_move_operation_collect_thread_messages_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void mail_move_operation_finish_data_free (gpointer _data);
static gboolean mail_move_operation_finish_co (MailMoveOperationFinishData* _data_);
static void _g_free0_ (gpointer var);
static void mail_move_operation_finish_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static void mail_move_operation_finalize (GObject * obj);
static GType mail_move_operation_get_type_once (void);

GQuark
move_error_quark (void)
{
	return g_quark_from_static_string ("move-error-quark");
}

static GType
move_error_get_type_once (void)
{
	static const GEnumValue values[] = {{MOVE_ERROR_DST_FOLDER_NOT_FOUND, "MOVE_ERROR_DST_FOLDER_NOT_FOUND", "dst-folder-not-found"}, {MOVE_ERROR_FAILED, "MOVE_ERROR_FAILED", "failed"}, {0, NULL, NULL}};
	GType move_error_type_id;
	move_error_type_id = g_enum_register_static ("MoveError", values);
	return move_error_type_id;
}

GType
move_error_get_type (void)
{
	static volatile gsize move_error_type_id__once = 0;
	if (g_once_init_enter (&move_error_type_id__once)) {
		GType move_error_type_id;
		move_error_type_id = move_error_get_type_once ();
		g_once_init_leave (&move_error_type_id__once, move_error_type_id);
	}
	return move_error_type_id__once;
}

static inline gpointer
mail_move_operation_get_instance_private (MailMoveOperation* self)
{
	return G_STRUCT_MEMBER_P (self, MailMoveOperation_private_offset);
}

static GType
mail_move_operation_move_type_get_type_once (void)
{
	static const GEnumValue values[] = {{MAIL_MOVE_OPERATION_MOVE_TYPE_ARCHIVE, "MAIL_MOVE_OPERATION_MOVE_TYPE_ARCHIVE", "archive"}, {MAIL_MOVE_OPERATION_MOVE_TYPE_MOVE, "MAIL_MOVE_OPERATION_MOVE_TYPE_MOVE", "move"}, {MAIL_MOVE_OPERATION_MOVE_TYPE_TRASH, "MAIL_MOVE_OPERATION_MOVE_TYPE_TRASH", "trash"}, {MAIL_MOVE_OPERATION_MOVE_TYPE_VTRASH, "MAIL_MOVE_OPERATION_MOVE_TYPE_VTRASH", "vtrash"}, {0, NULL, NULL}};
	GType mail_move_operation_move_type_type_id;
	mail_move_operation_move_type_type_id = g_enum_register_static ("MailMoveOperationMoveType", values);
	return mail_move_operation_move_type_type_id;
}

GType
mail_move_operation_move_type_get_type (void)
{
	static volatile gsize mail_move_operation_move_type_type_id__once = 0;
	if (g_once_init_enter (&mail_move_operation_move_type_type_id__once)) {
		GType mail_move_operation_move_type_type_id;
		mail_move_operation_move_type_type_id = mail_move_operation_move_type_get_type_once ();
		g_once_init_leave (&mail_move_operation_move_type_type_id__once, mail_move_operation_move_type_type_id);
	}
	return mail_move_operation_move_type_type_id__once;
}

void
mail_move_operation_undo_last_move (void)
{
	MailMoveOperation* _tmp0_;
	MailMoveOperation* _tmp1_;
	MailMoveOperation* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	MailMoveOperation* _tmp6_;
#line 40 "../src/Backend/MoveOperation.vala"
	_tmp0_ = mail_move_operation_last_move_operation;
#line 40 "../src/Backend/MoveOperation.vala"
	if (_tmp0_ == NULL) {
#line 41 "../src/Backend/MoveOperation.vala"
		return;
#line 486 "MoveOperation.c"
	}
#line 44 "../src/Backend/MoveOperation.vala"
	_tmp1_ = mail_move_operation_last_move_operation;
#line 44 "../src/Backend/MoveOperation.vala"
	g_source_remove (_tmp1_->priv->timeout_id);
#line 45 "../src/Backend/MoveOperation.vala"
	_tmp2_ = mail_move_operation_last_move_operation;
#line 45 "../src/Backend/MoveOperation.vala"
	_tmp3_ = _tmp2_->priv->moved_messages;
#line 45 "../src/Backend/MoveOperation.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 45 "../src/Backend/MoveOperation.vala"
	_tmp5_ = _tmp4_;
#line 45 "../src/Backend/MoveOperation.vala"
	mail_move_operation_update_queue (-_tmp5_);
#line 46 "../src/Backend/MoveOperation.vala"
	_tmp6_ = mail_move_operation_last_move_operation;
#line 46 "../src/Backend/MoveOperation.vala"
	g_signal_emit (_tmp6_, mail_move_operation_signals[MAIL_MOVE_OPERATION_UNDONE_SIGNAL], 0);
#line 48 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (mail_move_operation_last_move_operation);
#line 48 "../src/Backend/MoveOperation.vala"
	mail_move_operation_last_move_operation = NULL;
#line 510 "MoveOperation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/Backend/MoveOperation.vala"
	return self ? g_object_ref (self) : NULL;
#line 518 "MoveOperation.c"
}

void
mail_move_operation_bind_spinner (GtkSpinner* _spinner)
{
	GtkSpinner* _tmp0_;
#line 51 "../src/Backend/MoveOperation.vala"
	g_return_if_fail (_spinner != NULL);
#line 52 "../src/Backend/MoveOperation.vala"
	_tmp0_ = _g_object_ref0 (_spinner);
#line 52 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (mail_move_operation_spinner);
#line 52 "../src/Backend/MoveOperation.vala"
	mail_move_operation_spinner = _tmp0_;
#line 533 "MoveOperation.c"
}

static void
mail_move_operation_update_queue (gint change)
{
	GtkSpinner* _tmp0_;
#line 56 "../src/Backend/MoveOperation.vala"
	mail_move_operation_n_messages_queued = mail_move_operation_n_messages_queued + change;
#line 58 "../src/Backend/MoveOperation.vala"
	_tmp0_ = mail_move_operation_spinner;
#line 58 "../src/Backend/MoveOperation.vala"
	if (_tmp0_ == NULL) {
#line 59 "../src/Backend/MoveOperation.vala"
		return;
#line 548 "MoveOperation.c"
	}
#line 62 "../src/Backend/MoveOperation.vala"
	if (mail_move_operation_n_messages_queued == 0) {
#line 552 "MoveOperation.c"
		GtkSpinner* _tmp1_;
#line 63 "../src/Backend/MoveOperation.vala"
		_tmp1_ = mail_move_operation_spinner;
#line 63 "../src/Backend/MoveOperation.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 558 "MoveOperation.c"
	} else {
		GtkSpinner* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GtkSpinner* _tmp5_;
#line 65 "../src/Backend/MoveOperation.vala"
		_tmp2_ = mail_move_operation_spinner;
#line 65 "../src/Backend/MoveOperation.vala"
		_tmp3_ = g_strdup_printf (_ ("Moving messages… (%u remaining)"), (guint) mail_move_operation_n_messages_queued);
#line 65 "../src/Backend/MoveOperation.vala"
		_tmp4_ = _tmp3_;
#line 65 "../src/Backend/MoveOperation.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _tmp4_);
#line 65 "../src/Backend/MoveOperation.vala"
		_g_free0 (_tmp4_);
#line 66 "../src/Backend/MoveOperation.vala"
		_tmp5_ = mail_move_operation_spinner;
#line 66 "../src/Backend/MoveOperation.vala"
		gtk_widget_show ((GtkWidget*) _tmp5_);
#line 578 "MoveOperation.c"
	}
}

static void
mail_move_operation_construct_data_free (gpointer _data)
{
	MailMoveOperationNewData* _data_;
	_data_ = _data;
#line 78 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->_src_folder);
#line 78 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->threads);
#line 78 "../src/Backend/MoveOperation.vala"
	_g_variant_unref0 (_data_->dst_folder_full_name);
#line 78 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->self);
#line 78 "../src/Backend/MoveOperation.vala"
	g_slice_free (MailMoveOperationNewData, _data_);
#line 597 "MoveOperation.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 78 "../src/Backend/MoveOperation.vala"
	return self ? g_variant_ref (self) : NULL;
#line 605 "MoveOperation.c"
}

void
mail_move_operation_construct (GType object_type,
                               CamelFolder* _src_folder,
                               MailMoveOperationMoveType _move_type,
                               GeeArrayList* threads,
                               GVariant* dst_folder_full_name,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	MailMoveOperationNewData* _data_;
	CamelFolder* _tmp0_;
	GeeArrayList* _tmp1_;
	GVariant* _tmp2_;
#line 78 "../src/Backend/MoveOperation.vala"
	g_return_if_fail (_src_folder != NULL);
#line 78 "../src/Backend/MoveOperation.vala"
	g_return_if_fail (threads != NULL);
#line 78 "../src/Backend/MoveOperation.vala"
	_data_ = g_slice_new0 (MailMoveOperationNewData);
#line 78 "../src/Backend/MoveOperation.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 78 "../src/Backend/MoveOperation.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_move_operation_construct_data_free);
#line 78 "../src/Backend/MoveOperation.vala"
	_data_->object_type = object_type;
#line 78 "../src/Backend/MoveOperation.vala"
	_tmp0_ = _g_object_ref0 (_src_folder);
#line 78 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->_src_folder);
#line 78 "../src/Backend/MoveOperation.vala"
	_data_->_src_folder = _tmp0_;
#line 78 "../src/Backend/MoveOperation.vala"
	_data_->_move_type = _move_type;
#line 78 "../src/Backend/MoveOperation.vala"
	_tmp1_ = _g_object_ref0 (threads);
#line 78 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->threads);
#line 78 "../src/Backend/MoveOperation.vala"
	_data_->threads = _tmp1_;
#line 78 "../src/Backend/MoveOperation.vala"
	_tmp2_ = _g_variant_ref0 (dst_folder_full_name);
#line 78 "../src/Backend/MoveOperation.vala"
	_g_variant_unref0 (_data_->dst_folder_full_name);
#line 78 "../src/Backend/MoveOperation.vala"
	_data_->dst_folder_full_name = _tmp2_;
#line 78 "../src/Backend/MoveOperation.vala"
	mail_move_operation_construct_co (_data_);
#line 655 "MoveOperation.c"
}

MailMoveOperation*
mail_move_operation_construct_finish (GAsyncResult* _res_,
                                      guint* n_messages_moved,
                                      GError** error)
{
	MailMoveOperation* result;
	MailMoveOperationNewData* _data_;
#line 78 "../src/Backend/MoveOperation.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 78 "../src/Backend/MoveOperation.vala"
	if (NULL == _data_) {
#line 78 "../src/Backend/MoveOperation.vala"
		return NULL;
#line 671 "MoveOperation.c"
	}
#line 78 "../src/Backend/MoveOperation.vala"
	if (n_messages_moved) {
#line 78 "../src/Backend/MoveOperation.vala"
		*n_messages_moved = _data_->n_messages_moved;
#line 677 "MoveOperation.c"
	}
#line 78 "../src/Backend/MoveOperation.vala"
	result = _data_->self;
#line 78 "../src/Backend/MoveOperation.vala"
	_data_->self = NULL;
#line 78 "../src/Backend/MoveOperation.vala"
	return result;
#line 685 "MoveOperation.c"
}

static void
mail_move_operation_new_ready (GObject* source_object,
                               GAsyncResult* _res_,
                               gpointer _user_data_)
{
	MailMoveOperationNewData* _data_;
#line 91 "../src/Backend/MoveOperation.vala"
	_data_ = _user_data_;
#line 91 "../src/Backend/MoveOperation.vala"
	_data_->_source_object_ = source_object;
#line 91 "../src/Backend/MoveOperation.vala"
	_data_->_res_ = _res_;
#line 91 "../src/Backend/MoveOperation.vala"
	mail_move_operation_construct_co (_data_);
#line 702 "MoveOperation.c"
}

static void
__lambda25_ (MailMoveOperation* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 134 "../src/Backend/MoveOperation.vala"
	g_return_if_fail (res != NULL);
#line 713 "MoveOperation.c"
	{
#line 136 "../src/Backend/MoveOperation.vala"
		mail_move_operation_finish_finish (self, res, &_inner_error0_);
#line 136 "../src/Backend/MoveOperation.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 719 "MoveOperation.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 135 "../src/Backend/MoveOperation.vala"
		e = _inner_error0_;
#line 135 "../src/Backend/MoveOperation.vala"
		_inner_error0_ = NULL;
#line 138 "../src/Backend/MoveOperation.vala"
		_tmp0_ = e;
#line 138 "../src/Backend/MoveOperation.vala"
		_tmp1_ = _tmp0_->message;
#line 138 "../src/Backend/MoveOperation.vala"
		g_warning ("MoveOperation.vala:138: Failed to finish move operation: %s", _tmp1_);
#line 135 "../src/Backend/MoveOperation.vala"
		_g_error_free0 (e);
#line 741 "MoveOperation.c"
	}
	__finally0:
#line 135 "../src/Backend/MoveOperation.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../src/Backend/MoveOperation.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 135 "../src/Backend/MoveOperation.vala"
		g_clear_error (&_inner_error0_);
#line 135 "../src/Backend/MoveOperation.vala"
		return;
#line 752 "MoveOperation.c"
	}
}

static void
___lambda25__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 134 "../src/Backend/MoveOperation.vala"
	__lambda25_ ((MailMoveOperation*) self, source_object, res);
#line 134 "../src/Backend/MoveOperation.vala"
	g_object_unref (self);
#line 765 "MoveOperation.c"
}

static gboolean
__lambda24_ (MailMoveOperation* self)
{
	gboolean result;
#line 134 "../src/Backend/MoveOperation.vala"
	mail_move_operation_finish (self, ___lambda25__gasync_ready_callback, g_object_ref (self));
#line 141 "../src/Backend/MoveOperation.vala"
	result = G_SOURCE_REMOVE;
#line 141 "../src/Backend/MoveOperation.vala"
	return result;
#line 778 "MoveOperation.c"
}

static gboolean
___lambda24__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda24_ ((MailMoveOperation*) self);
#line 133 "../src/Backend/MoveOperation.vala"
	return result;
#line 788 "MoveOperation.c"
}

static gboolean
mail_move_operation_construct_co (MailMoveOperationNewData* _data_)
{
#line 78 "../src/Backend/MoveOperation.vala"
	switch (_data_->_state_) {
#line 78 "../src/Backend/MoveOperation.vala"
		case 0:
#line 798 "MoveOperation.c"
		goto _state_0;
#line 78 "../src/Backend/MoveOperation.vala"
		case 1:
#line 802 "MoveOperation.c"
		goto _state_1;
#line 78 "../src/Backend/MoveOperation.vala"
		case 2:
#line 806 "MoveOperation.c"
		goto _state_2;
#line 78 "../src/Backend/MoveOperation.vala"
		case 3:
#line 810 "MoveOperation.c"
		goto _state_3;
#line 78 "../src/Backend/MoveOperation.vala"
		case 4:
#line 814 "MoveOperation.c"
		goto _state_4;
		default:
#line 78 "../src/Backend/MoveOperation.vala"
		g_assert_not_reached ();
#line 819 "MoveOperation.c"
	}
	_state_0:
#line 78 "../src/Backend/MoveOperation.vala"
	_data_->self = (MailMoveOperation*) g_object_new (_data_->object_type, NULL);
#line 85 "../src/Backend/MoveOperation.vala"
	_data_->_tmp0_ = _g_object_ref0 (_data_->_src_folder);
#line 85 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->self->priv->src_folder);
#line 85 "../src/Backend/MoveOperation.vala"
	_data_->self->priv->src_folder = _data_->_tmp0_;
#line 86 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->self->priv->dst_folder);
#line 86 "../src/Backend/MoveOperation.vala"
	_data_->self->priv->dst_folder = NULL;
#line 87 "../src/Backend/MoveOperation.vala"
	_data_->self->priv->move_type = _data_->_move_type;
#line 88 "../src/Backend/MoveOperation.vala"
	_data_->_tmp1_ = gee_array_list_new (camel_message_info_get_type (), NULL, NULL, NULL, NULL, NULL);
#line 88 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->self->priv->moved_messages);
#line 88 "../src/Backend/MoveOperation.vala"
	_data_->self->priv->moved_messages = _data_->_tmp1_;
#line 842 "MoveOperation.c"
	{
#line 90 "../src/Backend/MoveOperation.vala"
		_data_->_thread_list = _data_->threads;
#line 90 "../src/Backend/MoveOperation.vala"
		_data_->_tmp2_ = _data_->_thread_list;
#line 90 "../src/Backend/MoveOperation.vala"
		_data_->_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp2_);
#line 90 "../src/Backend/MoveOperation.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 90 "../src/Backend/MoveOperation.vala"
		_data_->_thread_size = _data_->_tmp4_;
#line 90 "../src/Backend/MoveOperation.vala"
		_data_->_thread_index = -1;
#line 90 "../src/Backend/MoveOperation.vala"
		while (TRUE) {
#line 90 "../src/Backend/MoveOperation.vala"
			_data_->_thread_index = _data_->_thread_index + 1;
#line 90 "../src/Backend/MoveOperation.vala"
			_data_->_tmp5_ = _data_->_thread_index;
#line 90 "../src/Backend/MoveOperation.vala"
			_data_->_tmp6_ = _data_->_thread_size;
#line 90 "../src/Backend/MoveOperation.vala"
			if (!(_data_->_tmp5_ < _data_->_tmp6_)) {
#line 90 "../src/Backend/MoveOperation.vala"
				break;
#line 868 "MoveOperation.c"
			}
#line 90 "../src/Backend/MoveOperation.vala"
			_data_->_tmp7_ = _data_->_thread_list;
#line 90 "../src/Backend/MoveOperation.vala"
			_data_->_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp7_, _data_->_thread_index);
#line 90 "../src/Backend/MoveOperation.vala"
			_data_->thread = (CamelFolderThreadNode*) _data_->_tmp8_;
#line 91 "../src/Backend/MoveOperation.vala"
			_data_->_tmp9_ = _data_->thread;
#line 91 "../src/Backend/MoveOperation.vala"
			_data_->_state_ = 1;
#line 91 "../src/Backend/MoveOperation.vala"
			mail_move_operation_collect_thread_messages (_data_->self, _data_->_tmp9_, mail_move_operation_new_ready, _data_);
#line 91 "../src/Backend/MoveOperation.vala"
			return FALSE;
#line 884 "MoveOperation.c"
			_state_1:
#line 91 "../src/Backend/MoveOperation.vala"
			mail_move_operation_collect_thread_messages_finish (_data_->self, _data_->_res_);
#line 888 "MoveOperation.c"
		}
	}
#line 94 "../src/Backend/MoveOperation.vala"
	switch (_data_->self->priv->move_type) {
#line 94 "../src/Backend/MoveOperation.vala"
		case MAIL_MOVE_OPERATION_MOVE_TYPE_ARCHIVE:
#line 895 "MoveOperation.c"
		{
#line 96 "../src/Backend/MoveOperation.vala"
			_data_->_tmp10_ = mail_move_operation_get_archive_folder_uri (_data_->self);
#line 96 "../src/Backend/MoveOperation.vala"
			_data_->archive_folder_uri = _data_->_tmp10_;
#line 97 "../src/Backend/MoveOperation.vala"
			_data_->_tmp12_ = _data_->archive_folder_uri;
#line 97 "../src/Backend/MoveOperation.vala"
			_data_->_state_ = 2;
#line 97 "../src/Backend/MoveOperation.vala"
			mail_move_operation_set_dst_folder_for_uri (_data_->self, _data_->_tmp12_, mail_move_operation_new_ready, _data_);
#line 97 "../src/Backend/MoveOperation.vala"
			return FALSE;
#line 909 "MoveOperation.c"
			_state_2:
#line 97 "../src/Backend/MoveOperation.vala"
			_data_->_tmp11_ = mail_move_operation_set_dst_folder_for_uri_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 97 "../src/Backend/MoveOperation.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 97 "../src/Backend/MoveOperation.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 97 "../src/Backend/MoveOperation.vala"
				_g_free0 (_data_->archive_folder_uri);
#line 97 "../src/Backend/MoveOperation.vala"
				g_object_unref (_data_->_async_result);
#line 97 "../src/Backend/MoveOperation.vala"
				return FALSE;
#line 923 "MoveOperation.c"
			}
#line 97 "../src/Backend/MoveOperation.vala"
			if (!_data_->_tmp11_) {
#line 98 "../src/Backend/MoveOperation.vala"
				_data_->_tmp13_ = g_error_new_literal (MOVE_ERROR, MOVE_ERROR_DST_FOLDER_NOT_FOUND, _ ("No Archive folder is configured."));
#line 98 "../src/Backend/MoveOperation.vala"
				_data_->_inner_error0_ = _data_->_tmp13_;
#line 98 "../src/Backend/MoveOperation.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 98 "../src/Backend/MoveOperation.vala"
				_g_free0 (_data_->archive_folder_uri);
#line 98 "../src/Backend/MoveOperation.vala"
				g_object_unref (_data_->_async_result);
#line 98 "../src/Backend/MoveOperation.vala"
				return FALSE;
#line 939 "MoveOperation.c"
			}
#line 100 "../src/Backend/MoveOperation.vala"
			_g_free0 (_data_->archive_folder_uri);
#line 100 "../src/Backend/MoveOperation.vala"
			break;
#line 945 "MoveOperation.c"
		}
#line 94 "../src/Backend/MoveOperation.vala"
		case MAIL_MOVE_OPERATION_MOVE_TYPE_MOVE:
#line 949 "MoveOperation.c"
		{
#line 103 "../src/Backend/MoveOperation.vala"
			_data_->_tmp14_ = _data_->self->priv->src_folder;
#line 103 "../src/Backend/MoveOperation.vala"
			_data_->_tmp15_ = camel_folder_get_parent_store (_data_->_tmp14_);
#line 103 "../src/Backend/MoveOperation.vala"
			_data_->_tmp16_ = _data_->_tmp15_;
#line 103 "../src/Backend/MoveOperation.vala"
			_data_->_tmp17_ = _g_object_ref0 (_data_->_tmp16_);
#line 103 "../src/Backend/MoveOperation.vala"
			_data_->store = _data_->_tmp17_;
#line 104 "../src/Backend/MoveOperation.vala"
			_data_->_tmp19_ = _data_->store;
#line 104 "../src/Backend/MoveOperation.vala"
			_data_->_tmp20_ = g_variant_get_string (_data_->dst_folder_full_name, NULL);
#line 104 "../src/Backend/MoveOperation.vala"
			_data_->_state_ = 3;
#line 104 "../src/Backend/MoveOperation.vala"
			camel_store_get_folder (_data_->_tmp19_, _data_->_tmp20_, CAMEL_STORE_FOLDER_NONE, G_PRIORITY_DEFAULT, NULL, mail_move_operation_new_ready, _data_);
#line 104 "../src/Backend/MoveOperation.vala"
			return FALSE;
#line 971 "MoveOperation.c"
			_state_3:
#line 104 "../src/Backend/MoveOperation.vala"
			_data_->_tmp21_ = camel_store_get_folder_finish (_data_->_tmp19_, _data_->_res_, &_data_->_inner_error0_);
#line 104 "../src/Backend/MoveOperation.vala"
			_data_->_tmp18_ = _data_->_tmp21_;
#line 104 "../src/Backend/MoveOperation.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 104 "../src/Backend/MoveOperation.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 104 "../src/Backend/MoveOperation.vala"
				_g_object_unref0 (_data_->store);
#line 104 "../src/Backend/MoveOperation.vala"
				g_object_unref (_data_->_async_result);
#line 104 "../src/Backend/MoveOperation.vala"
				return FALSE;
#line 987 "MoveOperation.c"
			}
#line 104 "../src/Backend/MoveOperation.vala"
			_data_->_tmp22_ = _data_->_tmp18_;
#line 104 "../src/Backend/MoveOperation.vala"
			_data_->_tmp18_ = NULL;
#line 104 "../src/Backend/MoveOperation.vala"
			_g_object_unref0 (_data_->self->priv->dst_folder);
#line 104 "../src/Backend/MoveOperation.vala"
			_data_->self->priv->dst_folder = _data_->_tmp22_;
#line 110 "../src/Backend/MoveOperation.vala"
			_g_object_unref0 (_data_->_tmp18_);
#line 110 "../src/Backend/MoveOperation.vala"
			_g_object_unref0 (_data_->store);
#line 110 "../src/Backend/MoveOperation.vala"
			break;
#line 1003 "MoveOperation.c"
		}
#line 94 "../src/Backend/MoveOperation.vala"
		case MAIL_MOVE_OPERATION_MOVE_TYPE_TRASH:
#line 1007 "MoveOperation.c"
		{
#line 113 "../src/Backend/MoveOperation.vala"
			_data_->_tmp23_ = _data_->self->priv->src_folder;
#line 113 "../src/Backend/MoveOperation.vala"
			_data_->_tmp24_ = camel_folder_get_parent_store (_data_->_tmp23_);
#line 113 "../src/Backend/MoveOperation.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 113 "../src/Backend/MoveOperation.vala"
			_data_->_tmp26_ = _g_object_ref0 (_data_->_tmp25_);
#line 113 "../src/Backend/MoveOperation.vala"
			_data_->_vala1_store = _data_->_tmp26_;
#line 114 "../src/Backend/MoveOperation.vala"
			_data_->_tmp27_ = _data_->_vala1_store;
#line 114 "../src/Backend/MoveOperation.vala"
			if ((((CamelStoreFlags) camel_store_get_flags (_data_->_tmp27_)) & CAMEL_STORE_VTRASH) == CAMEL_STORE_VTRASH) {
#line 115 "../src/Backend/MoveOperation.vala"
				_data_->self->priv->move_type = MAIL_MOVE_OPERATION_MOVE_TYPE_VTRASH;
#line 1025 "MoveOperation.c"
			} else {
#line 117 "../src/Backend/MoveOperation.vala"
				_data_->_tmp29_ = _data_->_vala1_store;
#line 117 "../src/Backend/MoveOperation.vala"
				_data_->_state_ = 4;
#line 117 "../src/Backend/MoveOperation.vala"
				camel_store_get_trash_folder (_data_->_tmp29_, G_PRIORITY_DEFAULT, NULL, mail_move_operation_new_ready, _data_);
#line 117 "../src/Backend/MoveOperation.vala"
				return FALSE;
#line 1035 "MoveOperation.c"
				_state_4:
#line 117 "../src/Backend/MoveOperation.vala"
				_data_->_tmp30_ = camel_store_get_trash_folder_finish (_data_->_tmp29_, _data_->_res_, &_data_->_inner_error0_);
#line 117 "../src/Backend/MoveOperation.vala"
				_data_->_tmp28_ = _data_->_tmp30_;
#line 117 "../src/Backend/MoveOperation.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 117 "../src/Backend/MoveOperation.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 117 "../src/Backend/MoveOperation.vala"
					_g_object_unref0 (_data_->_vala1_store);
#line 117 "../src/Backend/MoveOperation.vala"
					g_object_unref (_data_->_async_result);
#line 117 "../src/Backend/MoveOperation.vala"
					return FALSE;
#line 1051 "MoveOperation.c"
				}
#line 117 "../src/Backend/MoveOperation.vala"
				_data_->_tmp31_ = _data_->_tmp28_;
#line 117 "../src/Backend/MoveOperation.vala"
				_data_->_tmp28_ = NULL;
#line 117 "../src/Backend/MoveOperation.vala"
				_g_object_unref0 (_data_->self->priv->dst_folder);
#line 117 "../src/Backend/MoveOperation.vala"
				_data_->self->priv->dst_folder = _data_->_tmp31_;
#line 114 "../src/Backend/MoveOperation.vala"
				_g_object_unref0 (_data_->_tmp28_);
#line 1063 "MoveOperation.c"
			}
#line 119 "../src/Backend/MoveOperation.vala"
			_g_object_unref0 (_data_->_vala1_store);
#line 119 "../src/Backend/MoveOperation.vala"
			break;
#line 1069 "MoveOperation.c"
		}
#line 94 "../src/Backend/MoveOperation.vala"
		case MAIL_MOVE_OPERATION_MOVE_TYPE_VTRASH:
#line 1073 "MoveOperation.c"
		{
#line 122 "../src/Backend/MoveOperation.vala"
			_data_->_tmp32_ = g_error_new_literal (G_OPTION_ERROR, G_OPTION_ERROR_BAD_VALUE, "MoveType.VTRASH: Invalid value");
#line 122 "../src/Backend/MoveOperation.vala"
			_data_->_inner_error0_ = _data_->_tmp32_;
#line 122 "../src/Backend/MoveOperation.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 122 "../src/Backend/MoveOperation.vala"
			g_object_unref (_data_->_async_result);
#line 122 "../src/Backend/MoveOperation.vala"
			return FALSE;
#line 1085 "MoveOperation.c"
		}
		default:
#line 94 "../src/Backend/MoveOperation.vala"
		break;
#line 1090 "MoveOperation.c"
	}
#line 125 "../src/Backend/MoveOperation.vala"
	_data_->_tmp34_ = _data_->self->priv->dst_folder;
#line 125 "../src/Backend/MoveOperation.vala"
	if (_data_->_tmp34_ == NULL) {
#line 125 "../src/Backend/MoveOperation.vala"
		_data_->_tmp33_ = _data_->self->priv->move_type != MAIL_MOVE_OPERATION_MOVE_TYPE_VTRASH;
#line 1098 "MoveOperation.c"
	} else {
#line 125 "../src/Backend/MoveOperation.vala"
		_data_->_tmp33_ = FALSE;
#line 1102 "MoveOperation.c"
	}
#line 125 "../src/Backend/MoveOperation.vala"
	if (_data_->_tmp33_) {
#line 126 "../src/Backend/MoveOperation.vala"
		_data_->_tmp35_ = g_error_new_literal (MOVE_ERROR, MOVE_ERROR_DST_FOLDER_NOT_FOUND, _ ("The destination folder was not found."));
#line 126 "../src/Backend/MoveOperation.vala"
		_data_->_inner_error0_ = _data_->_tmp35_;
#line 126 "../src/Backend/MoveOperation.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 126 "../src/Backend/MoveOperation.vala"
		g_object_unref (_data_->_async_result);
#line 126 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 1116 "MoveOperation.c"
	}
#line 129 "../src/Backend/MoveOperation.vala"
	_data_->_tmp36_ = _data_->self->priv->src_folder;
#line 129 "../src/Backend/MoveOperation.vala"
	_data_->_tmp37_ = _data_->self->priv->dst_folder;
#line 129 "../src/Backend/MoveOperation.vala"
	if (_data_->_tmp36_ == _data_->_tmp37_) {
#line 130 "../src/Backend/MoveOperation.vala"
		_data_->_tmp38_ = g_error_new_literal (MOVE_ERROR, MOVE_ERROR_DST_FOLDER_NOT_FOUND, _ ("The source folder is the destination folder."));
#line 130 "../src/Backend/MoveOperation.vala"
		_data_->_inner_error0_ = _data_->_tmp38_;
#line 130 "../src/Backend/MoveOperation.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 130 "../src/Backend/MoveOperation.vala"
		g_object_unref (_data_->_async_result);
#line 130 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 1134 "MoveOperation.c"
	}
#line 133 "../src/Backend/MoveOperation.vala"
	_data_->self->priv->timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) MAIL_MOVE_OPERATION_TIMEOUT_DURATION, ___lambda24__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 144 "../src/Backend/MoveOperation.vala"
	_data_->_tmp39_ = _g_object_ref0 (_data_->self);
#line 144 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (mail_move_operation_last_move_operation);
#line 144 "../src/Backend/MoveOperation.vala"
	mail_move_operation_last_move_operation = _data_->_tmp39_;
#line 145 "../src/Backend/MoveOperation.vala"
	_data_->_tmp40_ = _data_->self->priv->moved_messages;
#line 145 "../src/Backend/MoveOperation.vala"
	_data_->_tmp41_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp40_);
#line 145 "../src/Backend/MoveOperation.vala"
	_data_->_tmp42_ = _data_->_tmp41_;
#line 145 "../src/Backend/MoveOperation.vala"
	mail_move_operation_update_queue (_data_->_tmp42_);
#line 147 "../src/Backend/MoveOperation.vala"
	_data_->_tmp43_ = _data_->self->priv->moved_messages;
#line 147 "../src/Backend/MoveOperation.vala"
	_data_->_tmp44_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp43_);
#line 147 "../src/Backend/MoveOperation.vala"
	_data_->_tmp45_ = _data_->_tmp44_;
#line 147 "../src/Backend/MoveOperation.vala"
	_data_->n_messages_moved = (guint) _data_->_tmp45_;
#line 78 "../src/Backend/MoveOperation.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 78 "../src/Backend/MoveOperation.vala"
	if (_data_->_state_ != 0) {
#line 78 "../src/Backend/MoveOperation.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 78 "../src/Backend/MoveOperation.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1168 "MoveOperation.c"
		}
	}
#line 78 "../src/Backend/MoveOperation.vala"
	g_object_unref (_data_->_async_result);
#line 78 "../src/Backend/MoveOperation.vala"
	return FALSE;
#line 1175 "MoveOperation.c"
}

void
mail_move_operation_new (CamelFolder* _src_folder,
                         MailMoveOperationMoveType _move_type,
                         GeeArrayList* threads,
                         GVariant* dst_folder_full_name,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
#line 78 "../src/Backend/MoveOperation.vala"
	mail_move_operation_construct (MAIL_TYPE_MOVE_OPERATION, _src_folder, _move_type, threads, dst_folder_full_name, _callback_, _user_data_);
#line 1188 "MoveOperation.c"
}

MailMoveOperation*
mail_move_operation_new_finish (GAsyncResult* _res_,
                                guint* n_messages_moved,
                                GError** error)
{
#line 78 "../src/Backend/MoveOperation.vala"
	return mail_move_operation_construct_finish (_res_, n_messages_moved, error);
#line 1198 "MoveOperation.c"
}

static void
mail_move_operation_set_dst_folder_for_uri_data_free (gpointer _data)
{
	MailMoveOperationSetDstFolderForUriData* _data_;
	_data_ = _data;
#line 25 "../src/Backend/MoveOperation.vala"
	_g_free0 (_data_->uri);
#line 25 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/Backend/MoveOperation.vala"
	g_slice_free (MailMoveOperationSetDstFolderForUriData, _data_);
#line 1212 "MoveOperation.c"
}

static void
mail_move_operation_set_dst_folder_for_uri (MailMoveOperation* self,
                                            const gchar* uri,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	MailMoveOperationSetDstFolderForUriData* _data_;
	MailMoveOperation* _tmp0_;
	gchar* _tmp1_;
#line 25 "../src/Backend/MoveOperation.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Backend/MoveOperation.vala"
	g_return_if_fail (uri != NULL);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_ = g_slice_new0 (MailMoveOperationSetDstFolderForUriData);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/Backend/MoveOperation.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_move_operation_set_dst_folder_for_uri_data_free);
#line 25 "../src/Backend/MoveOperation.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_->self = _tmp0_;
#line 25 "../src/Backend/MoveOperation.vala"
	_tmp1_ = g_strdup (uri);
#line 25 "../src/Backend/MoveOperation.vala"
	_g_free0 (_data_->uri);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_->uri = _tmp1_;
#line 25 "../src/Backend/MoveOperation.vala"
	mail_move_operation_set_dst_folder_for_uri_co (_data_);
#line 1246 "MoveOperation.c"
}

static gboolean
mail_move_operation_set_dst_folder_for_uri_finish (MailMoveOperation* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	gboolean result;
	MailMoveOperationSetDstFolderForUriData* _data_;
#line 25 "../src/Backend/MoveOperation.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 25 "../src/Backend/MoveOperation.vala"
	if (NULL == _data_) {
#line 1260 "MoveOperation.c"
		gboolean _tmp0_ = FALSE;
#line 25 "../src/Backend/MoveOperation.vala"
		return _tmp0_;
#line 1264 "MoveOperation.c"
	}
#line 25 "../src/Backend/MoveOperation.vala"
	result = _data_->result;
#line 25 "../src/Backend/MoveOperation.vala"
	return result;
#line 1270 "MoveOperation.c"
}

static void
_vala_CamelURL_free (CamelURL* self)
{
#line 152 "../src/Backend/MoveOperation.vala"
	g_boxed_free (camel_url_get_type (), self);
#line 1278 "MoveOperation.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 1301 "MoveOperation.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 1310 "MoveOperation.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1329 "MoveOperation.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1333 "MoveOperation.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1339 "MoveOperation.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1349 "MoveOperation.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1357 "MoveOperation.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1361 "MoveOperation.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 1367 "MoveOperation.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 1377 "MoveOperation.c"
}

static void
mail_move_operation_set_dst_folder_for_uri_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	MailMoveOperationSetDstFolderForUriData* _data_;
#line 178 "../src/Backend/MoveOperation.vala"
	_data_ = _user_data_;
#line 178 "../src/Backend/MoveOperation.vala"
	_data_->_source_object_ = source_object;
#line 178 "../src/Backend/MoveOperation.vala"
	_data_->_res_ = _res_;
#line 178 "../src/Backend/MoveOperation.vala"
	mail_move_operation_set_dst_folder_for_uri_co (_data_);
#line 1394 "MoveOperation.c"
}

static gboolean
mail_move_operation_set_dst_folder_for_uri_co (MailMoveOperationSetDstFolderForUriData* _data_)
{
#line 150 "../src/Backend/MoveOperation.vala"
	switch (_data_->_state_) {
#line 150 "../src/Backend/MoveOperation.vala"
		case 0:
#line 1404 "MoveOperation.c"
		goto _state_0;
#line 150 "../src/Backend/MoveOperation.vala"
		case 1:
#line 1408 "MoveOperation.c"
		goto _state_1;
		default:
#line 150 "../src/Backend/MoveOperation.vala"
		g_assert_not_reached ();
#line 1413 "MoveOperation.c"
	}
	_state_0:
#line 151 "../src/Backend/MoveOperation.vala"
	_data_->url = NULL;
#line 152 "../src/Backend/MoveOperation.vala"
	_data_->_tmp1_ = camel_url_new (_data_->uri, &_data_->_inner_error0_);
#line 152 "../src/Backend/MoveOperation.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 152 "../src/Backend/MoveOperation.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 152 "../src/Backend/MoveOperation.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 152 "../src/Backend/MoveOperation.vala"
		__vala_CamelURL_free0 (_data_->url);
#line 152 "../src/Backend/MoveOperation.vala"
		g_object_unref (_data_->_async_result);
#line 152 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 1432 "MoveOperation.c"
	}
#line 152 "../src/Backend/MoveOperation.vala"
	_data_->_tmp2_ = _data_->_tmp0_;
#line 152 "../src/Backend/MoveOperation.vala"
	_data_->_tmp0_ = NULL;
#line 152 "../src/Backend/MoveOperation.vala"
	__vala_CamelURL_free0 (_data_->url);
#line 152 "../src/Backend/MoveOperation.vala"
	_data_->url = _data_->_tmp2_;
#line 153 "../src/Backend/MoveOperation.vala"
	_data_->_tmp3_ = _data_->url;
#line 153 "../src/Backend/MoveOperation.vala"
	if (_data_->_tmp3_ == NULL) {
#line 154 "../src/Backend/MoveOperation.vala"
		_data_->result = FALSE;
#line 154 "../src/Backend/MoveOperation.vala"
		__vala_CamelURL_free0 (_data_->_tmp0_);
#line 154 "../src/Backend/MoveOperation.vala"
		__vala_CamelURL_free0 (_data_->url);
#line 154 "../src/Backend/MoveOperation.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 154 "../src/Backend/MoveOperation.vala"
		if (_data_->_state_ != 0) {
#line 154 "../src/Backend/MoveOperation.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 154 "../src/Backend/MoveOperation.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1460 "MoveOperation.c"
			}
		}
#line 154 "../src/Backend/MoveOperation.vala"
		g_object_unref (_data_->_async_result);
#line 154 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 1467 "MoveOperation.c"
	}
#line 157 "../src/Backend/MoveOperation.vala"
	_data_->service = NULL;
#line 158 "../src/Backend/MoveOperation.vala"
	_data_->parsed_folder_name = NULL;
#line 160 "../src/Backend/MoveOperation.vala"
	_data_->_tmp4_ = _data_->url;
#line 160 "../src/Backend/MoveOperation.vala"
	_data_->_tmp5_ = _data_->_tmp4_->protocol;
#line 160 "../src/Backend/MoveOperation.vala"
	if (g_strcmp0 (_data_->_tmp5_, "folder") == 0) {
#line 161 "../src/Backend/MoveOperation.vala"
		_data_->_tmp6_ = _data_->url;
#line 161 "../src/Backend/MoveOperation.vala"
		_data_->_tmp7_ = _data_->_tmp6_->host;
#line 161 "../src/Backend/MoveOperation.vala"
		if (_data_->_tmp7_ != NULL) {
#line 163 "../src/Backend/MoveOperation.vala"
			_data_->_tmp9_ = _data_->url;
#line 163 "../src/Backend/MoveOperation.vala"
			_data_->_tmp10_ = _data_->_tmp9_->user;
#line 163 "../src/Backend/MoveOperation.vala"
			if (_data_->_tmp10_ == NULL) {
#line 163 "../src/Backend/MoveOperation.vala"
				_data_->_tmp8_ = TRUE;
#line 1493 "MoveOperation.c"
			} else {
#line 163 "../src/Backend/MoveOperation.vala"
				_data_->_tmp11_ = _data_->url;
#line 163 "../src/Backend/MoveOperation.vala"
				_data_->_tmp12_ = _data_->_tmp11_->user;
#line 163 "../src/Backend/MoveOperation.vala"
				_data_->_tmp8_ = g_strcmp0 (_data_->_tmp12_, "") == 0;
#line 1501 "MoveOperation.c"
			}
#line 163 "../src/Backend/MoveOperation.vala"
			if (_data_->_tmp8_) {
#line 164 "../src/Backend/MoveOperation.vala"
				_data_->_tmp13_ = _data_->url;
#line 164 "../src/Backend/MoveOperation.vala"
				_data_->_tmp14_ = _data_->_tmp13_->host;
#line 164 "../src/Backend/MoveOperation.vala"
				_data_->_tmp15_ = g_strdup (_data_->_tmp14_);
#line 164 "../src/Backend/MoveOperation.vala"
				_g_free0 (_data_->uid);
#line 164 "../src/Backend/MoveOperation.vala"
				_data_->uid = _data_->_tmp15_;
#line 1515 "MoveOperation.c"
			} else {
#line 166 "../src/Backend/MoveOperation.vala"
				_data_->_tmp16_ = _data_->url;
#line 166 "../src/Backend/MoveOperation.vala"
				_data_->_tmp17_ = _data_->_tmp16_->user;
#line 166 "../src/Backend/MoveOperation.vala"
				_data_->_tmp18_ = g_strconcat (_data_->_tmp17_, "@", NULL);
#line 166 "../src/Backend/MoveOperation.vala"
				_data_->_tmp19_ = _data_->_tmp18_;
#line 166 "../src/Backend/MoveOperation.vala"
				_data_->_tmp20_ = _data_->url;
#line 166 "../src/Backend/MoveOperation.vala"
				_data_->_tmp21_ = _data_->_tmp20_->host;
#line 166 "../src/Backend/MoveOperation.vala"
				_data_->_tmp22_ = g_strconcat (_data_->_tmp19_, _data_->_tmp21_, NULL);
#line 166 "../src/Backend/MoveOperation.vala"
				_g_free0 (_data_->uid);
#line 166 "../src/Backend/MoveOperation.vala"
				_data_->uid = _data_->_tmp22_;
#line 166 "../src/Backend/MoveOperation.vala"
				_g_free0 (_data_->_tmp19_);
#line 1537 "MoveOperation.c"
			}
#line 169 "../src/Backend/MoveOperation.vala"
			_data_->_tmp23_ = mail_backend_session_get_default ();
#line 169 "../src/Backend/MoveOperation.vala"
			_data_->_tmp24_ = _data_->uid;
#line 169 "../src/Backend/MoveOperation.vala"
			_data_->_tmp25_ = camel_session_ref_service ((CamelSession*) _data_->_tmp23_, _data_->_tmp24_);
#line 169 "../src/Backend/MoveOperation.vala"
			_g_object_unref0 (_data_->service);
#line 169 "../src/Backend/MoveOperation.vala"
			_data_->service = _data_->_tmp25_;
#line 161 "../src/Backend/MoveOperation.vala"
			_g_free0 (_data_->uid);
#line 1551 "MoveOperation.c"
		}
#line 172 "../src/Backend/MoveOperation.vala"
		_data_->_tmp27_ = _data_->url;
#line 172 "../src/Backend/MoveOperation.vala"
		_data_->_tmp28_ = _data_->_tmp27_->path;
#line 172 "../src/Backend/MoveOperation.vala"
		if (_data_->_tmp28_ != NULL) {
#line 172 "../src/Backend/MoveOperation.vala"
			_data_->_tmp29_ = _data_->url;
#line 172 "../src/Backend/MoveOperation.vala"
			_data_->_tmp30_ = _data_->_tmp29_->path;
#line 172 "../src/Backend/MoveOperation.vala"
			_data_->_tmp26_ = g_str_has_prefix (_data_->_tmp30_, "/");
#line 1565 "MoveOperation.c"
		} else {
#line 172 "../src/Backend/MoveOperation.vala"
			_data_->_tmp26_ = FALSE;
#line 1569 "MoveOperation.c"
		}
#line 172 "../src/Backend/MoveOperation.vala"
		if (_data_->_tmp26_) {
#line 173 "../src/Backend/MoveOperation.vala"
			_data_->_tmp31_ = _data_->url;
#line 173 "../src/Backend/MoveOperation.vala"
			_data_->_tmp32_ = _data_->_tmp31_->path;
#line 173 "../src/Backend/MoveOperation.vala"
			_data_->_tmp33_ = string_substring (_data_->_tmp32_, (glong) 1, (glong) -1);
#line 173 "../src/Backend/MoveOperation.vala"
			_data_->_tmp34_ = _data_->_tmp33_;
#line 173 "../src/Backend/MoveOperation.vala"
			_data_->_tmp35_ = camel_url_decode_path (_data_->_tmp34_);
#line 173 "../src/Backend/MoveOperation.vala"
			_g_free0 (_data_->parsed_folder_name);
#line 173 "../src/Backend/MoveOperation.vala"
			_data_->parsed_folder_name = _data_->_tmp35_;
#line 173 "../src/Backend/MoveOperation.vala"
			_g_free0 (_data_->_tmp34_);
#line 1589 "MoveOperation.c"
		}
	}
#line 177 "../src/Backend/MoveOperation.vala"
	_data_->_tmp38_ = _data_->service;
#line 177 "../src/Backend/MoveOperation.vala"
	if (_data_->_tmp38_ != NULL) {
#line 177 "../src/Backend/MoveOperation.vala"
		_data_->_tmp39_ = _data_->service;
#line 177 "../src/Backend/MoveOperation.vala"
		_data_->_tmp37_ = G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp39_, camel_store_get_type ());
#line 1600 "MoveOperation.c"
	} else {
#line 177 "../src/Backend/MoveOperation.vala"
		_data_->_tmp37_ = FALSE;
#line 1604 "MoveOperation.c"
	}
#line 177 "../src/Backend/MoveOperation.vala"
	if (_data_->_tmp37_) {
#line 177 "../src/Backend/MoveOperation.vala"
		_data_->_tmp40_ = _data_->parsed_folder_name;
#line 177 "../src/Backend/MoveOperation.vala"
		_data_->_tmp36_ = _data_->_tmp40_ != NULL;
#line 1612 "MoveOperation.c"
	} else {
#line 177 "../src/Backend/MoveOperation.vala"
		_data_->_tmp36_ = FALSE;
#line 1616 "MoveOperation.c"
	}
#line 177 "../src/Backend/MoveOperation.vala"
	if (_data_->_tmp36_) {
#line 178 "../src/Backend/MoveOperation.vala"
		_data_->_tmp42_ = _data_->service;
#line 178 "../src/Backend/MoveOperation.vala"
		_data_->_tmp43_ = _data_->parsed_folder_name;
#line 178 "../src/Backend/MoveOperation.vala"
		_data_->_state_ = 1;
#line 178 "../src/Backend/MoveOperation.vala"
		camel_store_get_folder (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp42_, camel_store_get_type (), CamelStore), _data_->_tmp43_, CAMEL_STORE_FOLDER_NONE, G_PRIORITY_DEFAULT, NULL, mail_move_operation_set_dst_folder_for_uri_ready, _data_);
#line 178 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 1630 "MoveOperation.c"
		_state_1:
#line 178 "../src/Backend/MoveOperation.vala"
		_data_->_tmp44_ = camel_store_get_folder_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp42_, camel_store_get_type (), CamelStore), _data_->_res_, &_data_->_inner_error0_);
#line 178 "../src/Backend/MoveOperation.vala"
		_data_->_tmp41_ = _data_->_tmp44_;
#line 178 "../src/Backend/MoveOperation.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 178 "../src/Backend/MoveOperation.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 178 "../src/Backend/MoveOperation.vala"
			_g_free0 (_data_->parsed_folder_name);
#line 178 "../src/Backend/MoveOperation.vala"
			_g_object_unref0 (_data_->service);
#line 178 "../src/Backend/MoveOperation.vala"
			__vala_CamelURL_free0 (_data_->_tmp0_);
#line 178 "../src/Backend/MoveOperation.vala"
			__vala_CamelURL_free0 (_data_->url);
#line 178 "../src/Backend/MoveOperation.vala"
			g_object_unref (_data_->_async_result);
#line 178 "../src/Backend/MoveOperation.vala"
			return FALSE;
#line 1652 "MoveOperation.c"
		}
#line 178 "../src/Backend/MoveOperation.vala"
		_data_->_tmp45_ = _data_->_tmp41_;
#line 178 "../src/Backend/MoveOperation.vala"
		_data_->_tmp41_ = NULL;
#line 178 "../src/Backend/MoveOperation.vala"
		_g_object_unref0 (_data_->self->priv->dst_folder);
#line 178 "../src/Backend/MoveOperation.vala"
		_data_->self->priv->dst_folder = _data_->_tmp45_;
#line 179 "../src/Backend/MoveOperation.vala"
		_data_->result = TRUE;
#line 179 "../src/Backend/MoveOperation.vala"
		_g_object_unref0 (_data_->_tmp41_);
#line 179 "../src/Backend/MoveOperation.vala"
		_g_free0 (_data_->parsed_folder_name);
#line 179 "../src/Backend/MoveOperation.vala"
		_g_object_unref0 (_data_->service);
#line 179 "../src/Backend/MoveOperation.vala"
		__vala_CamelURL_free0 (_data_->_tmp0_);
#line 179 "../src/Backend/MoveOperation.vala"
		__vala_CamelURL_free0 (_data_->url);
#line 179 "../src/Backend/MoveOperation.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 179 "../src/Backend/MoveOperation.vala"
		if (_data_->_state_ != 0) {
#line 179 "../src/Backend/MoveOperation.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 179 "../src/Backend/MoveOperation.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1682 "MoveOperation.c"
			}
		}
#line 179 "../src/Backend/MoveOperation.vala"
		g_object_unref (_data_->_async_result);
#line 179 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 1689 "MoveOperation.c"
	}
#line 182 "../src/Backend/MoveOperation.vala"
	_data_->result = FALSE;
#line 182 "../src/Backend/MoveOperation.vala"
	_g_free0 (_data_->parsed_folder_name);
#line 182 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->service);
#line 182 "../src/Backend/MoveOperation.vala"
	__vala_CamelURL_free0 (_data_->_tmp0_);
#line 182 "../src/Backend/MoveOperation.vala"
	__vala_CamelURL_free0 (_data_->url);
#line 182 "../src/Backend/MoveOperation.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 182 "../src/Backend/MoveOperation.vala"
	if (_data_->_state_ != 0) {
#line 182 "../src/Backend/MoveOperation.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 182 "../src/Backend/MoveOperation.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1709 "MoveOperation.c"
		}
	}
#line 182 "../src/Backend/MoveOperation.vala"
	g_object_unref (_data_->_async_result);
#line 182 "../src/Backend/MoveOperation.vala"
	return FALSE;
#line 1716 "MoveOperation.c"
}

static gchar*
mail_move_operation_get_archive_folder_uri (MailMoveOperation* self)
{
	CamelStore* store = NULL;
	CamelFolder* _tmp0_;
	CamelStore* _tmp1_;
	CamelFolder* _tmp2_;
	CamelStore* _tmp26_;
	gchar* result;
#line 185 "../src/Backend/MoveOperation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 186 "../src/Backend/MoveOperation.vala"
	_tmp0_ = self->priv->src_folder;
#line 186 "../src/Backend/MoveOperation.vala"
	_tmp1_ = camel_folder_get_parent_store (_tmp0_);
#line 186 "../src/Backend/MoveOperation.vala"
	store = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, camel_store_get_type (), CamelStore);
#line 188 "../src/Backend/MoveOperation.vala"
	_tmp2_ = self->priv->src_folder;
#line 188 "../src/Backend/MoveOperation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, camel_vee_folder_get_type ())) {
#line 1740 "MoveOperation.c"
		CamelVeeFolder* vee_folder = NULL;
		CamelFolder* _tmp3_;
		CamelVeeFolder* _tmp4_;
		CamelFolder* orig_folder = NULL;
#line 189 "../src/Backend/MoveOperation.vala"
		_tmp3_ = self->priv->src_folder;
#line 189 "../src/Backend/MoveOperation.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, camel_vee_folder_get_type (), CamelVeeFolder));
#line 189 "../src/Backend/MoveOperation.vala"
		vee_folder = _tmp4_;
#line 191 "../src/Backend/MoveOperation.vala"
		store = NULL;
#line 192 "../src/Backend/MoveOperation.vala"
		orig_folder = NULL;
#line 1755 "MoveOperation.c"
		{
			GeeArrayList* _message_list = NULL;
			GeeArrayList* _tmp5_;
			gint _message_size = 0;
			GeeArrayList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _message_index = 0;
#line 194 "../src/Backend/MoveOperation.vala"
			_tmp5_ = self->priv->moved_messages;
#line 194 "../src/Backend/MoveOperation.vala"
			_message_list = _tmp5_;
#line 194 "../src/Backend/MoveOperation.vala"
			_tmp6_ = _message_list;
#line 194 "../src/Backend/MoveOperation.vala"
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 194 "../src/Backend/MoveOperation.vala"
			_tmp8_ = _tmp7_;
#line 194 "../src/Backend/MoveOperation.vala"
			_message_size = _tmp8_;
#line 194 "../src/Backend/MoveOperation.vala"
			_message_index = -1;
#line 194 "../src/Backend/MoveOperation.vala"
			while (TRUE) {
#line 1780 "MoveOperation.c"
				gint _tmp9_;
				gint _tmp10_;
				CamelMessageInfo* message = NULL;
				GeeArrayList* _tmp11_;
				gpointer _tmp12_;
				CamelVeeFolder* _tmp13_;
				CamelMessageInfo* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
				CamelFolder* _tmp17_;
				CamelFolder* _tmp18_;
#line 194 "../src/Backend/MoveOperation.vala"
				_message_index = _message_index + 1;
#line 194 "../src/Backend/MoveOperation.vala"
				_tmp9_ = _message_index;
#line 194 "../src/Backend/MoveOperation.vala"
				_tmp10_ = _message_size;
#line 194 "../src/Backend/MoveOperation.vala"
				if (!(_tmp9_ < _tmp10_)) {
#line 194 "../src/Backend/MoveOperation.vala"
					break;
#line 1802 "MoveOperation.c"
				}
#line 194 "../src/Backend/MoveOperation.vala"
				_tmp11_ = _message_list;
#line 194 "../src/Backend/MoveOperation.vala"
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _message_index);
#line 194 "../src/Backend/MoveOperation.vala"
				message = (CamelMessageInfo*) _tmp12_;
#line 195 "../src/Backend/MoveOperation.vala"
				_tmp13_ = vee_folder;
#line 195 "../src/Backend/MoveOperation.vala"
				_tmp14_ = message;
#line 195 "../src/Backend/MoveOperation.vala"
				_tmp15_ = camel_message_info_get_uid (_tmp14_);
#line 195 "../src/Backend/MoveOperation.vala"
				_tmp16_ = _tmp15_;
#line 195 "../src/Backend/MoveOperation.vala"
				_tmp17_ = camel_vee_folder_get_vee_uid_folder (_tmp13_, _tmp16_);
#line 195 "../src/Backend/MoveOperation.vala"
				orig_folder = _tmp17_;
#line 196 "../src/Backend/MoveOperation.vala"
				_tmp18_ = orig_folder;
#line 196 "../src/Backend/MoveOperation.vala"
				if (_tmp18_ != NULL) {
#line 1826 "MoveOperation.c"
					gboolean _tmp19_ = FALSE;
					CamelStore* _tmp20_;
					CamelFolder* _tmp24_;
					CamelStore* _tmp25_;
#line 197 "../src/Backend/MoveOperation.vala"
					_tmp20_ = store;
#line 197 "../src/Backend/MoveOperation.vala"
					if (_tmp20_ != NULL) {
#line 1835 "MoveOperation.c"
						CamelFolder* _tmp21_;
						CamelStore* _tmp22_;
						CamelStore* _tmp23_;
#line 197 "../src/Backend/MoveOperation.vala"
						_tmp21_ = orig_folder;
#line 197 "../src/Backend/MoveOperation.vala"
						_tmp22_ = camel_folder_get_parent_store (_tmp21_);
#line 197 "../src/Backend/MoveOperation.vala"
						_tmp23_ = store;
#line 197 "../src/Backend/MoveOperation.vala"
						_tmp19_ = _tmp22_ != _tmp23_;
#line 1847 "MoveOperation.c"
					} else {
#line 197 "../src/Backend/MoveOperation.vala"
						_tmp19_ = FALSE;
#line 1851 "MoveOperation.c"
					}
#line 197 "../src/Backend/MoveOperation.vala"
					if (_tmp19_) {
#line 200 "../src/Backend/MoveOperation.vala"
						store = NULL;
#line 201 "../src/Backend/MoveOperation.vala"
						break;
#line 1859 "MoveOperation.c"
					}
#line 204 "../src/Backend/MoveOperation.vala"
					_tmp24_ = orig_folder;
#line 204 "../src/Backend/MoveOperation.vala"
					_tmp25_ = camel_folder_get_parent_store (_tmp24_);
#line 204 "../src/Backend/MoveOperation.vala"
					store = G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, camel_store_get_type (), CamelStore);
#line 1867 "MoveOperation.c"
				}
			}
		}
#line 188 "../src/Backend/MoveOperation.vala"
		_g_object_unref0 (vee_folder);
#line 1873 "MoveOperation.c"
	}
#line 209 "../src/Backend/MoveOperation.vala"
	_tmp26_ = store;
#line 209 "../src/Backend/MoveOperation.vala"
	if (_tmp26_ != NULL) {
#line 1879 "MoveOperation.c"
		MailBackendSession* _tmp27_;
		CamelStore* _tmp28_;
		gchar* _tmp29_;
#line 210 "../src/Backend/MoveOperation.vala"
		_tmp27_ = mail_backend_session_get_default ();
#line 210 "../src/Backend/MoveOperation.vala"
		_tmp28_ = store;
#line 210 "../src/Backend/MoveOperation.vala"
		_tmp29_ = mail_backend_session_get_archive_folder_uri_for_service (_tmp27_, (CamelService*) _tmp28_);
#line 210 "../src/Backend/MoveOperation.vala"
		result = _tmp29_;
#line 210 "../src/Backend/MoveOperation.vala"
		return result;
#line 1893 "MoveOperation.c"
	}
#line 213 "../src/Backend/MoveOperation.vala"
	result = NULL;
#line 213 "../src/Backend/MoveOperation.vala"
	return result;
#line 1899 "MoveOperation.c"
}

static void
mail_move_operation_collect_thread_messages_data_free (gpointer _data)
{
	MailMoveOperationCollectThreadMessagesData* _data_;
	_data_ = _data;
#line 25 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/Backend/MoveOperation.vala"
	g_slice_free (MailMoveOperationCollectThreadMessagesData, _data_);
#line 1911 "MoveOperation.c"
}

static void
mail_move_operation_collect_thread_messages (MailMoveOperation* self,
                                             CamelFolderThreadNode* thread,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	MailMoveOperationCollectThreadMessagesData* _data_;
	MailMoveOperation* _tmp0_;
#line 25 "../src/Backend/MoveOperation.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Backend/MoveOperation.vala"
	g_return_if_fail (thread != NULL);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_ = g_slice_new0 (MailMoveOperationCollectThreadMessagesData);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/Backend/MoveOperation.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_move_operation_collect_thread_messages_data_free);
#line 25 "../src/Backend/MoveOperation.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_->self = _tmp0_;
#line 25 "../src/Backend/MoveOperation.vala"
	_data_->thread = thread;
#line 25 "../src/Backend/MoveOperation.vala"
	mail_move_operation_collect_thread_messages_co (_data_);
#line 1940 "MoveOperation.c"
}

static void
mail_move_operation_collect_thread_messages_finish (MailMoveOperation* self,
                                                    GAsyncResult* _res_)
{
	MailMoveOperationCollectThreadMessagesData* _data_;
#line 25 "../src/Backend/MoveOperation.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1950 "MoveOperation.c"
}

static void
mail_move_operation_collect_thread_messages_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	MailMoveOperationCollectThreadMessagesData* _data_;
#line 220 "../src/Backend/MoveOperation.vala"
	_data_ = _user_data_;
#line 220 "../src/Backend/MoveOperation.vala"
	_data_->_source_object_ = source_object;
#line 220 "../src/Backend/MoveOperation.vala"
	_data_->_res_ = _res_;
#line 220 "../src/Backend/MoveOperation.vala"
	mail_move_operation_collect_thread_messages_co (_data_);
#line 1967 "MoveOperation.c"
}

static gboolean
mail_move_operation_collect_thread_messages_co (MailMoveOperationCollectThreadMessagesData* _data_)
{
#line 216 "../src/Backend/MoveOperation.vala"
	switch (_data_->_state_) {
#line 216 "../src/Backend/MoveOperation.vala"
		case 0:
#line 1977 "MoveOperation.c"
		goto _state_0;
#line 216 "../src/Backend/MoveOperation.vala"
		case 1:
#line 1981 "MoveOperation.c"
		goto _state_1;
		default:
#line 216 "../src/Backend/MoveOperation.vala"
		g_assert_not_reached ();
#line 1986 "MoveOperation.c"
	}
	_state_0:
#line 217 "../src/Backend/MoveOperation.vala"
	_data_->_tmp0_ = _data_->self->priv->moved_messages;
#line 217 "../src/Backend/MoveOperation.vala"
	_data_->_tmp1_ = _data_->thread->message;
#line 217 "../src/Backend/MoveOperation.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp0_, _data_->_tmp1_);
#line 218 "../src/Backend/MoveOperation.vala"
	_data_->_tmp2_ = _data_->thread->child;
#line 218 "../src/Backend/MoveOperation.vala"
	_data_->child = (CamelFolderThreadNode*) _data_->_tmp2_;
#line 219 "../src/Backend/MoveOperation.vala"
	while (TRUE) {
#line 219 "../src/Backend/MoveOperation.vala"
		_data_->_tmp3_ = _data_->child;
#line 219 "../src/Backend/MoveOperation.vala"
		if (!(_data_->_tmp3_ != NULL)) {
#line 219 "../src/Backend/MoveOperation.vala"
			break;
#line 2007 "MoveOperation.c"
		}
#line 220 "../src/Backend/MoveOperation.vala"
		_data_->_tmp4_ = _data_->child;
#line 220 "../src/Backend/MoveOperation.vala"
		_data_->_state_ = 1;
#line 220 "../src/Backend/MoveOperation.vala"
		mail_move_operation_collect_thread_messages (_data_->self, _data_->_tmp4_, mail_move_operation_collect_thread_messages_ready, _data_);
#line 220 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 2017 "MoveOperation.c"
		_state_1:
#line 220 "../src/Backend/MoveOperation.vala"
		mail_move_operation_collect_thread_messages_finish (_data_->self, _data_->_res_);
#line 221 "../src/Backend/MoveOperation.vala"
		_data_->_tmp5_ = _data_->child;
#line 221 "../src/Backend/MoveOperation.vala"
		_data_->_tmp6_ = _data_->_tmp5_->next;
#line 221 "../src/Backend/MoveOperation.vala"
		_data_->child = (CamelFolderThreadNode*) _data_->_tmp6_;
#line 2027 "MoveOperation.c"
	}
#line 216 "../src/Backend/MoveOperation.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 216 "../src/Backend/MoveOperation.vala"
	if (_data_->_state_ != 0) {
#line 216 "../src/Backend/MoveOperation.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 216 "../src/Backend/MoveOperation.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2037 "MoveOperation.c"
		}
	}
#line 216 "../src/Backend/MoveOperation.vala"
	g_object_unref (_data_->_async_result);
#line 216 "../src/Backend/MoveOperation.vala"
	return FALSE;
#line 2044 "MoveOperation.c"
}

static void
mail_move_operation_finish_data_free (gpointer _data)
{
	MailMoveOperationFinishData* _data_;
	_data_ = _data;
#line 25 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/Backend/MoveOperation.vala"
	g_slice_free (MailMoveOperationFinishData, _data_);
#line 2056 "MoveOperation.c"
}

static void
mail_move_operation_finish (MailMoveOperation* self,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	MailMoveOperationFinishData* _data_;
	MailMoveOperation* _tmp0_;
#line 25 "../src/Backend/MoveOperation.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_ = g_slice_new0 (MailMoveOperationFinishData);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/Backend/MoveOperation.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_move_operation_finish_data_free);
#line 25 "../src/Backend/MoveOperation.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/Backend/MoveOperation.vala"
	_data_->self = _tmp0_;
#line 25 "../src/Backend/MoveOperation.vala"
	mail_move_operation_finish_co (_data_);
#line 2080 "MoveOperation.c"
}

static void
mail_move_operation_finish_finish (MailMoveOperation* self,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	MailMoveOperationFinishData* _data_;
#line 25 "../src/Backend/MoveOperation.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 25 "../src/Backend/MoveOperation.vala"
	if (NULL == _data_) {
#line 25 "../src/Backend/MoveOperation.vala"
		return;
#line 2095 "MoveOperation.c"
	}
}

static void
_g_free0_ (gpointer var)
{
#line 238 "../src/Backend/MoveOperation.vala"
	var = (g_free (var), NULL);
#line 2104 "MoveOperation.c"
}

static void
mail_move_operation_finish_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	MailMoveOperationFinishData* _data_;
#line 246 "../src/Backend/MoveOperation.vala"
	_data_ = _user_data_;
#line 246 "../src/Backend/MoveOperation.vala"
	_data_->_source_object_ = source_object;
#line 246 "../src/Backend/MoveOperation.vala"
	_data_->_res_ = _res_;
#line 246 "../src/Backend/MoveOperation.vala"
	mail_move_operation_finish_co (_data_);
#line 2121 "MoveOperation.c"
}

static gboolean
mail_move_operation_finish_co (MailMoveOperationFinishData* _data_)
{
#line 225 "../src/Backend/MoveOperation.vala"
	switch (_data_->_state_) {
#line 225 "../src/Backend/MoveOperation.vala"
		case 0:
#line 2131 "MoveOperation.c"
		goto _state_0;
#line 225 "../src/Backend/MoveOperation.vala"
		case 1:
#line 2135 "MoveOperation.c"
		goto _state_1;
		default:
#line 225 "../src/Backend/MoveOperation.vala"
		g_assert_not_reached ();
#line 2140 "MoveOperation.c"
	}
	_state_0:
#line 226 "../src/Backend/MoveOperation.vala"
	_data_->_tmp0_ = mail_move_operation_last_move_operation;
#line 226 "../src/Backend/MoveOperation.vala"
	if (_data_->self == _data_->_tmp0_) {
#line 227 "../src/Backend/MoveOperation.vala"
		_g_object_unref0 (mail_move_operation_last_move_operation);
#line 227 "../src/Backend/MoveOperation.vala"
		mail_move_operation_last_move_operation = NULL;
#line 2151 "MoveOperation.c"
	}
#line 230 "../src/Backend/MoveOperation.vala"
	if (_data_->self->priv->move_type == MAIL_MOVE_OPERATION_MOVE_TYPE_VTRASH) {
#line 2155 "MoveOperation.c"
		{
#line 231 "../src/Backend/MoveOperation.vala"
			_data_->_tmp1_ = _data_->self->priv->moved_messages;
#line 231 "../src/Backend/MoveOperation.vala"
			_data_->_message_list = _data_->_tmp1_;
#line 231 "../src/Backend/MoveOperation.vala"
			_data_->_tmp2_ = _data_->_message_list;
#line 231 "../src/Backend/MoveOperation.vala"
			_data_->_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp2_);
#line 231 "../src/Backend/MoveOperation.vala"
			_data_->_tmp4_ = _data_->_tmp3_;
#line 231 "../src/Backend/MoveOperation.vala"
			_data_->_message_size = _data_->_tmp4_;
#line 231 "../src/Backend/MoveOperation.vala"
			_data_->_message_index = -1;
#line 231 "../src/Backend/MoveOperation.vala"
			while (TRUE) {
#line 231 "../src/Backend/MoveOperation.vala"
				_data_->_message_index = _data_->_message_index + 1;
#line 231 "../src/Backend/MoveOperation.vala"
				_data_->_tmp5_ = _data_->_message_index;
#line 231 "../src/Backend/MoveOperation.vala"
				_data_->_tmp6_ = _data_->_message_size;
#line 231 "../src/Backend/MoveOperation.vala"
				if (!(_data_->_tmp5_ < _data_->_tmp6_)) {
#line 231 "../src/Backend/MoveOperation.vala"
					break;
#line 2183 "MoveOperation.c"
				}
#line 231 "../src/Backend/MoveOperation.vala"
				_data_->_tmp7_ = _data_->_message_list;
#line 231 "../src/Backend/MoveOperation.vala"
				_data_->_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp7_, _data_->_message_index);
#line 231 "../src/Backend/MoveOperation.vala"
				_data_->message = (CamelMessageInfo*) _data_->_tmp8_;
#line 232 "../src/Backend/MoveOperation.vala"
				_data_->_tmp9_ = _data_->message;
#line 232 "../src/Backend/MoveOperation.vala"
				camel_message_info_set_flags (_data_->_tmp9_, (guint32) CAMEL_MESSAGE_DELETED, (guint32) (~0));
#line 2195 "MoveOperation.c"
			}
		}
#line 234 "../src/Backend/MoveOperation.vala"
		_data_->_tmp10_ = _data_->self->priv->moved_messages;
#line 234 "../src/Backend/MoveOperation.vala"
		_data_->_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp10_);
#line 234 "../src/Backend/MoveOperation.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 234 "../src/Backend/MoveOperation.vala"
		mail_move_operation_update_queue (-_data_->_tmp12_);
#line 235 "../src/Backend/MoveOperation.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 235 "../src/Backend/MoveOperation.vala"
		if (_data_->_state_ != 0) {
#line 235 "../src/Backend/MoveOperation.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 235 "../src/Backend/MoveOperation.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2214 "MoveOperation.c"
			}
		}
#line 235 "../src/Backend/MoveOperation.vala"
		g_object_unref (_data_->_async_result);
#line 235 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 2221 "MoveOperation.c"
	}
#line 238 "../src/Backend/MoveOperation.vala"
	_data_->_tmp13_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
#line 238 "../src/Backend/MoveOperation.vala"
	_data_->message_uids = _data_->_tmp13_;
#line 2227 "MoveOperation.c"
	{
#line 239 "../src/Backend/MoveOperation.vala"
		_data_->_tmp14_ = _data_->self->priv->moved_messages;
#line 239 "../src/Backend/MoveOperation.vala"
		_data_->_vala1__message_list = _data_->_tmp14_;
#line 239 "../src/Backend/MoveOperation.vala"
		_data_->_tmp15_ = _data_->_vala1__message_list;
#line 239 "../src/Backend/MoveOperation.vala"
		_data_->_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp15_);
#line 239 "../src/Backend/MoveOperation.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 239 "../src/Backend/MoveOperation.vala"
		_data_->_vala1__message_size = _data_->_tmp17_;
#line 239 "../src/Backend/MoveOperation.vala"
		_data_->_vala1__message_index = -1;
#line 239 "../src/Backend/MoveOperation.vala"
		while (TRUE) {
#line 239 "../src/Backend/MoveOperation.vala"
			_data_->_vala1__message_index = _data_->_vala1__message_index + 1;
#line 239 "../src/Backend/MoveOperation.vala"
			_data_->_tmp18_ = _data_->_vala1__message_index;
#line 239 "../src/Backend/MoveOperation.vala"
			_data_->_tmp19_ = _data_->_vala1__message_size;
#line 239 "../src/Backend/MoveOperation.vala"
			if (!(_data_->_tmp18_ < _data_->_tmp19_)) {
#line 239 "../src/Backend/MoveOperation.vala"
				break;
#line 2255 "MoveOperation.c"
			}
#line 239 "../src/Backend/MoveOperation.vala"
			_data_->_tmp20_ = _data_->_vala1__message_list;
#line 239 "../src/Backend/MoveOperation.vala"
			_data_->_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp20_, _data_->_vala1__message_index);
#line 239 "../src/Backend/MoveOperation.vala"
			_data_->_vala1_message = (CamelMessageInfo*) _data_->_tmp21_;
#line 240 "../src/Backend/MoveOperation.vala"
			_data_->_tmp22_ = _data_->message_uids;
#line 240 "../src/Backend/MoveOperation.vala"
			_data_->_tmp23_ = _data_->_vala1_message;
#line 240 "../src/Backend/MoveOperation.vala"
			_data_->_tmp24_ = camel_message_info_get_uid (_data_->_tmp23_);
#line 240 "../src/Backend/MoveOperation.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 240 "../src/Backend/MoveOperation.vala"
			_data_->_tmp26_ = g_strdup (_data_->_tmp25_);
#line 240 "../src/Backend/MoveOperation.vala"
			g_ptr_array_add (_data_->_tmp22_, _data_->_tmp26_);
#line 2275 "MoveOperation.c"
		}
	}
#line 243 "../src/Backend/MoveOperation.vala"
	_data_->_tmp27_ = _data_->self->priv->src_folder;
#line 243 "../src/Backend/MoveOperation.vala"
	camel_folder_freeze (_data_->_tmp27_);
#line 244 "../src/Backend/MoveOperation.vala"
	_data_->_tmp28_ = _data_->self->priv->dst_folder;
#line 244 "../src/Backend/MoveOperation.vala"
	camel_folder_freeze (_data_->_tmp28_);
#line 246 "../src/Backend/MoveOperation.vala"
	_data_->_tmp30_ = _data_->self->priv->src_folder;
#line 246 "../src/Backend/MoveOperation.vala"
	_data_->_tmp31_ = _data_->message_uids;
#line 246 "../src/Backend/MoveOperation.vala"
	_data_->_tmp32_ = _data_->self->priv->dst_folder;
#line 246 "../src/Backend/MoveOperation.vala"
	_data_->_state_ = 1;
#line 246 "../src/Backend/MoveOperation.vala"
	camel_folder_transfer_messages_to (_data_->_tmp30_, _data_->_tmp31_, _data_->_tmp32_, TRUE, G_PRIORITY_DEFAULT, NULL, mail_move_operation_finish_ready, _data_);
#line 246 "../src/Backend/MoveOperation.vala"
	return FALSE;
#line 2298 "MoveOperation.c"
	_state_1:
#line 246 "../src/Backend/MoveOperation.vala"
	_data_->_tmp29_ = camel_folder_transfer_messages_to_finish (_data_->_tmp30_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 246 "../src/Backend/MoveOperation.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 246 "../src/Backend/MoveOperation.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 246 "../src/Backend/MoveOperation.vala"
		_g_ptr_array_unref0 (_data_->message_uids);
#line 246 "../src/Backend/MoveOperation.vala"
		g_object_unref (_data_->_async_result);
#line 246 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 2312 "MoveOperation.c"
	}
#line 246 "../src/Backend/MoveOperation.vala"
	if (!_data_->_tmp29_) {
#line 247 "../src/Backend/MoveOperation.vala"
		_data_->_tmp33_ = g_error_new_literal (MOVE_ERROR, MOVE_ERROR_FAILED, "Failed to move messages");
#line 247 "../src/Backend/MoveOperation.vala"
		_data_->_inner_error0_ = _data_->_tmp33_;
#line 247 "../src/Backend/MoveOperation.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 247 "../src/Backend/MoveOperation.vala"
		_g_ptr_array_unref0 (_data_->message_uids);
#line 247 "../src/Backend/MoveOperation.vala"
		g_object_unref (_data_->_async_result);
#line 247 "../src/Backend/MoveOperation.vala"
		return FALSE;
#line 2328 "MoveOperation.c"
	}
#line 250 "../src/Backend/MoveOperation.vala"
	_data_->_tmp34_ = _data_->self->priv->src_folder;
#line 250 "../src/Backend/MoveOperation.vala"
	camel_folder_thaw (_data_->_tmp34_);
#line 251 "../src/Backend/MoveOperation.vala"
	_data_->_tmp35_ = _data_->self->priv->dst_folder;
#line 251 "../src/Backend/MoveOperation.vala"
	camel_folder_thaw (_data_->_tmp35_);
#line 253 "../src/Backend/MoveOperation.vala"
	_data_->_tmp36_ = _data_->self->priv->moved_messages;
#line 253 "../src/Backend/MoveOperation.vala"
	_data_->_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp36_);
#line 253 "../src/Backend/MoveOperation.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 253 "../src/Backend/MoveOperation.vala"
	mail_move_operation_update_queue (-_data_->_tmp38_);
#line 225 "../src/Backend/MoveOperation.vala"
	_g_ptr_array_unref0 (_data_->message_uids);
#line 225 "../src/Backend/MoveOperation.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 225 "../src/Backend/MoveOperation.vala"
	if (_data_->_state_ != 0) {
#line 225 "../src/Backend/MoveOperation.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 225 "../src/Backend/MoveOperation.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2356 "MoveOperation.c"
		}
	}
#line 225 "../src/Backend/MoveOperation.vala"
	g_object_unref (_data_->_async_result);
#line 225 "../src/Backend/MoveOperation.vala"
	return FALSE;
#line 2363 "MoveOperation.c"
}

static void
mail_move_operation_class_init (MailMoveOperationClass * klass,
                                gpointer klass_data)
{
#line 25 "../src/Backend/MoveOperation.vala"
	mail_move_operation_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/Backend/MoveOperation.vala"
	g_type_class_adjust_private_offset (klass, &MailMoveOperation_private_offset);
#line 25 "../src/Backend/MoveOperation.vala"
	G_OBJECT_CLASS (klass)->finalize = mail_move_operation_finalize;
#line 25 "../src/Backend/MoveOperation.vala"
	mail_move_operation_signals[MAIL_MOVE_OPERATION_UNDONE_SIGNAL] = g_signal_new ("undone", MAIL_TYPE_MOVE_OPERATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2378 "MoveOperation.c"
}

static void
mail_move_operation_instance_init (MailMoveOperation * self,
                                   gpointer klass)
{
#line 25 "../src/Backend/MoveOperation.vala"
	self->priv = mail_move_operation_get_instance_private (self);
#line 2387 "MoveOperation.c"
}

static void
mail_move_operation_finalize (GObject * obj)
{
	MailMoveOperation * self;
#line 25 "../src/Backend/MoveOperation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_MOVE_OPERATION, MailMoveOperation);
#line 72 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (self->priv->src_folder);
#line 73 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (self->priv->dst_folder);
#line 75 "../src/Backend/MoveOperation.vala"
	_g_object_unref0 (self->priv->moved_messages);
#line 25 "../src/Backend/MoveOperation.vala"
	G_OBJECT_CLASS (mail_move_operation_parent_class)->finalize (obj);
#line 2404 "MoveOperation.c"
}

static GType
mail_move_operation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailMoveOperationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_move_operation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailMoveOperation), 0, (GInstanceInitFunc) mail_move_operation_instance_init, NULL };
	GType mail_move_operation_type_id;
	mail_move_operation_type_id = g_type_register_static (G_TYPE_OBJECT, "MailMoveOperation", &g_define_type_info, 0);
	MailMoveOperation_private_offset = g_type_add_instance_private (mail_move_operation_type_id, sizeof (MailMoveOperationPrivate));
	return mail_move_operation_type_id;
}

GType
mail_move_operation_get_type (void)
{
	static volatile gsize mail_move_operation_type_id__once = 0;
	if (g_once_init_enter (&mail_move_operation_type_id__once)) {
		GType mail_move_operation_type_id;
		mail_move_operation_type_id = mail_move_operation_get_type_once ();
		g_once_init_leave (&mail_move_operation_type_id__once, mail_move_operation_type_id);
	}
	return mail_move_operation_type_id__once;
}

