/* ConversationItemModel.c generated by valac 0.56.14, the Vala compiler
 * generated from ConversationItemModel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: David Hewitt <davidmhewitt@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <camel/camel.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MAIL_TYPE_CONVERSATION_ITEM_MODEL (mail_conversation_item_model_get_type ())
#define MAIL_CONVERSATION_ITEM_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_CONVERSATION_ITEM_MODEL, MailConversationItemModel))
#define MAIL_CONVERSATION_ITEM_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_CONVERSATION_ITEM_MODEL, MailConversationItemModelClass))
#define MAIL_IS_CONVERSATION_ITEM_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_CONVERSATION_ITEM_MODEL))
#define MAIL_IS_CONVERSATION_ITEM_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_CONVERSATION_ITEM_MODEL))
#define MAIL_CONVERSATION_ITEM_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_CONVERSATION_ITEM_MODEL, MailConversationItemModelClass))

typedef struct _MailConversationItemModel MailConversationItemModel;
typedef struct _MailConversationItemModelClass MailConversationItemModelClass;
typedef struct _MailConversationItemModelPrivate MailConversationItemModelPrivate;
enum  {
	MAIL_CONVERSATION_ITEM_MODEL_0_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_SERVICE_UID_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_NODE_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_THREAD_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_TIMESTAMP_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_FOLDER_INFO_FLAGS_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_HIDDEN_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_FORMATTED_DATE_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_NUM_MESSAGES_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_FROM_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_TO_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_SUBJECT_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_FLAGGED_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_FORWARDED_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_REPLIED_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_REPLIED_ALL_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_UNREAD_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_DELETED_PROPERTY,
	MAIL_CONVERSATION_ITEM_MODEL_NUM_PROPERTIES
};
static GParamSpec* mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _camel_folder_thread_messages_unref0(var) ((var == NULL) ? NULL : (var = (camel_folder_thread_messages_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MailConversationItemModel {
	GObject parent_instance;
	MailConversationItemModelPrivate * priv;
};

struct _MailConversationItemModelClass {
	GObjectClass parent_class;
};

struct _MailConversationItemModelPrivate {
	gchar* _service_uid;
	CamelFolderThreadNode* _node;
	CamelFolderThread* _thread;
	gint64 _timestamp;
	CamelFolderInfoFlags _folder_info_flags;
	gboolean _hidden;
};

static gint MailConversationItemModel_private_offset;
static gpointer mail_conversation_item_model_parent_class = NULL;

VALA_EXTERN GType mail_conversation_item_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailConversationItemModel, g_object_unref)
VALA_EXTERN MailConversationItemModel* mail_conversation_item_model_new (CamelFolderInfoFlags folder_info_flags,
                                                             CamelFolderThreadNode* node,
                                                             CamelFolderThread* thread,
                                                             const gchar* service_uid);
VALA_EXTERN MailConversationItemModel* mail_conversation_item_model_construct (GType object_type,
                                                                   CamelFolderInfoFlags folder_info_flags,
                                                                   CamelFolderThreadNode* node,
                                                                   CamelFolderThread* thread,
                                                                   const gchar* service_uid);
VALA_EXTERN gboolean mail_conversation_item_model_is_older_than (MailConversationItemModel* self,
                                                     CamelFolderThreadNode* other_node);
static gint64 mail_conversation_item_model_get_newest_timestamp (CamelFolderThreadNode* node,
                                                          gint64 highest);
VALA_EXTERN gint64 mail_conversation_item_model_get_timestamp (MailConversationItemModel* self);
static guint mail_conversation_item_model_count_thread_messages (CamelFolderThreadNode* node);
static gboolean mail_conversation_item_model_has_thread_flag (CamelFolderThreadNode* node,
                                                       CamelMessageFlags flag);
VALA_EXTERN const gchar* mail_conversation_item_model_get_service_uid (MailConversationItemModel* self);
static void mail_conversation_item_model_set_service_uid (MailConversationItemModel* self,
                                                   const gchar* value);
VALA_EXTERN CamelFolderThreadNode* mail_conversation_item_model_get_node (MailConversationItemModel* self);
static void mail_conversation_item_model_set_node (MailConversationItemModel* self,
                                            CamelFolderThreadNode* value);
VALA_EXTERN CamelFolderThread* mail_conversation_item_model_get_thread (MailConversationItemModel* self);
static void mail_conversation_item_model_set_thread (MailConversationItemModel* self,
                                              CamelFolderThread* value);
static void mail_conversation_item_model_set_timestamp (MailConversationItemModel* self,
                                                 gint64 value);
VALA_EXTERN CamelFolderInfoFlags mail_conversation_item_model_get_folder_info_flags (MailConversationItemModel* self);
static void mail_conversation_item_model_set_folder_info_flags (MailConversationItemModel* self,
                                                         CamelFolderInfoFlags value);
VALA_EXTERN gboolean mail_conversation_item_model_get_hidden (MailConversationItemModel* self);
VALA_EXTERN void mail_conversation_item_model_set_hidden (MailConversationItemModel* self,
                                              gboolean value);
VALA_EXTERN gchar* mail_conversation_item_model_get_formatted_date (MailConversationItemModel* self);
VALA_EXTERN guint mail_conversation_item_model_get_num_messages (MailConversationItemModel* self);
VALA_EXTERN gchar* mail_conversation_item_model_get_from (MailConversationItemModel* self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gchar* mail_conversation_item_model_get_to (MailConversationItemModel* self);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN const gchar* mail_conversation_item_model_get_subject (MailConversationItemModel* self);
VALA_EXTERN gboolean mail_conversation_item_model_get_flagged (MailConversationItemModel* self);
VALA_EXTERN gboolean mail_conversation_item_model_get_forwarded (MailConversationItemModel* self);
VALA_EXTERN gboolean mail_conversation_item_model_get_replied (MailConversationItemModel* self);
VALA_EXTERN gboolean mail_conversation_item_model_get_replied_all (MailConversationItemModel* self);
VALA_EXTERN gboolean mail_conversation_item_model_get_unread (MailConversationItemModel* self);
VALA_EXTERN gboolean mail_conversation_item_model_get_deleted (MailConversationItemModel* self);
static GObject * mail_conversation_item_model_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static void mail_conversation_item_model_finalize (GObject * obj);
static GType mail_conversation_item_model_get_type_once (void);
static void _vala_mail_conversation_item_model_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_mail_conversation_item_model_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
mail_conversation_item_model_get_instance_private (MailConversationItemModel* self)
{
	return G_STRUCT_MEMBER_P (self, MailConversationItemModel_private_offset);
}

MailConversationItemModel*
mail_conversation_item_model_construct (GType object_type,
                                        CamelFolderInfoFlags folder_info_flags,
                                        CamelFolderThreadNode* node,
                                        CamelFolderThread* thread,
                                        const gchar* service_uid)
{
	MailConversationItemModel * self = NULL;
#line 191 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 191 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (thread != NULL, NULL);
#line 191 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (service_uid != NULL, NULL);
#line 192 "../src/ConversationList/ConversationItemModel.vala"
	self = (MailConversationItemModel*) g_object_new (object_type, "service-uid", service_uid, "node", node, "thread", thread, "folder-info-flags", folder_info_flags, NULL);
#line 191 "../src/ConversationList/ConversationItemModel.vala"
	return self;
#line 205 "ConversationItemModel.c"
}

MailConversationItemModel*
mail_conversation_item_model_new (CamelFolderInfoFlags folder_info_flags,
                                  CamelFolderThreadNode* node,
                                  CamelFolderThread* thread,
                                  const gchar* service_uid)
{
#line 191 "../src/ConversationList/ConversationItemModel.vala"
	return mail_conversation_item_model_construct (MAIL_TYPE_CONVERSATION_ITEM_MODEL, folder_info_flags, node, thread, service_uid);
#line 216 "ConversationItemModel.c"
}

gboolean
mail_conversation_item_model_is_older_than (MailConversationItemModel* self,
                                            CamelFolderThreadNode* other_node)
{
	gint64 other_timestamp = 0LL;
	gint64 _tmp0_;
	gboolean result;
#line 199 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 199 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (other_node != NULL, FALSE);
#line 200 "../src/ConversationList/ConversationItemModel.vala"
	other_timestamp = mail_conversation_item_model_get_newest_timestamp (other_node, (gint64) -1);
#line 202 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_timestamp;
#line 202 "../src/ConversationList/ConversationItemModel.vala"
	result = _tmp0_ < other_timestamp;
#line 202 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 238 "ConversationItemModel.c"
}

static guint
mail_conversation_item_model_count_thread_messages (CamelFolderThreadNode* node)
{
	guint i = 0U;
	guint result;
#line 205 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (node != NULL, 0U);
#line 206 "../src/ConversationList/ConversationItemModel.vala"
	i = (guint) 1;
#line 250 "ConversationItemModel.c"
	{
		CamelFolderThreadNode* child = NULL;
		CamelFolderThreadNode* _tmp0_;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
		_tmp0_ = node->child;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
		child = _tmp0_;
#line 258 "ConversationItemModel.c"
		{
			gboolean _tmp1_ = FALSE;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
			_tmp1_ = TRUE;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
			while (TRUE) {
#line 265 "ConversationItemModel.c"
				CamelFolderThreadNode* _tmp4_;
				CamelFolderThreadNode* _tmp5_;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
				if (!_tmp1_) {
#line 270 "ConversationItemModel.c"
					CamelFolderThreadNode* _tmp2_;
					CamelFolderThreadNode* _tmp3_;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
					_tmp2_ = child;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
					_tmp3_ = _tmp2_->next;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
					child = _tmp3_;
#line 279 "ConversationItemModel.c"
				}
#line 207 "../src/ConversationList/ConversationItemModel.vala"
				_tmp1_ = FALSE;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
				_tmp4_ = child;
#line 207 "../src/ConversationList/ConversationItemModel.vala"
				if (!(_tmp4_ != NULL)) {
#line 207 "../src/ConversationList/ConversationItemModel.vala"
					break;
#line 289 "ConversationItemModel.c"
				}
#line 208 "../src/ConversationList/ConversationItemModel.vala"
				_tmp5_ = child;
#line 208 "../src/ConversationList/ConversationItemModel.vala"
				i += mail_conversation_item_model_count_thread_messages (_tmp5_);
#line 295 "ConversationItemModel.c"
			}
		}
	}
#line 211 "../src/ConversationList/ConversationItemModel.vala"
	result = i;
#line 211 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 303 "ConversationItemModel.c"
}

static gint64
mail_conversation_item_model_get_newest_timestamp (CamelFolderThreadNode* node,
                                                   gint64 highest)
{
	gint64 time = 0LL;
	CamelMessageInfo* message = NULL;
	CamelMessageInfo* _tmp0_;
	CamelMessageInfo* _tmp1_;
	gint64 result;
#line 215 "../src/ConversationList/ConversationItemModel.vala"
	time = highest;
#line 216 "../src/ConversationList/ConversationItemModel.vala"
	if (node == NULL) {
#line 217 "../src/ConversationList/ConversationItemModel.vala"
		result = time;
#line 217 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 323 "ConversationItemModel.c"
	}
#line 220 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = node->message;
#line 220 "../src/ConversationList/ConversationItemModel.vala"
	message = _tmp0_;
#line 221 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = message;
#line 221 "../src/ConversationList/ConversationItemModel.vala"
	if (_tmp1_ != NULL) {
#line 333 "ConversationItemModel.c"
		CamelMessageInfo* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		CamelMessageInfo* _tmp5_;
		gint64 _tmp6_;
		gint64 _tmp7_;
#line 222 "../src/ConversationList/ConversationItemModel.vala"
		_tmp2_ = message;
#line 222 "../src/ConversationList/ConversationItemModel.vala"
		_tmp3_ = camel_message_info_get_date_received (_tmp2_);
#line 222 "../src/ConversationList/ConversationItemModel.vala"
		_tmp4_ = _tmp3_;
#line 222 "../src/ConversationList/ConversationItemModel.vala"
		time = MAX (time, _tmp4_);
#line 223 "../src/ConversationList/ConversationItemModel.vala"
		_tmp5_ = message;
#line 223 "../src/ConversationList/ConversationItemModel.vala"
		_tmp6_ = camel_message_info_get_date_sent (_tmp5_);
#line 223 "../src/ConversationList/ConversationItemModel.vala"
		_tmp7_ = _tmp6_;
#line 223 "../src/ConversationList/ConversationItemModel.vala"
		time = MAX (time, _tmp7_);
#line 356 "ConversationItemModel.c"
	}
	{
		CamelFolderThreadNode* child = NULL;
		CamelFolderThreadNode* _tmp8_;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
		_tmp8_ = node->child;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
		child = _tmp8_;
#line 365 "ConversationItemModel.c"
		{
			gboolean _tmp9_ = FALSE;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
			_tmp9_ = TRUE;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
			while (TRUE) {
#line 372 "ConversationItemModel.c"
				CamelFolderThreadNode* _tmp12_;
				CamelFolderThreadNode* _tmp13_;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
				if (!_tmp9_) {
#line 377 "ConversationItemModel.c"
					CamelFolderThreadNode* _tmp10_;
					CamelFolderThreadNode* _tmp11_;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
					_tmp10_ = child;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
					_tmp11_ = _tmp10_->next;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
					child = _tmp11_;
#line 386 "ConversationItemModel.c"
				}
#line 226 "../src/ConversationList/ConversationItemModel.vala"
				_tmp9_ = FALSE;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
				_tmp12_ = child;
#line 226 "../src/ConversationList/ConversationItemModel.vala"
				if (!(_tmp12_ != NULL)) {
#line 226 "../src/ConversationList/ConversationItemModel.vala"
					break;
#line 396 "ConversationItemModel.c"
				}
#line 227 "../src/ConversationList/ConversationItemModel.vala"
				_tmp13_ = child;
#line 227 "../src/ConversationList/ConversationItemModel.vala"
				time = mail_conversation_item_model_get_newest_timestamp (_tmp13_, time);
#line 402 "ConversationItemModel.c"
			}
		}
	}
#line 230 "../src/ConversationList/ConversationItemModel.vala"
	result = time;
#line 230 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 410 "ConversationItemModel.c"
}

static gboolean
mail_conversation_item_model_has_thread_flag (CamelFolderThreadNode* node,
                                              CamelMessageFlags flag)
{
	gboolean has_flag = FALSE;
	CamelMessageInfo* _tmp0_;
	CamelMessageFlags _tmp1_;
	CamelMessageFlags _tmp2_;
	gboolean result;
#line 234 "../src/ConversationList/ConversationItemModel.vala"
	if (node == NULL) {
#line 235 "../src/ConversationList/ConversationItemModel.vala"
		result = FALSE;
#line 235 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 428 "ConversationItemModel.c"
	}
#line 238 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = node->message;
#line 238 "../src/ConversationList/ConversationItemModel.vala"
	g_object_get (_tmp0_, "flags", &_tmp1_, NULL);
#line 238 "../src/ConversationList/ConversationItemModel.vala"
	_tmp2_ = _tmp1_;
#line 238 "../src/ConversationList/ConversationItemModel.vala"
	has_flag = !((((gint) _tmp2_) & flag) == flag);
#line 240 "../src/ConversationList/ConversationItemModel.vala"
	if (!has_flag) {
#line 440 "ConversationItemModel.c"
		{
			CamelFolderThreadNode* child = NULL;
			CamelFolderThreadNode* _tmp3_;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
			_tmp3_ = node->child;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
			child = _tmp3_;
#line 448 "ConversationItemModel.c"
			{
				gboolean _tmp4_ = FALSE;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
				_tmp4_ = TRUE;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
				while (TRUE) {
#line 455 "ConversationItemModel.c"
					CamelFolderThreadNode* _tmp7_;
					CamelFolderThreadNode* _tmp8_;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
					if (!_tmp4_) {
#line 460 "ConversationItemModel.c"
						CamelFolderThreadNode* _tmp5_;
						CamelFolderThreadNode* _tmp6_;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
						_tmp5_ = child;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
						_tmp6_ = _tmp5_->next;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
						child = _tmp6_;
#line 469 "ConversationItemModel.c"
					}
#line 241 "../src/ConversationList/ConversationItemModel.vala"
					_tmp4_ = FALSE;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
					_tmp7_ = child;
#line 241 "../src/ConversationList/ConversationItemModel.vala"
					if (!(_tmp7_ != NULL)) {
#line 241 "../src/ConversationList/ConversationItemModel.vala"
						break;
#line 479 "ConversationItemModel.c"
					}
#line 242 "../src/ConversationList/ConversationItemModel.vala"
					_tmp8_ = child;
#line 242 "../src/ConversationList/ConversationItemModel.vala"
					has_flag = mail_conversation_item_model_has_thread_flag (_tmp8_, flag);
#line 243 "../src/ConversationList/ConversationItemModel.vala"
					if (has_flag) {
#line 244 "../src/ConversationList/ConversationItemModel.vala"
						break;
#line 489 "ConversationItemModel.c"
					}
				}
			}
		}
	}
#line 249 "../src/ConversationList/ConversationItemModel.vala"
	result = has_flag;
#line 249 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 499 "ConversationItemModel.c"
}

const gchar*
mail_conversation_item_model_get_service_uid (MailConversationItemModel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_service_uid;
#line 24 "../src/ConversationList/ConversationItemModel.vala"
	result = _tmp0_;
#line 24 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 515 "ConversationItemModel.c"
}

static void
mail_conversation_item_model_set_service_uid (MailConversationItemModel* self,
                                              const gchar* value)
{
	gchar* old_value;
#line 24 "../src/ConversationList/ConversationItemModel.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/ConversationList/ConversationItemModel.vala"
	old_value = mail_conversation_item_model_get_service_uid (self);
#line 24 "../src/ConversationList/ConversationItemModel.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 529 "ConversationItemModel.c"
		gchar* _tmp0_;
#line 24 "../src/ConversationList/ConversationItemModel.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../src/ConversationList/ConversationItemModel.vala"
		_g_free0 (self->priv->_service_uid);
#line 24 "../src/ConversationList/ConversationItemModel.vala"
		self->priv->_service_uid = _tmp0_;
#line 24 "../src/ConversationList/ConversationItemModel.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_SERVICE_UID_PROPERTY]);
#line 539 "ConversationItemModel.c"
	}
}

CamelFolderThreadNode*
mail_conversation_item_model_get_node (MailConversationItemModel* self)
{
	CamelFolderThreadNode* result;
	CamelFolderThreadNode* _tmp0_;
#line 25 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 25 "../src/ConversationList/ConversationItemModel.vala"
	result = _tmp0_;
#line 25 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 556 "ConversationItemModel.c"
}

static void
mail_conversation_item_model_set_node (MailConversationItemModel* self,
                                       CamelFolderThreadNode* value)
{
	CamelFolderThreadNode* old_value;
#line 25 "../src/ConversationList/ConversationItemModel.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/ConversationList/ConversationItemModel.vala"
	old_value = mail_conversation_item_model_get_node (self);
#line 25 "../src/ConversationList/ConversationItemModel.vala"
	if (old_value != value) {
#line 25 "../src/ConversationList/ConversationItemModel.vala"
		self->priv->_node = value;
#line 25 "../src/ConversationList/ConversationItemModel.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_NODE_PROPERTY]);
#line 574 "ConversationItemModel.c"
	}
}

CamelFolderThread*
mail_conversation_item_model_get_thread (MailConversationItemModel* self)
{
	CamelFolderThread* result;
	CamelFolderThread* _tmp0_;
#line 26 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_thread;
#line 26 "../src/ConversationList/ConversationItemModel.vala"
	result = _tmp0_;
#line 26 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 591 "ConversationItemModel.c"
}

static gpointer
_camel_folder_thread_messages_ref0 (gpointer self)
{
#line 26 "../src/ConversationList/ConversationItemModel.vala"
	return self ? camel_folder_thread_messages_ref (self) : NULL;
#line 599 "ConversationItemModel.c"
}

static void
mail_conversation_item_model_set_thread (MailConversationItemModel* self,
                                         CamelFolderThread* value)
{
	CamelFolderThread* old_value;
#line 26 "../src/ConversationList/ConversationItemModel.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/ConversationList/ConversationItemModel.vala"
	old_value = mail_conversation_item_model_get_thread (self);
#line 26 "../src/ConversationList/ConversationItemModel.vala"
	if (old_value != value) {
#line 613 "ConversationItemModel.c"
		CamelFolderThread* _tmp0_;
#line 26 "../src/ConversationList/ConversationItemModel.vala"
		_tmp0_ = _camel_folder_thread_messages_ref0 (value);
#line 26 "../src/ConversationList/ConversationItemModel.vala"
		_camel_folder_thread_messages_unref0 (self->priv->_thread);
#line 26 "../src/ConversationList/ConversationItemModel.vala"
		self->priv->_thread = _tmp0_;
#line 26 "../src/ConversationList/ConversationItemModel.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_THREAD_PROPERTY]);
#line 623 "ConversationItemModel.c"
	}
}

gint64
mail_conversation_item_model_get_timestamp (MailConversationItemModel* self)
{
	gint64 result;
#line 27 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 27 "../src/ConversationList/ConversationItemModel.vala"
	result = self->priv->_timestamp;
#line 27 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 637 "ConversationItemModel.c"
}

static void
mail_conversation_item_model_set_timestamp (MailConversationItemModel* self,
                                            gint64 value)
{
	gint64 old_value;
#line 27 "../src/ConversationList/ConversationItemModel.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/ConversationList/ConversationItemModel.vala"
	old_value = mail_conversation_item_model_get_timestamp (self);
#line 27 "../src/ConversationList/ConversationItemModel.vala"
	if (old_value != value) {
#line 27 "../src/ConversationList/ConversationItemModel.vala"
		self->priv->_timestamp = value;
#line 27 "../src/ConversationList/ConversationItemModel.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_TIMESTAMP_PROPERTY]);
#line 655 "ConversationItemModel.c"
	}
}

CamelFolderInfoFlags
mail_conversation_item_model_get_folder_info_flags (MailConversationItemModel* self)
{
	CamelFolderInfoFlags result;
#line 28 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 28 "../src/ConversationList/ConversationItemModel.vala"
	result = self->priv->_folder_info_flags;
#line 28 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 669 "ConversationItemModel.c"
}

static void
mail_conversation_item_model_set_folder_info_flags (MailConversationItemModel* self,
                                                    CamelFolderInfoFlags value)
{
	CamelFolderInfoFlags old_value;
#line 28 "../src/ConversationList/ConversationItemModel.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/ConversationList/ConversationItemModel.vala"
	old_value = mail_conversation_item_model_get_folder_info_flags (self);
#line 28 "../src/ConversationList/ConversationItemModel.vala"
	if (old_value != value) {
#line 28 "../src/ConversationList/ConversationItemModel.vala"
		self->priv->_folder_info_flags = value;
#line 28 "../src/ConversationList/ConversationItemModel.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_FOLDER_INFO_FLAGS_PROPERTY]);
#line 687 "ConversationItemModel.c"
	}
}

gboolean
mail_conversation_item_model_get_hidden (MailConversationItemModel* self)
{
	gboolean result;
#line 29 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/ConversationList/ConversationItemModel.vala"
	result = self->priv->_hidden;
#line 29 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 701 "ConversationItemModel.c"
}

void
mail_conversation_item_model_set_hidden (MailConversationItemModel* self,
                                         gboolean value)
{
	gboolean old_value;
#line 29 "../src/ConversationList/ConversationItemModel.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/ConversationList/ConversationItemModel.vala"
	old_value = mail_conversation_item_model_get_hidden (self);
#line 29 "../src/ConversationList/ConversationItemModel.vala"
	if (old_value != value) {
#line 29 "../src/ConversationList/ConversationItemModel.vala"
		self->priv->_hidden = value;
#line 29 "../src/ConversationList/ConversationItemModel.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_HIDDEN_PROPERTY]);
#line 719 "ConversationItemModel.c"
	}
}

gchar*
mail_conversation_item_model_get_formatted_date (MailConversationItemModel* self)
{
	gchar* result;
	gint64 _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 32 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_timestamp;
#line 33 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = g_date_time_new_from_unix_local (_tmp0_);
#line 33 "../src/ConversationList/ConversationItemModel.vala"
	_tmp2_ = _tmp1_;
#line 33 "../src/ConversationList/ConversationItemModel.vala"
	_tmp3_ = granite_date_time_get_relative_datetime (_tmp2_);
#line 33 "../src/ConversationList/ConversationItemModel.vala"
	_tmp4_ = _tmp3_;
#line 33 "../src/ConversationList/ConversationItemModel.vala"
	_g_date_time_unref0 (_tmp2_);
#line 33 "../src/ConversationList/ConversationItemModel.vala"
	result = _tmp4_;
#line 33 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 750 "ConversationItemModel.c"
}

guint
mail_conversation_item_model_get_num_messages (MailConversationItemModel* self)
{
	guint result;
	CamelFolderThreadNode* _tmp0_;
#line 38 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 39 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 39 "../src/ConversationList/ConversationItemModel.vala"
	result = mail_conversation_item_model_count_thread_messages (_tmp0_);
#line 39 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 766 "ConversationItemModel.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 64 "../src/ConversationList/ConversationItemModel.vala"
	for (i = 0; i < stack_length; i++) {
#line 64 "../src/ConversationList/ConversationItemModel.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 64 "../src/ConversationList/ConversationItemModel.vala"
			return TRUE;
#line 781 "ConversationItemModel.c"
		}
	}
#line 64 "../src/ConversationList/ConversationItemModel.vala"
	return FALSE;
#line 786 "ConversationItemModel.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 65 "../src/ConversationList/ConversationItemModel.vala"
	if ((*length) == (*size)) {
#line 65 "../src/ConversationList/ConversationItemModel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 65 "../src/ConversationList/ConversationItemModel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 801 "ConversationItemModel.c"
	}
#line 65 "../src/ConversationList/ConversationItemModel.vala"
	(*array)[(*length)++] = value;
#line 65 "../src/ConversationList/ConversationItemModel.vala"
	(*array)[*length] = NULL;
#line 807 "ConversationItemModel.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 821 "ConversationItemModel.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 825 "ConversationItemModel.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 831 "ConversationItemModel.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 836 "ConversationItemModel.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 842 "ConversationItemModel.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 846 "ConversationItemModel.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 850 "ConversationItemModel.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 854 "ConversationItemModel.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 858 "ConversationItemModel.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 862 "ConversationItemModel.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 877 "ConversationItemModel.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 886 "ConversationItemModel.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 893 "ConversationItemModel.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 899 "ConversationItemModel.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 907 "ConversationItemModel.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 911 "ConversationItemModel.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 917 "ConversationItemModel.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 922 "ConversationItemModel.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 928 "ConversationItemModel.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 932 "ConversationItemModel.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 936 "ConversationItemModel.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 942 "ConversationItemModel.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 948 "ConversationItemModel.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 960 "ConversationItemModel.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 964 "ConversationItemModel.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 968 "ConversationItemModel.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 973 "ConversationItemModel.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 981 "ConversationItemModel.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 999 "ConversationItemModel.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1005 "ConversationItemModel.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1009 "ConversationItemModel.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1017 "ConversationItemModel.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 1026 "ConversationItemModel.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1035 "ConversationItemModel.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1041 "ConversationItemModel.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 1049 "ConversationItemModel.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1061 "ConversationItemModel.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1067 "ConversationItemModel.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1071 "ConversationItemModel.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1079 "ConversationItemModel.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1090 "ConversationItemModel.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1099 "ConversationItemModel.c"
	}
}

gchar*
mail_conversation_item_model_get_from (MailConversationItemModel* self)
{
	gchar* result;
	gchar** senders = NULL;
	gchar** _tmp0_;
	gint senders_length1;
	gint _senders_size_;
	CamelFolderThreadNode* current_node = NULL;
	CamelFolderThreadNode* _tmp1_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	gchar* _tmp30_;
#line 44 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 45 "../src/ConversationList/ConversationItemModel.vala"
	senders = _tmp0_;
#line 45 "../src/ConversationList/ConversationItemModel.vala"
	senders_length1 = 0;
#line 45 "../src/ConversationList/ConversationItemModel.vala"
	_senders_size_ = senders_length1;
#line 47 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = self->priv->_node;
#line 47 "../src/ConversationList/ConversationItemModel.vala"
	current_node = _tmp1_;
#line 48 "../src/ConversationList/ConversationItemModel.vala"
	while (TRUE) {
#line 1132 "ConversationItemModel.c"
		CamelFolderThreadNode* _tmp2_;
		CamelMessageInfo* message = NULL;
		CamelFolderThreadNode* _tmp3_;
		CamelMessageInfo* _tmp4_;
		CamelMessageInfo* _tmp5_;
		CamelFolderThreadNode* _tmp25_;
		CamelFolderThreadNode* _tmp26_;
#line 48 "../src/ConversationList/ConversationItemModel.vala"
		_tmp2_ = current_node;
#line 48 "../src/ConversationList/ConversationItemModel.vala"
		if (!(_tmp2_ != NULL)) {
#line 48 "../src/ConversationList/ConversationItemModel.vala"
			break;
#line 1146 "ConversationItemModel.c"
		}
#line 49 "../src/ConversationList/ConversationItemModel.vala"
		_tmp3_ = current_node;
#line 49 "../src/ConversationList/ConversationItemModel.vala"
		_tmp4_ = _tmp3_->message;
#line 49 "../src/ConversationList/ConversationItemModel.vala"
		message = _tmp4_;
#line 50 "../src/ConversationList/ConversationItemModel.vala"
		_tmp5_ = message;
#line 50 "../src/ConversationList/ConversationItemModel.vala"
		if (_tmp5_ != NULL) {
#line 1158 "ConversationItemModel.c"
			CamelInternetAddress* address = NULL;
			CamelInternetAddress* _tmp6_;
			CamelInternetAddress* _tmp7_;
			CamelMessageInfo* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
#line 51 "../src/ConversationList/ConversationItemModel.vala"
			_tmp6_ = camel_internet_address_new ();
#line 51 "../src/ConversationList/ConversationItemModel.vala"
			address = _tmp6_;
#line 52 "../src/ConversationList/ConversationItemModel.vala"
			_tmp7_ = address;
#line 52 "../src/ConversationList/ConversationItemModel.vala"
			_tmp8_ = message;
#line 52 "../src/ConversationList/ConversationItemModel.vala"
			_tmp9_ = camel_message_info_get_from (_tmp8_);
#line 52 "../src/ConversationList/ConversationItemModel.vala"
			_tmp10_ = _tmp9_;
#line 52 "../src/ConversationList/ConversationItemModel.vala"
			if (camel_address_decode ((CamelAddress*) _tmp7_, _tmp10_) > 0) {
#line 1179 "ConversationItemModel.c"
				const gchar* ia_name = NULL;
				const gchar* ia_address = NULL;
				gchar* sender = NULL;
				CamelInternetAddress* _tmp11_;
				const gchar* _tmp12_ = NULL;
				const gchar* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				const gchar* _tmp15_;
				const gchar* _tmp21_;
				gchar** _tmp22_;
				gint _tmp22__length1;
#line 57 "../src/ConversationList/ConversationItemModel.vala"
				_tmp11_ = address;
#line 57 "../src/ConversationList/ConversationItemModel.vala"
				camel_internet_address_get (_tmp11_, 0, &_tmp12_, &_tmp13_);
#line 57 "../src/ConversationList/ConversationItemModel.vala"
				ia_name = _tmp12_;
#line 57 "../src/ConversationList/ConversationItemModel.vala"
				ia_address = _tmp13_;
#line 58 "../src/ConversationList/ConversationItemModel.vala"
				_tmp15_ = ia_name;
#line 58 "../src/ConversationList/ConversationItemModel.vala"
				if (_tmp15_ != NULL) {
#line 1203 "ConversationItemModel.c"
					const gchar* _tmp16_;
#line 58 "../src/ConversationList/ConversationItemModel.vala"
					_tmp16_ = ia_name;
#line 58 "../src/ConversationList/ConversationItemModel.vala"
					_tmp14_ = g_strcmp0 (_tmp16_, "") != 0;
#line 1209 "ConversationItemModel.c"
				} else {
#line 58 "../src/ConversationList/ConversationItemModel.vala"
					_tmp14_ = FALSE;
#line 1213 "ConversationItemModel.c"
				}
#line 58 "../src/ConversationList/ConversationItemModel.vala"
				if (_tmp14_) {
#line 1217 "ConversationItemModel.c"
					const gchar* _tmp17_;
					gchar* _tmp18_;
#line 59 "../src/ConversationList/ConversationItemModel.vala"
					_tmp17_ = ia_name;
#line 59 "../src/ConversationList/ConversationItemModel.vala"
					_tmp18_ = g_strdup (_tmp17_);
#line 59 "../src/ConversationList/ConversationItemModel.vala"
					_g_free0 (sender);
#line 59 "../src/ConversationList/ConversationItemModel.vala"
					sender = _tmp18_;
#line 1228 "ConversationItemModel.c"
				} else {
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 61 "../src/ConversationList/ConversationItemModel.vala"
					_tmp19_ = ia_address;
#line 61 "../src/ConversationList/ConversationItemModel.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 61 "../src/ConversationList/ConversationItemModel.vala"
					_g_free0 (sender);
#line 61 "../src/ConversationList/ConversationItemModel.vala"
					sender = _tmp20_;
#line 1240 "ConversationItemModel.c"
				}
#line 64 "../src/ConversationList/ConversationItemModel.vala"
				_tmp21_ = sender;
#line 64 "../src/ConversationList/ConversationItemModel.vala"
				_tmp22_ = senders;
#line 64 "../src/ConversationList/ConversationItemModel.vala"
				_tmp22__length1 = senders_length1;
#line 64 "../src/ConversationList/ConversationItemModel.vala"
				if (!_vala_string_array_contains (_tmp22_, _tmp22__length1, _tmp21_)) {
#line 1250 "ConversationItemModel.c"
					const gchar* _tmp23_;
					gchar* _tmp24_;
#line 65 "../src/ConversationList/ConversationItemModel.vala"
					_tmp23_ = sender;
#line 65 "../src/ConversationList/ConversationItemModel.vala"
					_tmp24_ = g_strdup (_tmp23_);
#line 65 "../src/ConversationList/ConversationItemModel.vala"
					_vala_array_add1 (&senders, &senders_length1, &_senders_size_, _tmp24_);
#line 1259 "ConversationItemModel.c"
				}
#line 52 "../src/ConversationList/ConversationItemModel.vala"
				_g_free0 (sender);
#line 1263 "ConversationItemModel.c"
			}
#line 50 "../src/ConversationList/ConversationItemModel.vala"
			_g_object_unref0 (address);
#line 1267 "ConversationItemModel.c"
		}
#line 70 "../src/ConversationList/ConversationItemModel.vala"
		_tmp25_ = current_node;
#line 70 "../src/ConversationList/ConversationItemModel.vala"
		_tmp26_ = _tmp25_->child;
#line 70 "../src/ConversationList/ConversationItemModel.vala"
		current_node = (CamelFolderThreadNode*) _tmp26_;
#line 1275 "ConversationItemModel.c"
	}
#line 73 "../src/ConversationList/ConversationItemModel.vala"
	_tmp27_ = senders;
#line 73 "../src/ConversationList/ConversationItemModel.vala"
	_tmp27__length1 = senders_length1;
#line 73 "../src/ConversationList/ConversationItemModel.vala"
	if (_tmp27__length1 > 0) {
#line 1283 "ConversationItemModel.c"
		gchar** _tmp28_;
		gint _tmp28__length1;
		gchar* _tmp29_;
#line 74 "../src/ConversationList/ConversationItemModel.vala"
		_tmp28_ = senders;
#line 74 "../src/ConversationList/ConversationItemModel.vala"
		_tmp28__length1 = senders_length1;
#line 74 "../src/ConversationList/ConversationItemModel.vala"
		_tmp29_ = _vala_g_strjoinv (_ (", "), _tmp28_, (gint) _tmp28__length1);
#line 74 "../src/ConversationList/ConversationItemModel.vala"
		result = _tmp29_;
#line 74 "../src/ConversationList/ConversationItemModel.vala"
		senders = (_vala_array_free (senders, senders_length1, (GDestroyNotify) g_free), NULL);
#line 74 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 1299 "ConversationItemModel.c"
	}
#line 77 "../src/ConversationList/ConversationItemModel.vala"
	_tmp30_ = g_strdup (_ ("Unknown"));
#line 77 "../src/ConversationList/ConversationItemModel.vala"
	result = _tmp30_;
#line 77 "../src/ConversationList/ConversationItemModel.vala"
	senders = (_vala_array_free (senders, senders_length1, (GDestroyNotify) g_free), NULL);
#line 77 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 1309 "ConversationItemModel.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 103 "../src/ConversationList/ConversationItemModel.vala"
	if ((*length) == (*size)) {
#line 103 "../src/ConversationList/ConversationItemModel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 103 "../src/ConversationList/ConversationItemModel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1324 "ConversationItemModel.c"
	}
#line 103 "../src/ConversationList/ConversationItemModel.vala"
	(*array)[(*length)++] = value;
#line 103 "../src/ConversationList/ConversationItemModel.vala"
	(*array)[*length] = NULL;
#line 1330 "ConversationItemModel.c"
}

gchar*
mail_conversation_item_model_get_to (MailConversationItemModel* self)
{
	gchar* result;
	gchar** recipients = NULL;
	gchar** _tmp0_;
	gint recipients_length1;
	gint _recipients_size_;
	CamelFolderThreadNode* current_node = NULL;
	CamelFolderThreadNode* _tmp1_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	gchar* _tmp30_;
#line 82 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 83 "../src/ConversationList/ConversationItemModel.vala"
	recipients = _tmp0_;
#line 83 "../src/ConversationList/ConversationItemModel.vala"
	recipients_length1 = 0;
#line 83 "../src/ConversationList/ConversationItemModel.vala"
	_recipients_size_ = recipients_length1;
#line 85 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = self->priv->_node;
#line 85 "../src/ConversationList/ConversationItemModel.vala"
	current_node = _tmp1_;
#line 86 "../src/ConversationList/ConversationItemModel.vala"
	while (TRUE) {
#line 1362 "ConversationItemModel.c"
		CamelFolderThreadNode* _tmp2_;
		CamelMessageInfo* message = NULL;
		CamelFolderThreadNode* _tmp3_;
		CamelMessageInfo* _tmp4_;
		CamelMessageInfo* _tmp5_;
		CamelFolderThreadNode* _tmp25_;
		CamelFolderThreadNode* _tmp26_;
#line 86 "../src/ConversationList/ConversationItemModel.vala"
		_tmp2_ = current_node;
#line 86 "../src/ConversationList/ConversationItemModel.vala"
		if (!(_tmp2_ != NULL)) {
#line 86 "../src/ConversationList/ConversationItemModel.vala"
			break;
#line 1376 "ConversationItemModel.c"
		}
#line 87 "../src/ConversationList/ConversationItemModel.vala"
		_tmp3_ = current_node;
#line 87 "../src/ConversationList/ConversationItemModel.vala"
		_tmp4_ = _tmp3_->message;
#line 87 "../src/ConversationList/ConversationItemModel.vala"
		message = _tmp4_;
#line 88 "../src/ConversationList/ConversationItemModel.vala"
		_tmp5_ = message;
#line 88 "../src/ConversationList/ConversationItemModel.vala"
		if (_tmp5_ != NULL) {
#line 1388 "ConversationItemModel.c"
			CamelInternetAddress* address = NULL;
			CamelInternetAddress* _tmp6_;
			CamelInternetAddress* _tmp7_;
			CamelMessageInfo* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
#line 89 "../src/ConversationList/ConversationItemModel.vala"
			_tmp6_ = camel_internet_address_new ();
#line 89 "../src/ConversationList/ConversationItemModel.vala"
			address = _tmp6_;
#line 90 "../src/ConversationList/ConversationItemModel.vala"
			_tmp7_ = address;
#line 90 "../src/ConversationList/ConversationItemModel.vala"
			_tmp8_ = message;
#line 90 "../src/ConversationList/ConversationItemModel.vala"
			_tmp9_ = camel_message_info_get_to (_tmp8_);
#line 90 "../src/ConversationList/ConversationItemModel.vala"
			_tmp10_ = _tmp9_;
#line 90 "../src/ConversationList/ConversationItemModel.vala"
			if (camel_address_decode ((CamelAddress*) _tmp7_, _tmp10_) > 0) {
#line 1409 "ConversationItemModel.c"
				const gchar* ia_name = NULL;
				const gchar* ia_address = NULL;
				gchar* recipient = NULL;
				CamelInternetAddress* _tmp11_;
				const gchar* _tmp12_ = NULL;
				const gchar* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				const gchar* _tmp15_;
				const gchar* _tmp21_;
				gchar** _tmp22_;
				gint _tmp22__length1;
#line 95 "../src/ConversationList/ConversationItemModel.vala"
				_tmp11_ = address;
#line 95 "../src/ConversationList/ConversationItemModel.vala"
				camel_internet_address_get (_tmp11_, 0, &_tmp12_, &_tmp13_);
#line 95 "../src/ConversationList/ConversationItemModel.vala"
				ia_name = _tmp12_;
#line 95 "../src/ConversationList/ConversationItemModel.vala"
				ia_address = _tmp13_;
#line 96 "../src/ConversationList/ConversationItemModel.vala"
				_tmp15_ = ia_name;
#line 96 "../src/ConversationList/ConversationItemModel.vala"
				if (_tmp15_ != NULL) {
#line 1433 "ConversationItemModel.c"
					const gchar* _tmp16_;
#line 96 "../src/ConversationList/ConversationItemModel.vala"
					_tmp16_ = ia_name;
#line 96 "../src/ConversationList/ConversationItemModel.vala"
					_tmp14_ = g_strcmp0 (_tmp16_, "") != 0;
#line 1439 "ConversationItemModel.c"
				} else {
#line 96 "../src/ConversationList/ConversationItemModel.vala"
					_tmp14_ = FALSE;
#line 1443 "ConversationItemModel.c"
				}
#line 96 "../src/ConversationList/ConversationItemModel.vala"
				if (_tmp14_) {
#line 1447 "ConversationItemModel.c"
					const gchar* _tmp17_;
					gchar* _tmp18_;
#line 97 "../src/ConversationList/ConversationItemModel.vala"
					_tmp17_ = ia_name;
#line 97 "../src/ConversationList/ConversationItemModel.vala"
					_tmp18_ = g_strdup (_tmp17_);
#line 97 "../src/ConversationList/ConversationItemModel.vala"
					_g_free0 (recipient);
#line 97 "../src/ConversationList/ConversationItemModel.vala"
					recipient = _tmp18_;
#line 1458 "ConversationItemModel.c"
				} else {
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 99 "../src/ConversationList/ConversationItemModel.vala"
					_tmp19_ = ia_address;
#line 99 "../src/ConversationList/ConversationItemModel.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 99 "../src/ConversationList/ConversationItemModel.vala"
					_g_free0 (recipient);
#line 99 "../src/ConversationList/ConversationItemModel.vala"
					recipient = _tmp20_;
#line 1470 "ConversationItemModel.c"
				}
#line 102 "../src/ConversationList/ConversationItemModel.vala"
				_tmp21_ = recipient;
#line 102 "../src/ConversationList/ConversationItemModel.vala"
				_tmp22_ = recipients;
#line 102 "../src/ConversationList/ConversationItemModel.vala"
				_tmp22__length1 = recipients_length1;
#line 102 "../src/ConversationList/ConversationItemModel.vala"
				if (!_vala_string_array_contains (_tmp22_, _tmp22__length1, _tmp21_)) {
#line 1480 "ConversationItemModel.c"
					const gchar* _tmp23_;
					gchar* _tmp24_;
#line 103 "../src/ConversationList/ConversationItemModel.vala"
					_tmp23_ = recipient;
#line 103 "../src/ConversationList/ConversationItemModel.vala"
					_tmp24_ = g_strdup (_tmp23_);
#line 103 "../src/ConversationList/ConversationItemModel.vala"
					_vala_array_add2 (&recipients, &recipients_length1, &_recipients_size_, _tmp24_);
#line 1489 "ConversationItemModel.c"
				}
#line 90 "../src/ConversationList/ConversationItemModel.vala"
				_g_free0 (recipient);
#line 1493 "ConversationItemModel.c"
			}
#line 88 "../src/ConversationList/ConversationItemModel.vala"
			_g_object_unref0 (address);
#line 1497 "ConversationItemModel.c"
		}
#line 108 "../src/ConversationList/ConversationItemModel.vala"
		_tmp25_ = current_node;
#line 108 "../src/ConversationList/ConversationItemModel.vala"
		_tmp26_ = _tmp25_->child;
#line 108 "../src/ConversationList/ConversationItemModel.vala"
		current_node = (CamelFolderThreadNode*) _tmp26_;
#line 1505 "ConversationItemModel.c"
	}
#line 111 "../src/ConversationList/ConversationItemModel.vala"
	_tmp27_ = recipients;
#line 111 "../src/ConversationList/ConversationItemModel.vala"
	_tmp27__length1 = recipients_length1;
#line 111 "../src/ConversationList/ConversationItemModel.vala"
	if (_tmp27__length1 > 0) {
#line 1513 "ConversationItemModel.c"
		gchar** _tmp28_;
		gint _tmp28__length1;
		gchar* _tmp29_;
#line 112 "../src/ConversationList/ConversationItemModel.vala"
		_tmp28_ = recipients;
#line 112 "../src/ConversationList/ConversationItemModel.vala"
		_tmp28__length1 = recipients_length1;
#line 112 "../src/ConversationList/ConversationItemModel.vala"
		_tmp29_ = _vala_g_strjoinv (_ (", "), _tmp28_, (gint) _tmp28__length1);
#line 112 "../src/ConversationList/ConversationItemModel.vala"
		result = _tmp29_;
#line 112 "../src/ConversationList/ConversationItemModel.vala"
		recipients = (_vala_array_free (recipients, recipients_length1, (GDestroyNotify) g_free), NULL);
#line 112 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 1529 "ConversationItemModel.c"
	}
#line 115 "../src/ConversationList/ConversationItemModel.vala"
	_tmp30_ = g_strdup (_ ("Unknown"));
#line 115 "../src/ConversationList/ConversationItemModel.vala"
	result = _tmp30_;
#line 115 "../src/ConversationList/ConversationItemModel.vala"
	recipients = (_vala_array_free (recipients, recipients_length1, (GDestroyNotify) g_free), NULL);
#line 115 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 1539 "ConversationItemModel.c"
}

const gchar*
mail_conversation_item_model_get_subject (MailConversationItemModel* self)
{
	const gchar* result;
	CamelMessageInfo* message = NULL;
	CamelFolderThreadNode* _tmp0_;
	CamelMessageInfo* _tmp1_;
	CamelMessageInfo* _tmp2_;
	CamelMessageInfo* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 120 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 121 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 121 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = _tmp0_->message;
#line 121 "../src/ConversationList/ConversationItemModel.vala"
	message = _tmp1_;
#line 122 "../src/ConversationList/ConversationItemModel.vala"
	_tmp2_ = message;
#line 122 "../src/ConversationList/ConversationItemModel.vala"
	if (_tmp2_ == NULL) {
#line 123 "../src/ConversationList/ConversationItemModel.vala"
		result = _ ("Unknown");
#line 123 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 1569 "ConversationItemModel.c"
	}
#line 126 "../src/ConversationList/ConversationItemModel.vala"
	_tmp3_ = message;
#line 126 "../src/ConversationList/ConversationItemModel.vala"
	_tmp4_ = camel_message_info_get_subject (_tmp3_);
#line 126 "../src/ConversationList/ConversationItemModel.vala"
	_tmp5_ = _tmp4_;
#line 126 "../src/ConversationList/ConversationItemModel.vala"
	result = _tmp5_;
#line 126 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 1581 "ConversationItemModel.c"
}

gboolean
mail_conversation_item_model_get_flagged (MailConversationItemModel* self)
{
	gboolean result;
	CamelMessageInfo* message = NULL;
	CamelFolderThreadNode* _tmp0_;
	CamelMessageInfo* _tmp1_;
	CamelMessageInfo* _tmp2_;
	CamelMessageInfo* _tmp3_;
	CamelMessageFlags _tmp4_;
	CamelMessageFlags _tmp5_;
#line 131 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 132 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 132 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = _tmp0_->message;
#line 132 "../src/ConversationList/ConversationItemModel.vala"
	message = _tmp1_;
#line 133 "../src/ConversationList/ConversationItemModel.vala"
	_tmp2_ = message;
#line 133 "../src/ConversationList/ConversationItemModel.vala"
	if (_tmp2_ == NULL) {
#line 134 "../src/ConversationList/ConversationItemModel.vala"
		result = FALSE;
#line 134 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 1611 "ConversationItemModel.c"
	}
#line 137 "../src/ConversationList/ConversationItemModel.vala"
	_tmp3_ = message;
#line 137 "../src/ConversationList/ConversationItemModel.vala"
	g_object_get (_tmp3_, "flags", &_tmp4_, NULL);
#line 137 "../src/ConversationList/ConversationItemModel.vala"
	_tmp5_ = _tmp4_;
#line 137 "../src/ConversationList/ConversationItemModel.vala"
	result = (((gint) _tmp5_) & CAMEL_MESSAGE_FLAGGED) == CAMEL_MESSAGE_FLAGGED;
#line 137 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 1623 "ConversationItemModel.c"
}

gboolean
mail_conversation_item_model_get_forwarded (MailConversationItemModel* self)
{
	gboolean result;
	CamelMessageInfo* message = NULL;
	CamelFolderThreadNode* _tmp0_;
	CamelMessageInfo* _tmp1_;
	CamelMessageInfo* _tmp2_;
	CamelMessageInfo* _tmp3_;
	CamelMessageFlags _tmp4_;
	CamelMessageFlags _tmp5_;
#line 142 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 143 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = _tmp0_->message;
#line 143 "../src/ConversationList/ConversationItemModel.vala"
	message = _tmp1_;
#line 144 "../src/ConversationList/ConversationItemModel.vala"
	_tmp2_ = message;
#line 144 "../src/ConversationList/ConversationItemModel.vala"
	if (_tmp2_ == NULL) {
#line 145 "../src/ConversationList/ConversationItemModel.vala"
		result = FALSE;
#line 145 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 1653 "ConversationItemModel.c"
	}
#line 148 "../src/ConversationList/ConversationItemModel.vala"
	_tmp3_ = message;
#line 148 "../src/ConversationList/ConversationItemModel.vala"
	g_object_get (_tmp3_, "flags", &_tmp4_, NULL);
#line 148 "../src/ConversationList/ConversationItemModel.vala"
	_tmp5_ = _tmp4_;
#line 148 "../src/ConversationList/ConversationItemModel.vala"
	result = (((gint) _tmp5_) & CAMEL_MESSAGE_FORWARDED) == CAMEL_MESSAGE_FORWARDED;
#line 148 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 1665 "ConversationItemModel.c"
}

gboolean
mail_conversation_item_model_get_replied (MailConversationItemModel* self)
{
	gboolean result;
	CamelMessageInfo* message = NULL;
	CamelFolderThreadNode* _tmp0_;
	CamelMessageInfo* _tmp1_;
	CamelMessageInfo* _tmp2_;
	CamelMessageInfo* _tmp3_;
	CamelMessageFlags _tmp4_;
	CamelMessageFlags _tmp5_;
#line 153 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 154 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = _tmp0_->message;
#line 154 "../src/ConversationList/ConversationItemModel.vala"
	message = _tmp1_;
#line 155 "../src/ConversationList/ConversationItemModel.vala"
	_tmp2_ = message;
#line 155 "../src/ConversationList/ConversationItemModel.vala"
	if (_tmp2_ == NULL) {
#line 156 "../src/ConversationList/ConversationItemModel.vala"
		result = FALSE;
#line 156 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 1695 "ConversationItemModel.c"
	}
#line 159 "../src/ConversationList/ConversationItemModel.vala"
	_tmp3_ = message;
#line 159 "../src/ConversationList/ConversationItemModel.vala"
	g_object_get (_tmp3_, "flags", &_tmp4_, NULL);
#line 159 "../src/ConversationList/ConversationItemModel.vala"
	_tmp5_ = _tmp4_;
#line 159 "../src/ConversationList/ConversationItemModel.vala"
	result = (((gint) _tmp5_) & CAMEL_MESSAGE_ANSWERED) == CAMEL_MESSAGE_ANSWERED;
#line 159 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 1707 "ConversationItemModel.c"
}

gboolean
mail_conversation_item_model_get_replied_all (MailConversationItemModel* self)
{
	gboolean result;
	CamelMessageInfo* message = NULL;
	CamelFolderThreadNode* _tmp0_;
	CamelMessageInfo* _tmp1_;
	CamelMessageInfo* _tmp2_;
	CamelMessageInfo* _tmp3_;
	CamelMessageFlags _tmp4_;
	CamelMessageFlags _tmp5_;
#line 164 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 165 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = _tmp0_->message;
#line 165 "../src/ConversationList/ConversationItemModel.vala"
	message = _tmp1_;
#line 166 "../src/ConversationList/ConversationItemModel.vala"
	_tmp2_ = message;
#line 166 "../src/ConversationList/ConversationItemModel.vala"
	if (_tmp2_ == NULL) {
#line 167 "../src/ConversationList/ConversationItemModel.vala"
		result = FALSE;
#line 167 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 1737 "ConversationItemModel.c"
	}
#line 170 "../src/ConversationList/ConversationItemModel.vala"
	_tmp3_ = message;
#line 170 "../src/ConversationList/ConversationItemModel.vala"
	g_object_get (_tmp3_, "flags", &_tmp4_, NULL);
#line 170 "../src/ConversationList/ConversationItemModel.vala"
	_tmp5_ = _tmp4_;
#line 170 "../src/ConversationList/ConversationItemModel.vala"
	result = (((gint) _tmp5_) & CAMEL_MESSAGE_ANSWERED_ALL) == CAMEL_MESSAGE_ANSWERED_ALL;
#line 170 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 1749 "ConversationItemModel.c"
}

gboolean
mail_conversation_item_model_get_unread (MailConversationItemModel* self)
{
	gboolean result;
	CamelFolderThreadNode* _tmp0_;
#line 175 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 176 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 176 "../src/ConversationList/ConversationItemModel.vala"
	result = mail_conversation_item_model_has_thread_flag (_tmp0_, CAMEL_MESSAGE_SEEN);
#line 176 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 1765 "ConversationItemModel.c"
}

gboolean
mail_conversation_item_model_get_deleted (MailConversationItemModel* self)
{
	gboolean result;
	CamelMessageInfo* message = NULL;
	CamelFolderThreadNode* _tmp0_;
	CamelMessageInfo* _tmp1_;
	CamelMessageInfo* _tmp2_;
	CamelMessageInfo* _tmp3_;
	CamelMessageFlags _tmp4_;
	CamelMessageFlags _tmp5_;
#line 181 "../src/ConversationList/ConversationItemModel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 182 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 182 "../src/ConversationList/ConversationItemModel.vala"
	_tmp1_ = _tmp0_->message;
#line 182 "../src/ConversationList/ConversationItemModel.vala"
	message = _tmp1_;
#line 183 "../src/ConversationList/ConversationItemModel.vala"
	_tmp2_ = message;
#line 183 "../src/ConversationList/ConversationItemModel.vala"
	if (_tmp2_ == NULL) {
#line 184 "../src/ConversationList/ConversationItemModel.vala"
		result = FALSE;
#line 184 "../src/ConversationList/ConversationItemModel.vala"
		return result;
#line 1795 "ConversationItemModel.c"
	}
#line 187 "../src/ConversationList/ConversationItemModel.vala"
	_tmp3_ = message;
#line 187 "../src/ConversationList/ConversationItemModel.vala"
	g_object_get (_tmp3_, "flags", &_tmp4_, NULL);
#line 187 "../src/ConversationList/ConversationItemModel.vala"
	_tmp5_ = _tmp4_;
#line 187 "../src/ConversationList/ConversationItemModel.vala"
	result = (((gint) _tmp5_) & CAMEL_MESSAGE_DELETED) == CAMEL_MESSAGE_DELETED;
#line 187 "../src/ConversationList/ConversationItemModel.vala"
	return result;
#line 1807 "ConversationItemModel.c"
}

static GObject *
mail_conversation_item_model_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MailConversationItemModel * self;
	CamelFolderThreadNode* _tmp0_;
#line 195 "../src/ConversationList/ConversationItemModel.vala"
	parent_class = G_OBJECT_CLASS (mail_conversation_item_model_parent_class);
#line 195 "../src/ConversationList/ConversationItemModel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 195 "../src/ConversationList/ConversationItemModel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_CONVERSATION_ITEM_MODEL, MailConversationItemModel);
#line 196 "../src/ConversationList/ConversationItemModel.vala"
	_tmp0_ = self->priv->_node;
#line 196 "../src/ConversationList/ConversationItemModel.vala"
	mail_conversation_item_model_set_timestamp (self, mail_conversation_item_model_get_newest_timestamp (_tmp0_, (gint64) -1));
#line 195 "../src/ConversationList/ConversationItemModel.vala"
	return obj;
#line 1831 "ConversationItemModel.c"
}

static void
mail_conversation_item_model_class_init (MailConversationItemModelClass * klass,
                                         gpointer klass_data)
{
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	mail_conversation_item_model_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_type_class_adjust_private_offset (klass, &MailConversationItemModel_private_offset);
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_mail_conversation_item_model_get_property;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_mail_conversation_item_model_set_property;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	G_OBJECT_CLASS (klass)->constructor = mail_conversation_item_model_constructor;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	G_OBJECT_CLASS (klass)->finalize = mail_conversation_item_model_finalize;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_SERVICE_UID_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_SERVICE_UID_PROPERTY] = g_param_spec_string ("service-uid", "service-uid", "service-uid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_NODE_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_NODE_PROPERTY] = g_param_spec_pointer ("node", "node", "node", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_THREAD_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_THREAD_PROPERTY] = g_param_spec_boxed ("thread", "thread", "thread", camel_folder_thread_messages_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_TIMESTAMP_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_TIMESTAMP_PROPERTY] = g_param_spec_int64 ("timestamp", "timestamp", "timestamp", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_FOLDER_INFO_FLAGS_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_FOLDER_INFO_FLAGS_PROPERTY] = g_param_spec_flags ("folder-info-flags", "folder-info-flags", "folder-info-flags", camel_folder_info_flags_get_type (), 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_HIDDEN_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_HIDDEN_PROPERTY] = g_param_spec_boolean ("hidden", "hidden", "hidden", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_FORMATTED_DATE_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_FORMATTED_DATE_PROPERTY] = g_param_spec_string ("formatted-date", "formatted-date", "formatted-date", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_NUM_MESSAGES_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_NUM_MESSAGES_PROPERTY] = g_param_spec_uint ("num-messages", "num-messages", "num-messages", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_FROM_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_FROM_PROPERTY] = g_param_spec_string ("from", "from", "from", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_TO_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_TO_PROPERTY] = g_param_spec_string ("to", "to", "to", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_SUBJECT_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_SUBJECT_PROPERTY] = g_param_spec_string ("subject", "subject", "subject", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_FLAGGED_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_FLAGGED_PROPERTY] = g_param_spec_boolean ("flagged", "flagged", "flagged", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_FORWARDED_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_FORWARDED_PROPERTY] = g_param_spec_boolean ("forwarded", "forwarded", "forwarded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_REPLIED_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_REPLIED_PROPERTY] = g_param_spec_boolean ("replied", "replied", "replied", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_REPLIED_ALL_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_REPLIED_ALL_PROPERTY] = g_param_spec_boolean ("replied-all", "replied-all", "replied-all", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_UNREAD_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_UNREAD_PROPERTY] = g_param_spec_boolean ("unread", "unread", "unread", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_CONVERSATION_ITEM_MODEL_DELETED_PROPERTY, mail_conversation_item_model_properties[MAIL_CONVERSATION_ITEM_MODEL_DELETED_PROPERTY] = g_param_spec_boolean ("deleted", "deleted", "deleted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1884 "ConversationItemModel.c"
}

static void
mail_conversation_item_model_instance_init (MailConversationItemModel * self,
                                            gpointer klass)
{
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	self->priv = mail_conversation_item_model_get_instance_private (self);
#line 29 "../src/ConversationList/ConversationItemModel.vala"
	self->priv->_hidden = FALSE;
#line 1895 "ConversationItemModel.c"
}

static void
mail_conversation_item_model_finalize (GObject * obj)
{
	MailConversationItemModel * self;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_CONVERSATION_ITEM_MODEL, MailConversationItemModel);
#line 24 "../src/ConversationList/ConversationItemModel.vala"
	_g_free0 (self->priv->_service_uid);
#line 26 "../src/ConversationList/ConversationItemModel.vala"
	_camel_folder_thread_messages_unref0 (self->priv->_thread);
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	G_OBJECT_CLASS (mail_conversation_item_model_parent_class)->finalize (obj);
#line 1910 "ConversationItemModel.c"
}

static GType
mail_conversation_item_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailConversationItemModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_conversation_item_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailConversationItemModel), 0, (GInstanceInitFunc) mail_conversation_item_model_instance_init, NULL };
	GType mail_conversation_item_model_type_id;
	mail_conversation_item_model_type_id = g_type_register_static (G_TYPE_OBJECT, "MailConversationItemModel", &g_define_type_info, 0);
	MailConversationItemModel_private_offset = g_type_add_instance_private (mail_conversation_item_model_type_id, sizeof (MailConversationItemModelPrivate));
	return mail_conversation_item_model_type_id;
}

GType
mail_conversation_item_model_get_type (void)
{
	static volatile gsize mail_conversation_item_model_type_id__once = 0;
	if (g_once_init_enter (&mail_conversation_item_model_type_id__once)) {
		GType mail_conversation_item_model_type_id;
		mail_conversation_item_model_type_id = mail_conversation_item_model_get_type_once ();
		g_once_init_leave (&mail_conversation_item_model_type_id__once, mail_conversation_item_model_type_id);
	}
	return mail_conversation_item_model_type_id__once;
}

static void
_vala_mail_conversation_item_model_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	MailConversationItemModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_TYPE_CONVERSATION_ITEM_MODEL, MailConversationItemModel);
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	switch (property_id) {
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_SERVICE_UID_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_string (value, mail_conversation_item_model_get_service_uid (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_NODE_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_pointer (value, mail_conversation_item_model_get_node (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_THREAD_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_boxed (value, mail_conversation_item_model_get_thread (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_TIMESTAMP_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_int64 (value, mail_conversation_item_model_get_timestamp (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_FOLDER_INFO_FLAGS_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_flags (value, mail_conversation_item_model_get_folder_info_flags (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_HIDDEN_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_boolean (value, mail_conversation_item_model_get_hidden (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_FORMATTED_DATE_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_take_string (value, mail_conversation_item_model_get_formatted_date (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_NUM_MESSAGES_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_uint (value, mail_conversation_item_model_get_num_messages (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_FROM_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_take_string (value, mail_conversation_item_model_get_from (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_TO_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_take_string (value, mail_conversation_item_model_get_to (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_SUBJECT_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_string (value, mail_conversation_item_model_get_subject (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_FLAGGED_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_boolean (value, mail_conversation_item_model_get_flagged (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_FORWARDED_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_boolean (value, mail_conversation_item_model_get_forwarded (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_REPLIED_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_boolean (value, mail_conversation_item_model_get_replied (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_REPLIED_ALL_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_boolean (value, mail_conversation_item_model_get_replied_all (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_UNREAD_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_boolean (value, mail_conversation_item_model_get_unread (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_DELETED_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		g_value_set_boolean (value, mail_conversation_item_model_get_deleted (self));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 2047 "ConversationItemModel.c"
		default:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 2053 "ConversationItemModel.c"
	}
}

static void
_vala_mail_conversation_item_model_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	MailConversationItemModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_TYPE_CONVERSATION_ITEM_MODEL, MailConversationItemModel);
#line 23 "../src/ConversationList/ConversationItemModel.vala"
	switch (property_id) {
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_SERVICE_UID_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		mail_conversation_item_model_set_service_uid (self, g_value_get_string (value));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_NODE_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		mail_conversation_item_model_set_node (self, g_value_get_pointer (value));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_THREAD_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		mail_conversation_item_model_set_thread (self, g_value_get_boxed (value));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_TIMESTAMP_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		mail_conversation_item_model_set_timestamp (self, g_value_get_int64 (value));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_FOLDER_INFO_FLAGS_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		mail_conversation_item_model_set_folder_info_flags (self, g_value_get_flags (value));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		case MAIL_CONVERSATION_ITEM_MODEL_HIDDEN_PROPERTY:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		mail_conversation_item_model_set_hidden (self, g_value_get_boolean (value));
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 2103 "ConversationItemModel.c"
		default:
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/ConversationList/ConversationItemModel.vala"
		break;
#line 2109 "ConversationItemModel.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

