/* EditorToolbar.c generated by valac 0.56.14, the Vala compiler
 * generated from EditorToolbar.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2017-2023 elementary, Inc. (https://elementary.io)
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <webkit2/webkit2.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

#define EDITOR_TOOLBAR_ACTION_GROUP_PREFIX "editor-toolbar"
#define EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_GROUP_PREFIX "."
#define EDITOR_TOOLBAR_ACTION_BOLD "bold"
#define EDITOR_TOOLBAR_ACTION_ITALIC "italic"
#define EDITOR_TOOLBAR_ACTION_UNDERLINE "underline"
#define EDITOR_TOOLBAR_ACTION_STRIKETHROUGH "strikethrough"
#define EDITOR_TOOLBAR_ACTION_INSERT_LINK "insert-link"
#define EDITOR_TOOLBAR_ACTION_REMOVE_FORMAT "remove-formatting"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_EDITOR_TOOLBAR (editor_toolbar_get_type ())
#define EDITOR_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EDITOR_TOOLBAR, EditorToolbar))
#define EDITOR_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EDITOR_TOOLBAR, EditorToolbarClass))
#define IS_EDITOR_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EDITOR_TOOLBAR))
#define IS_EDITOR_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EDITOR_TOOLBAR))
#define EDITOR_TOOLBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EDITOR_TOOLBAR, EditorToolbarClass))

typedef struct _EditorToolbar EditorToolbar;
typedef struct _EditorToolbarClass EditorToolbarClass;
typedef struct _EditorToolbarPrivate EditorToolbarPrivate;

#define MAIL_TYPE_WEB_VIEW (mail_web_view_get_type ())
#define MAIL_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_WEB_VIEW, MailWebView))
#define MAIL_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_WEB_VIEW, MailWebViewClass))
#define MAIL_IS_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_WEB_VIEW))
#define MAIL_IS_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_WEB_VIEW))
#define MAIL_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_WEB_VIEW, MailWebViewClass))

typedef struct _MailWebView MailWebView;
typedef struct _MailWebViewClass MailWebViewClass;
enum  {
	EDITOR_TOOLBAR_0_PROPERTY,
	EDITOR_TOOLBAR_WEB_VIEW_PROPERTY,
	EDITOR_TOOLBAR_NUM_PROPERTIES
};
static GParamSpec* editor_toolbar_properties[EDITOR_TOOLBAR_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_INSERT_LINK_DIALOG (insert_link_dialog_get_type ())
#define INSERT_LINK_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INSERT_LINK_DIALOG, InsertLinkDialog))
#define INSERT_LINK_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INSERT_LINK_DIALOG, InsertLinkDialogClass))
#define IS_INSERT_LINK_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INSERT_LINK_DIALOG))
#define IS_INSERT_LINK_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INSERT_LINK_DIALOG))
#define INSERT_LINK_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INSERT_LINK_DIALOG, InsertLinkDialogClass))

typedef struct _InsertLinkDialog InsertLinkDialog;
typedef struct _InsertLinkDialogClass InsertLinkDialogClass;
typedef struct _EditorToolbarAskInsertLinkData EditorToolbarAskInsertLinkData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _EditorToolbar {
	GtkBox parent_instance;
	EditorToolbarPrivate * priv;
};

struct _EditorToolbarClass {
	GtkBoxClass parent_class;
};

struct _EditorToolbarPrivate {
	MailWebView* _web_view;
	GSimpleActionGroup* action_group;
};

struct _Block16Data {
	int _ref_count_;
	EditorToolbar* self;
	gchar* selected_text;
	gpointer _async_data_;
};

struct _EditorToolbarAskInsertLinkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	EditorToolbar* self;
	Block16Data* _data16_;
	MailWebView* _tmp0_;
	gchar* _tmp1_;
	InsertLinkDialog* insert_link_dialog;
	GtkWidget* _tmp2_;
	GtkWindow* _tmp3_;
	InsertLinkDialog* _tmp4_;
};

static gint EditorToolbar_private_offset;
static gpointer editor_toolbar_parent_class = NULL;

VALA_EXTERN GType editor_toolbar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditorToolbar, g_object_unref)
VALA_EXTERN GType mail_web_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailWebView, g_object_unref)
static void editor_toolbar_on_edit_action (EditorToolbar* self,
                                    GSimpleAction* action,
                                    GVariant* param);
static void _editor_toolbar_on_edit_action_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void editor_toolbar_on_insert_link_clicked (EditorToolbar* self);
static void _editor_toolbar_on_insert_link_clicked_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void editor_toolbar_on_remove_format (EditorToolbar* self);
static void _editor_toolbar_on_remove_format_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
VALA_EXTERN EditorToolbar* editor_toolbar_new (MailWebView* web_view);
VALA_EXTERN EditorToolbar* editor_toolbar_construct (GType object_type,
                                         MailWebView* web_view);
static void editor_toolbar_ask_insert_link (EditorToolbar* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static void editor_toolbar_ask_insert_link_finish (EditorToolbar* self,
                                            GAsyncResult* _res_);
static void editor_toolbar_ask_insert_link_data_free (gpointer _data);
static gboolean editor_toolbar_ask_insert_link_co (EditorToolbarAskInsertLinkData* _data_);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
VALA_EXTERN MailWebView* editor_toolbar_get_web_view (EditorToolbar* self);
VALA_EXTERN void mail_web_view_get_selected_text (MailWebView* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gchar* mail_web_view_get_selected_text_finish (MailWebView* self,
                                               GAsyncResult* _res_);
static void editor_toolbar_ask_insert_link_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
VALA_EXTERN GType insert_link_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (InsertLinkDialog, g_object_unref)
VALA_EXTERN InsertLinkDialog* insert_link_dialog_new (const gchar* text);
VALA_EXTERN InsertLinkDialog* insert_link_dialog_construct (GType object_type,
                                                const gchar* text);
static void __lambda90_ (Block16Data* _data16_,
                  const gchar* url,
                  const gchar* title);
static void editor_toolbar_on_link_inserted (EditorToolbar* self,
                                      const gchar* url,
                                      const gchar* title,
                                      const gchar* selected_text);
static void ___lambda90__insert_link_dialog_insert_link (InsertLinkDialog* _sender,
                                                  const gchar* url,
                                                  const gchar* title,
                                                  gpointer self);
VALA_EXTERN void mail_web_view_execute_editor_command (MailWebView* self,
                                           const gchar* command,
                                           const gchar* argument);
static void editor_toolbar_update_actions (EditorToolbar* self);
VALA_EXTERN void mail_web_view_query_command_state (MailWebView* self,
                                        const gchar* command,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
VALA_EXTERN gboolean mail_web_view_query_command_state_finish (MailWebView* self,
                                                   GAsyncResult* _res_);
static void __lambda84_ (EditorToolbar* self,
                  GObject* obj,
                  GAsyncResult* res);
static GVariant* _variant_new4 (const gchar* value);
static void ___lambda84__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda85_ (EditorToolbar* self,
                  GObject* obj,
                  GAsyncResult* res);
static GVariant* _variant_new5 (const gchar* value);
static void ___lambda85__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda86_ (EditorToolbar* self,
                  GObject* obj,
                  GAsyncResult* res);
static GVariant* _variant_new6 (const gchar* value);
static void ___lambda86__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda87_ (EditorToolbar* self,
                  GObject* obj,
                  GAsyncResult* res);
static GVariant* _variant_new7 (const gchar* value);
static void ___lambda87__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void editor_toolbar_set_web_view (EditorToolbar* self,
                                  MailWebView* value);
static GObject * editor_toolbar_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static GVariant* _variant_new8 (const gchar* value);
static GVariant* _variant_new9 (const gchar* value);
static GVariant* _variant_new10 (const gchar* value);
static GVariant* _variant_new11 (const gchar* value);
static GVariant* _variant_new12 (const gchar* value);
static GVariant* _variant_new13 (const gchar* value);
static GVariant* _variant_new14 (const gchar* value);
static GVariant* _variant_new15 (const gchar* value);
static void _editor_toolbar___lambda91_ (EditorToolbar* self);
static void __editor_toolbar___lambda91__gtk_widget_map (GtkWidget* _sender,
                                                  gpointer self);
static void _editor_toolbar_update_actions_mail_web_view_selection_changed (MailWebView* _sender,
                                                                     gpointer self);
static void editor_toolbar_finalize (GObject * obj);
static GType editor_toolbar_get_type_once (void);
static void _vala_editor_toolbar_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_editor_toolbar_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GActionEntry EDITOR_TOOLBAR_ACTION_ENTRIES[6] = {{EDITOR_TOOLBAR_ACTION_BOLD, _editor_toolbar_on_edit_action_gsimple_action_activate_callback, "s", "''"}, {EDITOR_TOOLBAR_ACTION_ITALIC, _editor_toolbar_on_edit_action_gsimple_action_activate_callback, "s", "''"}, {EDITOR_TOOLBAR_ACTION_UNDERLINE, _editor_toolbar_on_edit_action_gsimple_action_activate_callback, "s", "''"}, {EDITOR_TOOLBAR_ACTION_STRIKETHROUGH, _editor_toolbar_on_edit_action_gsimple_action_activate_callback, "s", "''"}, {EDITOR_TOOLBAR_ACTION_INSERT_LINK, _editor_toolbar_on_insert_link_clicked_gsimple_action_activate_callback}, {EDITOR_TOOLBAR_ACTION_REMOVE_FORMAT, _editor_toolbar_on_remove_format_gsimple_action_activate_callback}};

static inline gpointer
editor_toolbar_get_instance_private (EditorToolbar* self)
{
	return G_STRUCT_MEMBER_P (self, EditorToolbar_private_offset);
}

static void
_editor_toolbar_on_edit_action_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 17 "../src/EditorToolbar.vala"
	editor_toolbar_on_edit_action ((EditorToolbar*) self, action, parameter);
#line 264 "EditorToolbar.c"
}

static void
_editor_toolbar_on_insert_link_clicked_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 17 "../src/EditorToolbar.vala"
	editor_toolbar_on_insert_link_clicked ((EditorToolbar*) self);
#line 274 "EditorToolbar.c"
}

static void
_editor_toolbar_on_remove_format_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 17 "../src/EditorToolbar.vala"
	editor_toolbar_on_remove_format ((EditorToolbar*) self);
#line 284 "EditorToolbar.c"
}

EditorToolbar*
editor_toolbar_construct (GType object_type,
                          MailWebView* web_view)
{
	EditorToolbar * self = NULL;
#line 30 "../src/EditorToolbar.vala"
	g_return_val_if_fail (web_view != NULL, NULL);
#line 31 "../src/EditorToolbar.vala"
	self = (EditorToolbar*) g_object_new (object_type, "web-view", web_view, NULL);
#line 30 "../src/EditorToolbar.vala"
	return self;
#line 298 "EditorToolbar.c"
}

EditorToolbar*
editor_toolbar_new (MailWebView* web_view)
{
#line 30 "../src/EditorToolbar.vala"
	return editor_toolbar_construct (TYPE_EDITOR_TOOLBAR, web_view);
#line 306 "EditorToolbar.c"
}

static void
editor_toolbar_on_insert_link_clicked (EditorToolbar* self)
{
#line 127 "../src/EditorToolbar.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/EditorToolbar.vala"
	editor_toolbar_ask_insert_link (self, NULL, NULL);
#line 316 "EditorToolbar.c"
}

static void
editor_toolbar_ask_insert_link_data_free (gpointer _data)
{
	EditorToolbarAskInsertLinkData* _data_;
	_data_ = _data;
#line 6 "../src/EditorToolbar.vala"
	_g_object_unref0 (_data_->self);
#line 6 "../src/EditorToolbar.vala"
	g_slice_free (EditorToolbarAskInsertLinkData, _data_);
#line 328 "EditorToolbar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 6 "../src/EditorToolbar.vala"
	return self ? g_object_ref (self) : NULL;
#line 336 "EditorToolbar.c"
}

static void
editor_toolbar_ask_insert_link (EditorToolbar* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	EditorToolbarAskInsertLinkData* _data_;
	EditorToolbar* _tmp0_;
#line 6 "../src/EditorToolbar.vala"
	g_return_if_fail (self != NULL);
#line 6 "../src/EditorToolbar.vala"
	_data_ = g_slice_new0 (EditorToolbarAskInsertLinkData);
#line 6 "../src/EditorToolbar.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 6 "../src/EditorToolbar.vala"
	g_task_set_task_data (_data_->_async_result, _data_, editor_toolbar_ask_insert_link_data_free);
#line 6 "../src/EditorToolbar.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 6 "../src/EditorToolbar.vala"
	_data_->self = _tmp0_;
#line 6 "../src/EditorToolbar.vala"
	editor_toolbar_ask_insert_link_co (_data_);
#line 360 "EditorToolbar.c"
}

static void
editor_toolbar_ask_insert_link_finish (EditorToolbar* self,
                                       GAsyncResult* _res_)
{
	EditorToolbarAskInsertLinkData* _data_;
#line 6 "../src/EditorToolbar.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 370 "EditorToolbar.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 131 "../src/EditorToolbar.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 131 "../src/EditorToolbar.vala"
	return _data16_;
#line 380 "EditorToolbar.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 131 "../src/EditorToolbar.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 390 "EditorToolbar.c"
		EditorToolbar* self;
#line 131 "../src/EditorToolbar.vala"
		self = _data16_->self;
#line 131 "../src/EditorToolbar.vala"
		_g_free0 (_data16_->selected_text);
#line 131 "../src/EditorToolbar.vala"
		_g_object_unref0 (self);
#line 131 "../src/EditorToolbar.vala"
		g_slice_free (Block16Data, _data16_);
#line 400 "EditorToolbar.c"
	}
}

static void
editor_toolbar_ask_insert_link_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	EditorToolbarAskInsertLinkData* _data_;
#line 132 "../src/EditorToolbar.vala"
	_data_ = _user_data_;
#line 132 "../src/EditorToolbar.vala"
	_data_->_source_object_ = source_object;
#line 132 "../src/EditorToolbar.vala"
	_data_->_res_ = _res_;
#line 132 "../src/EditorToolbar.vala"
	editor_toolbar_ask_insert_link_co (_data_);
#line 418 "EditorToolbar.c"
}

static void
__lambda90_ (Block16Data* _data16_,
             const gchar* url,
             const gchar* title)
{
	EditorToolbar* self;
#line 137 "../src/EditorToolbar.vala"
	self = _data16_->self;
#line 137 "../src/EditorToolbar.vala"
	g_return_if_fail (url != NULL);
#line 137 "../src/EditorToolbar.vala"
	g_return_if_fail (title != NULL);
#line 137 "../src/EditorToolbar.vala"
	editor_toolbar_on_link_inserted (self, url, title, _data16_->selected_text);
#line 435 "EditorToolbar.c"
}

static void
___lambda90__insert_link_dialog_insert_link (InsertLinkDialog* _sender,
                                             const gchar* url,
                                             const gchar* title,
                                             gpointer self)
{
#line 137 "../src/EditorToolbar.vala"
	__lambda90_ (self, url, title);
#line 446 "EditorToolbar.c"
}

static gboolean
editor_toolbar_ask_insert_link_co (EditorToolbarAskInsertLinkData* _data_)
{
#line 131 "../src/EditorToolbar.vala"
	switch (_data_->_state_) {
#line 131 "../src/EditorToolbar.vala"
		case 0:
#line 456 "EditorToolbar.c"
		goto _state_0;
#line 131 "../src/EditorToolbar.vala"
		case 1:
#line 460 "EditorToolbar.c"
		goto _state_1;
		default:
#line 131 "../src/EditorToolbar.vala"
		g_assert_not_reached ();
#line 465 "EditorToolbar.c"
	}
	_state_0:
#line 131 "../src/EditorToolbar.vala"
	_data_->_data16_ = g_slice_new0 (Block16Data);
#line 131 "../src/EditorToolbar.vala"
	_data_->_data16_->_ref_count_ = 1;
#line 131 "../src/EditorToolbar.vala"
	_data_->_data16_->self = g_object_ref (_data_->self);
#line 131 "../src/EditorToolbar.vala"
	_data_->_data16_->_async_data_ = _data_;
#line 132 "../src/EditorToolbar.vala"
	_data_->_tmp0_ = _data_->self->priv->_web_view;
#line 132 "../src/EditorToolbar.vala"
	_data_->_state_ = 1;
#line 132 "../src/EditorToolbar.vala"
	mail_web_view_get_selected_text (_data_->_tmp0_, editor_toolbar_ask_insert_link_ready, _data_);
#line 132 "../src/EditorToolbar.vala"
	return FALSE;
#line 484 "EditorToolbar.c"
	_state_1:
#line 132 "../src/EditorToolbar.vala"
	_data_->_tmp1_ = mail_web_view_get_selected_text_finish (_data_->_tmp0_, _data_->_res_);
#line 132 "../src/EditorToolbar.vala"
	_data_->_data16_->selected_text = _data_->_tmp1_;
#line 133 "../src/EditorToolbar.vala"
	_data_->_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) _data_->self);
#line 133 "../src/EditorToolbar.vala"
	_data_->_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, gtk_window_get_type (), GtkWindow));
#line 133 "../src/EditorToolbar.vala"
	_data_->_tmp4_ = NULL;
#line 133 "../src/EditorToolbar.vala"
	_data_->_tmp4_ = insert_link_dialog_new (_data_->_data16_->selected_text);
#line 133 "../src/EditorToolbar.vala"
	gtk_window_set_transient_for ((GtkWindow*) _data_->_tmp4_, _data_->_tmp3_);
#line 133 "../src/EditorToolbar.vala"
	_g_object_unref0 (_data_->_tmp3_);
#line 133 "../src/EditorToolbar.vala"
	g_object_ref_sink (_data_->_tmp4_);
#line 133 "../src/EditorToolbar.vala"
	_data_->insert_link_dialog = _data_->_tmp4_;
#line 136 "../src/EditorToolbar.vala"
	gtk_window_present ((GtkWindow*) _data_->insert_link_dialog);
#line 137 "../src/EditorToolbar.vala"
	g_signal_connect_data (_data_->insert_link_dialog, "insert-link", (GCallback) ___lambda90__insert_link_dialog_insert_link, block16_data_ref (_data_->_data16_), (GClosureNotify) block16_data_unref, 0);
#line 131 "../src/EditorToolbar.vala"
	_g_object_unref0 (_data_->insert_link_dialog);
#line 131 "../src/EditorToolbar.vala"
	block16_data_unref (_data_->_data16_);
#line 131 "../src/EditorToolbar.vala"
	_data_->_data16_ = NULL;
#line 131 "../src/EditorToolbar.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 131 "../src/EditorToolbar.vala"
	if (_data_->_state_ != 0) {
#line 131 "../src/EditorToolbar.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 131 "../src/EditorToolbar.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 524 "EditorToolbar.c"
		}
	}
#line 131 "../src/EditorToolbar.vala"
	g_object_unref (_data_->_async_result);
#line 131 "../src/EditorToolbar.vala"
	return FALSE;
#line 531 "EditorToolbar.c"
}

static void
editor_toolbar_on_link_inserted (EditorToolbar* self,
                                 const gchar* url,
                                 const gchar* title,
                                 const gchar* selected_text)
{
	gboolean _tmp0_ = FALSE;
#line 140 "../src/EditorToolbar.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/EditorToolbar.vala"
	g_return_if_fail (url != NULL);
#line 140 "../src/EditorToolbar.vala"
	g_return_if_fail (title != NULL);
#line 141 "../src/EditorToolbar.vala"
	if (selected_text != NULL) {
#line 141 "../src/EditorToolbar.vala"
		_tmp0_ = g_strcmp0 (title, selected_text) == 0;
#line 551 "EditorToolbar.c"
	} else {
#line 141 "../src/EditorToolbar.vala"
		_tmp0_ = FALSE;
#line 555 "EditorToolbar.c"
	}
#line 141 "../src/EditorToolbar.vala"
	if (_tmp0_) {
#line 559 "EditorToolbar.c"
		MailWebView* _tmp1_;
#line 142 "../src/EditorToolbar.vala"
		_tmp1_ = self->priv->_web_view;
#line 142 "../src/EditorToolbar.vala"
		mail_web_view_execute_editor_command (_tmp1_, "createLink", url);
#line 565 "EditorToolbar.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 144 "../src/EditorToolbar.vala"
		if (title != NULL) {
#line 570 "EditorToolbar.c"
			gint _tmp3_;
			gint _tmp4_;
#line 144 "../src/EditorToolbar.vala"
			_tmp3_ = strlen (title);
#line 144 "../src/EditorToolbar.vala"
			_tmp4_ = _tmp3_;
#line 144 "../src/EditorToolbar.vala"
			_tmp2_ = _tmp4_ > 0;
#line 579 "EditorToolbar.c"
		} else {
#line 144 "../src/EditorToolbar.vala"
			_tmp2_ = FALSE;
#line 583 "EditorToolbar.c"
		}
#line 144 "../src/EditorToolbar.vala"
		if (_tmp2_) {
#line 587 "EditorToolbar.c"
			MailWebView* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 145 "../src/EditorToolbar.vala"
			_tmp5_ = self->priv->_web_view;
#line 145 "../src/EditorToolbar.vala"
			_tmp6_ = g_strdup_printf ("<a href=\"%s\">%s</a>", url, title);
#line 145 "../src/EditorToolbar.vala"
			_tmp7_ = _tmp6_;
#line 145 "../src/EditorToolbar.vala"
			mail_web_view_execute_editor_command (_tmp5_, "insertHTML", _tmp7_);
#line 145 "../src/EditorToolbar.vala"
			_g_free0 (_tmp7_);
#line 601 "EditorToolbar.c"
		} else {
			MailWebView* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 147 "../src/EditorToolbar.vala"
			_tmp8_ = self->priv->_web_view;
#line 147 "../src/EditorToolbar.vala"
			_tmp9_ = g_strdup_printf ("<a href=\"%s\">%s</a>", url, url);
#line 147 "../src/EditorToolbar.vala"
			_tmp10_ = _tmp9_;
#line 147 "../src/EditorToolbar.vala"
			mail_web_view_execute_editor_command (_tmp8_, "insertHTML", _tmp10_);
#line 147 "../src/EditorToolbar.vala"
			_g_free0 (_tmp10_);
#line 616 "EditorToolbar.c"
		}
	}
}

static void
editor_toolbar_on_edit_action (EditorToolbar* self,
                               GSimpleAction* action,
                               GVariant* param)
{
	gchar* command = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	MailWebView* _tmp2_;
#line 152 "../src/EditorToolbar.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/EditorToolbar.vala"
	g_return_if_fail (action != NULL);
#line 153 "../src/EditorToolbar.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 153 "../src/EditorToolbar.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 153 "../src/EditorToolbar.vala"
	command = _tmp1_;
#line 154 "../src/EditorToolbar.vala"
	_tmp2_ = self->priv->_web_view;
#line 154 "../src/EditorToolbar.vala"
	mail_web_view_execute_editor_command (_tmp2_, command, "");
#line 155 "../src/EditorToolbar.vala"
	editor_toolbar_update_actions (self);
#line 152 "../src/EditorToolbar.vala"
	_g_free0 (command);
#line 648 "EditorToolbar.c"
}

static void
editor_toolbar_on_remove_format (EditorToolbar* self)
{
	MailWebView* _tmp0_;
	MailWebView* _tmp1_;
#line 158 "../src/EditorToolbar.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/EditorToolbar.vala"
	_tmp0_ = self->priv->_web_view;
#line 159 "../src/EditorToolbar.vala"
	mail_web_view_execute_editor_command (_tmp0_, "removeformat", "");
#line 160 "../src/EditorToolbar.vala"
	_tmp1_ = self->priv->_web_view;
#line 160 "../src/EditorToolbar.vala"
	mail_web_view_execute_editor_command (_tmp1_, "unlink", "");
#line 666 "EditorToolbar.c"
}

static GVariant*
_variant_new4 (const gchar* value)
{
#line 165 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 674 "EditorToolbar.c"
}

static void
__lambda84_ (EditorToolbar* self,
             GObject* obj,
             GAsyncResult* res)
{
	const gchar* _tmp0_ = NULL;
	MailWebView* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GVariant* _tmp3_;
#line 164 "../src/EditorToolbar.vala"
	g_return_if_fail (res != NULL);
#line 167 "../src/EditorToolbar.vala"
	_tmp1_ = self->priv->_web_view;
#line 167 "../src/EditorToolbar.vala"
	if (mail_web_view_query_command_state_finish (_tmp1_, res)) {
#line 167 "../src/EditorToolbar.vala"
		_tmp0_ = EDITOR_TOOLBAR_ACTION_BOLD;
#line 694 "EditorToolbar.c"
	} else {
#line 167 "../src/EditorToolbar.vala"
		_tmp0_ = "";
#line 698 "EditorToolbar.c"
	}
#line 165 "../src/EditorToolbar.vala"
	_tmp2_ = self->priv->action_group;
#line 165 "../src/EditorToolbar.vala"
	_tmp3_ = _variant_new4 (_tmp0_);
#line 165 "../src/EditorToolbar.vala"
	g_action_group_change_action_state ((GActionGroup*) _tmp2_, EDITOR_TOOLBAR_ACTION_BOLD, _tmp3_);
#line 165 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp3_);
#line 708 "EditorToolbar.c"
}

static void
___lambda84__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 164 "../src/EditorToolbar.vala"
	__lambda84_ ((EditorToolbar*) self, source_object, res);
#line 164 "../src/EditorToolbar.vala"
	g_object_unref (self);
#line 720 "EditorToolbar.c"
}

static GVariant*
_variant_new5 (const gchar* value)
{
#line 171 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 728 "EditorToolbar.c"
}

static void
__lambda85_ (EditorToolbar* self,
             GObject* obj,
             GAsyncResult* res)
{
	const gchar* _tmp0_ = NULL;
	MailWebView* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GVariant* _tmp3_;
#line 170 "../src/EditorToolbar.vala"
	g_return_if_fail (res != NULL);
#line 173 "../src/EditorToolbar.vala"
	_tmp1_ = self->priv->_web_view;
#line 173 "../src/EditorToolbar.vala"
	if (mail_web_view_query_command_state_finish (_tmp1_, res)) {
#line 173 "../src/EditorToolbar.vala"
		_tmp0_ = EDITOR_TOOLBAR_ACTION_ITALIC;
#line 748 "EditorToolbar.c"
	} else {
#line 173 "../src/EditorToolbar.vala"
		_tmp0_ = "";
#line 752 "EditorToolbar.c"
	}
#line 171 "../src/EditorToolbar.vala"
	_tmp2_ = self->priv->action_group;
#line 171 "../src/EditorToolbar.vala"
	_tmp3_ = _variant_new5 (_tmp0_);
#line 171 "../src/EditorToolbar.vala"
	g_action_group_change_action_state ((GActionGroup*) _tmp2_, EDITOR_TOOLBAR_ACTION_ITALIC, _tmp3_);
#line 171 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp3_);
#line 762 "EditorToolbar.c"
}

static void
___lambda85__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 170 "../src/EditorToolbar.vala"
	__lambda85_ ((EditorToolbar*) self, source_object, res);
#line 170 "../src/EditorToolbar.vala"
	g_object_unref (self);
#line 774 "EditorToolbar.c"
}

static GVariant*
_variant_new6 (const gchar* value)
{
#line 177 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 782 "EditorToolbar.c"
}

static void
__lambda86_ (EditorToolbar* self,
             GObject* obj,
             GAsyncResult* res)
{
	const gchar* _tmp0_ = NULL;
	MailWebView* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GVariant* _tmp3_;
#line 176 "../src/EditorToolbar.vala"
	g_return_if_fail (res != NULL);
#line 178 "../src/EditorToolbar.vala"
	_tmp1_ = self->priv->_web_view;
#line 178 "../src/EditorToolbar.vala"
	if (mail_web_view_query_command_state_finish (_tmp1_, res)) {
#line 178 "../src/EditorToolbar.vala"
		_tmp0_ = EDITOR_TOOLBAR_ACTION_UNDERLINE;
#line 802 "EditorToolbar.c"
	} else {
#line 178 "../src/EditorToolbar.vala"
		_tmp0_ = "";
#line 806 "EditorToolbar.c"
	}
#line 177 "../src/EditorToolbar.vala"
	_tmp2_ = self->priv->action_group;
#line 177 "../src/EditorToolbar.vala"
	_tmp3_ = _variant_new6 (_tmp0_);
#line 177 "../src/EditorToolbar.vala"
	g_action_group_change_action_state ((GActionGroup*) _tmp2_, EDITOR_TOOLBAR_ACTION_UNDERLINE, _tmp3_);
#line 177 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp3_);
#line 816 "EditorToolbar.c"
}

static void
___lambda86__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 176 "../src/EditorToolbar.vala"
	__lambda86_ ((EditorToolbar*) self, source_object, res);
#line 176 "../src/EditorToolbar.vala"
	g_object_unref (self);
#line 828 "EditorToolbar.c"
}

static GVariant*
_variant_new7 (const gchar* value)
{
#line 182 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 836 "EditorToolbar.c"
}

static void
__lambda87_ (EditorToolbar* self,
             GObject* obj,
             GAsyncResult* res)
{
	const gchar* _tmp0_ = NULL;
	MailWebView* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GVariant* _tmp3_;
#line 181 "../src/EditorToolbar.vala"
	g_return_if_fail (res != NULL);
#line 184 "../src/EditorToolbar.vala"
	_tmp1_ = self->priv->_web_view;
#line 184 "../src/EditorToolbar.vala"
	if (mail_web_view_query_command_state_finish (_tmp1_, res)) {
#line 184 "../src/EditorToolbar.vala"
		_tmp0_ = EDITOR_TOOLBAR_ACTION_STRIKETHROUGH;
#line 856 "EditorToolbar.c"
	} else {
#line 184 "../src/EditorToolbar.vala"
		_tmp0_ = "";
#line 860 "EditorToolbar.c"
	}
#line 182 "../src/EditorToolbar.vala"
	_tmp2_ = self->priv->action_group;
#line 182 "../src/EditorToolbar.vala"
	_tmp3_ = _variant_new7 (_tmp0_);
#line 182 "../src/EditorToolbar.vala"
	g_action_group_change_action_state ((GActionGroup*) _tmp2_, EDITOR_TOOLBAR_ACTION_STRIKETHROUGH, _tmp3_);
#line 182 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp3_);
#line 870 "EditorToolbar.c"
}

static void
___lambda87__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 181 "../src/EditorToolbar.vala"
	__lambda87_ ((EditorToolbar*) self, source_object, res);
#line 181 "../src/EditorToolbar.vala"
	g_object_unref (self);
#line 882 "EditorToolbar.c"
}

static void
editor_toolbar_update_actions (EditorToolbar* self)
{
	MailWebView* _tmp0_;
	MailWebView* _tmp1_;
	MailWebView* _tmp2_;
	MailWebView* _tmp3_;
#line 163 "../src/EditorToolbar.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/EditorToolbar.vala"
	_tmp0_ = self->priv->_web_view;
#line 164 "../src/EditorToolbar.vala"
	mail_web_view_query_command_state (_tmp0_, "bold", ___lambda84__gasync_ready_callback, g_object_ref (self));
#line 170 "../src/EditorToolbar.vala"
	_tmp1_ = self->priv->_web_view;
#line 170 "../src/EditorToolbar.vala"
	mail_web_view_query_command_state (_tmp1_, "italic", ___lambda85__gasync_ready_callback, g_object_ref (self));
#line 176 "../src/EditorToolbar.vala"
	_tmp2_ = self->priv->_web_view;
#line 176 "../src/EditorToolbar.vala"
	mail_web_view_query_command_state (_tmp2_, "underline", ___lambda86__gasync_ready_callback, g_object_ref (self));
#line 181 "../src/EditorToolbar.vala"
	_tmp3_ = self->priv->_web_view;
#line 181 "../src/EditorToolbar.vala"
	mail_web_view_query_command_state (_tmp3_, "strikethrough", ___lambda87__gasync_ready_callback, g_object_ref (self));
#line 910 "EditorToolbar.c"
}

MailWebView*
editor_toolbar_get_web_view (EditorToolbar* self)
{
	MailWebView* result;
	MailWebView* _tmp0_;
#line 26 "../src/EditorToolbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/EditorToolbar.vala"
	_tmp0_ = self->priv->_web_view;
#line 26 "../src/EditorToolbar.vala"
	result = _tmp0_;
#line 26 "../src/EditorToolbar.vala"
	return result;
#line 926 "EditorToolbar.c"
}

static void
editor_toolbar_set_web_view (EditorToolbar* self,
                             MailWebView* value)
{
	MailWebView* old_value;
#line 26 "../src/EditorToolbar.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/EditorToolbar.vala"
	old_value = editor_toolbar_get_web_view (self);
#line 26 "../src/EditorToolbar.vala"
	if (old_value != value) {
#line 940 "EditorToolbar.c"
		MailWebView* _tmp0_;
#line 26 "../src/EditorToolbar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../src/EditorToolbar.vala"
		_g_object_unref0 (self->priv->_web_view);
#line 26 "../src/EditorToolbar.vala"
		self->priv->_web_view = _tmp0_;
#line 26 "../src/EditorToolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, editor_toolbar_properties[EDITOR_TOOLBAR_WEB_VIEW_PROPERTY]);
#line 950 "EditorToolbar.c"
	}
}

static GVariant*
_variant_new8 (const gchar* value)
{
#line 42 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 959 "EditorToolbar.c"
}

static GVariant*
_variant_new9 (const gchar* value)
{
#line 46 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 967 "EditorToolbar.c"
}

static GVariant*
_variant_new10 (const gchar* value)
{
#line 51 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 975 "EditorToolbar.c"
}

static GVariant*
_variant_new11 (const gchar* value)
{
#line 58 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 983 "EditorToolbar.c"
}

static GVariant*
_variant_new12 (const gchar* value)
{
#line 65 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 991 "EditorToolbar.c"
}

static GVariant*
_variant_new13 (const gchar* value)
{
#line 65 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 999 "EditorToolbar.c"
}

static GVariant*
_variant_new14 (const gchar* value)
{
#line 77 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1007 "EditorToolbar.c"
}

static GVariant*
_variant_new15 (const gchar* value)
{
#line 77 "../src/EditorToolbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1015 "EditorToolbar.c"
}

static void
_editor_toolbar___lambda91_ (EditorToolbar* self)
{
	GtkWidget* _tmp0_;
	GSimpleActionGroup* _tmp1_;
#line 121 "../src/EditorToolbar.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 121 "../src/EditorToolbar.vala"
	_tmp1_ = self->priv->action_group;
#line 121 "../src/EditorToolbar.vala"
	gtk_widget_insert_action_group (_tmp0_, EDITOR_TOOLBAR_ACTION_GROUP_PREFIX, (GActionGroup*) _tmp1_);
#line 1029 "EditorToolbar.c"
}

static void
__editor_toolbar___lambda91__gtk_widget_map (GtkWidget* _sender,
                                             gpointer self)
{
#line 120 "../src/EditorToolbar.vala"
	_editor_toolbar___lambda91_ ((EditorToolbar*) self);
#line 1038 "EditorToolbar.c"
}

static void
_editor_toolbar_update_actions_mail_web_view_selection_changed (MailWebView* _sender,
                                                                gpointer self)
{
#line 124 "../src/EditorToolbar.vala"
	editor_toolbar_update_actions ((EditorToolbar*) self);
#line 1047 "EditorToolbar.c"
}

static GObject *
editor_toolbar_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	EditorToolbar * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GtkApplication* application = NULL;
	GApplication* _tmp2_;
	GtkApplication* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GtkApplication* _tmp7_;
	GVariant* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GtkApplication* _tmp14_;
	GVariant* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	GtkToggleButton* bold = NULL;
	gchar* _tmp21_;
	GVariant* _tmp22_;
	GtkImage* _tmp23_;
	gchar* _tmp24_;
	gchar** _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gchar* _tmp27_;
	GtkToggleButton* _tmp28_ = NULL;
	GtkToggleButton* _tmp29_;
	GtkToggleButton* italic = NULL;
	gchar* _tmp30_;
	GVariant* _tmp31_;
	GtkImage* _tmp32_;
	gchar* _tmp33_;
	gchar** _tmp34_;
	gchar** _tmp35_;
	gint _tmp35__length1;
	gchar* _tmp36_;
	GtkToggleButton* _tmp37_ = NULL;
	GtkToggleButton* _tmp38_;
	GtkToggleButton* underline = NULL;
	gchar* _tmp39_;
	GVariant* _tmp40_;
	GtkImage* _tmp41_;
	GtkApplication* _tmp42_;
	GVariant* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar** _tmp46_;
	gchar** _tmp47_;
	gchar** _tmp48_;
	gint _tmp48__length1;
	gchar* _tmp49_;
	GtkToggleButton* _tmp50_ = NULL;
	GtkToggleButton* _tmp51_;
	GtkToggleButton* strikethrough = NULL;
	gchar* _tmp52_;
	GVariant* _tmp53_;
	GtkImage* _tmp54_;
	GtkApplication* _tmp55_;
	GVariant* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar** _tmp59_;
	gchar** _tmp60_;
	gchar** _tmp61_;
	gint _tmp61__length1;
	gchar* _tmp62_;
	GtkToggleButton* _tmp63_ = NULL;
	GtkToggleButton* _tmp64_;
	GtkBox* formatting_buttons = NULL;
	GtkBox* _tmp65_;
	GtkBox* _tmp66_;
	GtkStyleContext* _tmp67_;
	GtkBox* _tmp68_;
	GtkToggleButton* _tmp69_;
	GtkBox* _tmp70_;
	GtkToggleButton* _tmp71_;
	GtkBox* _tmp72_;
	GtkToggleButton* _tmp73_;
	GtkBox* _tmp74_;
	GtkToggleButton* _tmp75_;
	GtkButton* clear_format = NULL;
	gchar* _tmp76_;
	GtkApplication* _tmp77_;
	gchar** _tmp78_;
	gchar** _tmp79_;
	gchar** _tmp80_;
	gint _tmp80__length1;
	gchar* _tmp81_;
	GtkButton* _tmp82_ = NULL;
	GtkButton* _tmp83_;
	GtkButton* link = NULL;
	gchar* _tmp84_;
	GtkApplication* _tmp85_;
	gchar** _tmp86_;
	gchar** _tmp87_;
	gchar** _tmp88_;
	gint _tmp88__length1;
	gchar* _tmp89_;
	GtkButton* _tmp90_ = NULL;
	GtkButton* _tmp91_;
	GtkBox* _tmp92_;
	GtkButton* _tmp93_;
	GtkButton* _tmp94_;
	MailWebView* _tmp95_;
#line 36 "../src/EditorToolbar.vala"
	parent_class = G_OBJECT_CLASS (editor_toolbar_parent_class);
#line 36 "../src/EditorToolbar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/EditorToolbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EDITOR_TOOLBAR, EditorToolbar);
#line 37 "../src/EditorToolbar.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 37 "../src/EditorToolbar.vala"
	_g_object_unref0 (self->priv->action_group);
#line 37 "../src/EditorToolbar.vala"
	self->priv->action_group = _tmp0_;
#line 38 "../src/EditorToolbar.vala"
	_tmp1_ = self->priv->action_group;
#line 38 "../src/EditorToolbar.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp1_, EDITOR_TOOLBAR_ACTION_ENTRIES, (gint) G_N_ELEMENTS (EDITOR_TOOLBAR_ACTION_ENTRIES), self);
#line 40 "../src/EditorToolbar.vala"
	_tmp2_ = g_application_get_default ();
#line 40 "../src/EditorToolbar.vala"
	application = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_application_get_type (), GtkApplication);
#line 41 "../src/EditorToolbar.vala"
	_tmp3_ = application;
#line 41 "../src/EditorToolbar.vala"
	_tmp4_ = g_strdup ("<Control>K");
#line 41 "../src/EditorToolbar.vala"
	_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 41 "../src/EditorToolbar.vala"
	_tmp5_[0] = _tmp4_;
#line 41 "../src/EditorToolbar.vala"
	_tmp6_ = _tmp5_;
#line 41 "../src/EditorToolbar.vala"
	_tmp6__length1 = 1;
#line 41 "../src/EditorToolbar.vala"
	gtk_application_set_accels_for_action (_tmp3_, EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_INSERT_LINK, _tmp6_);
#line 41 "../src/EditorToolbar.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 42 "../src/EditorToolbar.vala"
	_tmp7_ = application;
#line 42 "../src/EditorToolbar.vala"
	_tmp8_ = _variant_new8 (EDITOR_TOOLBAR_ACTION_STRIKETHROUGH);
#line 42 "../src/EditorToolbar.vala"
	_tmp9_ = g_action_print_detailed_name (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_STRIKETHROUGH, _tmp8_);
#line 42 "../src/EditorToolbar.vala"
	_tmp10_ = _tmp9_;
#line 42 "../src/EditorToolbar.vala"
	_tmp11_ = g_strdup ("<Control>percent");
#line 42 "../src/EditorToolbar.vala"
	_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 42 "../src/EditorToolbar.vala"
	_tmp12_[0] = _tmp11_;
#line 42 "../src/EditorToolbar.vala"
	_tmp13_ = _tmp12_;
#line 42 "../src/EditorToolbar.vala"
	_tmp13__length1 = 1;
#line 42 "../src/EditorToolbar.vala"
	gtk_application_set_accels_for_action (_tmp7_, _tmp10_, _tmp13_);
#line 42 "../src/EditorToolbar.vala"
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 42 "../src/EditorToolbar.vala"
	_g_free0 (_tmp10_);
#line 42 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp8_);
#line 46 "../src/EditorToolbar.vala"
	_tmp14_ = application;
#line 46 "../src/EditorToolbar.vala"
	_tmp15_ = _variant_new9 (EDITOR_TOOLBAR_ACTION_UNDERLINE);
#line 46 "../src/EditorToolbar.vala"
	_tmp16_ = g_action_print_detailed_name (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_UNDERLINE, _tmp15_);
#line 46 "../src/EditorToolbar.vala"
	_tmp17_ = _tmp16_;
#line 46 "../src/EditorToolbar.vala"
	_tmp18_ = g_strdup ("<Control>U");
#line 46 "../src/EditorToolbar.vala"
	_tmp19_ = g_new0 (gchar*, 1 + 1);
#line 46 "../src/EditorToolbar.vala"
	_tmp19_[0] = _tmp18_;
#line 46 "../src/EditorToolbar.vala"
	_tmp20_ = _tmp19_;
#line 46 "../src/EditorToolbar.vala"
	_tmp20__length1 = 1;
#line 46 "../src/EditorToolbar.vala"
	gtk_application_set_accels_for_action (_tmp14_, _tmp17_, _tmp20_);
#line 46 "../src/EditorToolbar.vala"
	_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 46 "../src/EditorToolbar.vala"
	_g_free0 (_tmp17_);
#line 46 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp15_);
#line 51 "../src/EditorToolbar.vala"
	_tmp21_ = g_strdup (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_BOLD);
#line 51 "../src/EditorToolbar.vala"
	_tmp22_ = _variant_new10 (EDITOR_TOOLBAR_ACTION_BOLD);
#line 51 "../src/EditorToolbar.vala"
	_tmp23_ = (GtkImage*) gtk_image_new_from_icon_name ("format-text-bold-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 51 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp23_);
#line 51 "../src/EditorToolbar.vala"
	_tmp24_ = g_strdup ("<Ctrl>B");
#line 51 "../src/EditorToolbar.vala"
	_tmp25_ = g_new0 (gchar*, 1 + 1);
#line 51 "../src/EditorToolbar.vala"
	_tmp25_[0] = _tmp24_;
#line 51 "../src/EditorToolbar.vala"
	_tmp26_ = _tmp25_;
#line 51 "../src/EditorToolbar.vala"
	_tmp26__length1 = 1;
#line 51 "../src/EditorToolbar.vala"
	_tmp27_ = granite_markup_accel_tooltip (_tmp26_, (gint) 1, _ ("Bold"));
#line 51 "../src/EditorToolbar.vala"
	_tmp28_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 51 "../src/EditorToolbar.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp28_, _tmp21_);
#line 51 "../src/EditorToolbar.vala"
	_g_free0 (_tmp21_);
#line 51 "../src/EditorToolbar.vala"
	g_object_set ((GtkActionable*) _tmp28_, "action-target", _tmp22_, NULL);
#line 51 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp22_);
#line 51 "../src/EditorToolbar.vala"
	gtk_button_set_image ((GtkButton*) _tmp28_, (GtkWidget*) _tmp23_);
#line 51 "../src/EditorToolbar.vala"
	_g_object_unref0 (_tmp23_);
#line 51 "../src/EditorToolbar.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp28_, _tmp27_);
#line 51 "../src/EditorToolbar.vala"
	_g_free0 (_tmp27_);
#line 51 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp28_);
#line 51 "../src/EditorToolbar.vala"
	_tmp29_ = _tmp28_;
#line 51 "../src/EditorToolbar.vala"
	_tmp26_ = (_vala_array_free (_tmp26_, _tmp26__length1, (GDestroyNotify) g_free), NULL);
#line 51 "../src/EditorToolbar.vala"
	bold = _tmp29_;
#line 58 "../src/EditorToolbar.vala"
	_tmp30_ = g_strdup (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_ITALIC);
#line 58 "../src/EditorToolbar.vala"
	_tmp31_ = _variant_new11 (EDITOR_TOOLBAR_ACTION_ITALIC);
#line 58 "../src/EditorToolbar.vala"
	_tmp32_ = (GtkImage*) gtk_image_new_from_icon_name ("format-text-italic-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 58 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp32_);
#line 58 "../src/EditorToolbar.vala"
	_tmp33_ = g_strdup ("<Ctrl>I");
#line 58 "../src/EditorToolbar.vala"
	_tmp34_ = g_new0 (gchar*, 1 + 1);
#line 58 "../src/EditorToolbar.vala"
	_tmp34_[0] = _tmp33_;
#line 58 "../src/EditorToolbar.vala"
	_tmp35_ = _tmp34_;
#line 58 "../src/EditorToolbar.vala"
	_tmp35__length1 = 1;
#line 58 "../src/EditorToolbar.vala"
	_tmp36_ = granite_markup_accel_tooltip (_tmp35_, (gint) 1, _ ("Italic"));
#line 58 "../src/EditorToolbar.vala"
	_tmp37_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 58 "../src/EditorToolbar.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp37_, _tmp30_);
#line 58 "../src/EditorToolbar.vala"
	_g_free0 (_tmp30_);
#line 58 "../src/EditorToolbar.vala"
	g_object_set ((GtkActionable*) _tmp37_, "action-target", _tmp31_, NULL);
#line 58 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp31_);
#line 58 "../src/EditorToolbar.vala"
	gtk_button_set_image ((GtkButton*) _tmp37_, (GtkWidget*) _tmp32_);
#line 58 "../src/EditorToolbar.vala"
	_g_object_unref0 (_tmp32_);
#line 58 "../src/EditorToolbar.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp37_, _tmp36_);
#line 58 "../src/EditorToolbar.vala"
	_g_free0 (_tmp36_);
#line 58 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp37_);
#line 58 "../src/EditorToolbar.vala"
	_tmp38_ = _tmp37_;
#line 58 "../src/EditorToolbar.vala"
	_tmp35_ = (_vala_array_free (_tmp35_, _tmp35__length1, (GDestroyNotify) g_free), NULL);
#line 58 "../src/EditorToolbar.vala"
	italic = _tmp38_;
#line 65 "../src/EditorToolbar.vala"
	_tmp39_ = g_strdup (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_UNDERLINE);
#line 65 "../src/EditorToolbar.vala"
	_tmp40_ = _variant_new12 (EDITOR_TOOLBAR_ACTION_UNDERLINE);
#line 65 "../src/EditorToolbar.vala"
	_tmp41_ = (GtkImage*) gtk_image_new_from_icon_name ("format-text-underline-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 65 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp41_);
#line 65 "../src/EditorToolbar.vala"
	_tmp42_ = application;
#line 65 "../src/EditorToolbar.vala"
	_tmp43_ = _variant_new13 (EDITOR_TOOLBAR_ACTION_UNDERLINE);
#line 65 "../src/EditorToolbar.vala"
	_tmp44_ = g_action_print_detailed_name (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_UNDERLINE, _tmp43_);
#line 65 "../src/EditorToolbar.vala"
	_tmp45_ = _tmp44_;
#line 65 "../src/EditorToolbar.vala"
	_tmp47_ = _tmp46_ = gtk_application_get_accels_for_action (_tmp42_, _tmp45_);
#line 65 "../src/EditorToolbar.vala"
	_tmp48_ = _tmp47_;
#line 65 "../src/EditorToolbar.vala"
	_tmp48__length1 = _vala_array_length (_tmp46_);
#line 65 "../src/EditorToolbar.vala"
	_tmp49_ = granite_markup_accel_tooltip (_tmp48_, (gint) _vala_array_length (_tmp46_), _ ("Underline"));
#line 65 "../src/EditorToolbar.vala"
	_tmp50_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 65 "../src/EditorToolbar.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp50_, _tmp39_);
#line 65 "../src/EditorToolbar.vala"
	_g_free0 (_tmp39_);
#line 65 "../src/EditorToolbar.vala"
	g_object_set ((GtkActionable*) _tmp50_, "action-target", _tmp40_, NULL);
#line 65 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp40_);
#line 65 "../src/EditorToolbar.vala"
	gtk_button_set_image ((GtkButton*) _tmp50_, (GtkWidget*) _tmp41_);
#line 65 "../src/EditorToolbar.vala"
	_g_object_unref0 (_tmp41_);
#line 65 "../src/EditorToolbar.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp50_, _tmp49_);
#line 65 "../src/EditorToolbar.vala"
	_g_free0 (_tmp49_);
#line 65 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp50_);
#line 65 "../src/EditorToolbar.vala"
	_tmp51_ = _tmp50_;
#line 65 "../src/EditorToolbar.vala"
	_tmp48_ = (_vala_array_free (_tmp48_, _tmp48__length1, (GDestroyNotify) g_free), NULL);
#line 65 "../src/EditorToolbar.vala"
	_g_free0 (_tmp45_);
#line 65 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp43_);
#line 65 "../src/EditorToolbar.vala"
	underline = _tmp51_;
#line 77 "../src/EditorToolbar.vala"
	_tmp52_ = g_strdup (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_STRIKETHROUGH);
#line 77 "../src/EditorToolbar.vala"
	_tmp53_ = _variant_new14 (EDITOR_TOOLBAR_ACTION_STRIKETHROUGH);
#line 77 "../src/EditorToolbar.vala"
	_tmp54_ = (GtkImage*) gtk_image_new_from_icon_name ("format-text-strikethrough-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 77 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp54_);
#line 77 "../src/EditorToolbar.vala"
	_tmp55_ = application;
#line 77 "../src/EditorToolbar.vala"
	_tmp56_ = _variant_new15 (EDITOR_TOOLBAR_ACTION_STRIKETHROUGH);
#line 77 "../src/EditorToolbar.vala"
	_tmp57_ = g_action_print_detailed_name (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_STRIKETHROUGH, _tmp56_);
#line 77 "../src/EditorToolbar.vala"
	_tmp58_ = _tmp57_;
#line 77 "../src/EditorToolbar.vala"
	_tmp60_ = _tmp59_ = gtk_application_get_accels_for_action (_tmp55_, _tmp58_);
#line 77 "../src/EditorToolbar.vala"
	_tmp61_ = _tmp60_;
#line 77 "../src/EditorToolbar.vala"
	_tmp61__length1 = _vala_array_length (_tmp59_);
#line 77 "../src/EditorToolbar.vala"
	_tmp62_ = granite_markup_accel_tooltip (_tmp61_, (gint) _vala_array_length (_tmp59_), _ ("Strikethrough"));
#line 77 "../src/EditorToolbar.vala"
	_tmp63_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 77 "../src/EditorToolbar.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp63_, _tmp52_);
#line 77 "../src/EditorToolbar.vala"
	_g_free0 (_tmp52_);
#line 77 "../src/EditorToolbar.vala"
	g_object_set ((GtkActionable*) _tmp63_, "action-target", _tmp53_, NULL);
#line 77 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp53_);
#line 77 "../src/EditorToolbar.vala"
	gtk_button_set_image ((GtkButton*) _tmp63_, (GtkWidget*) _tmp54_);
#line 77 "../src/EditorToolbar.vala"
	_g_object_unref0 (_tmp54_);
#line 77 "../src/EditorToolbar.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp63_, _tmp62_);
#line 77 "../src/EditorToolbar.vala"
	_g_free0 (_tmp62_);
#line 77 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp63_);
#line 77 "../src/EditorToolbar.vala"
	_tmp64_ = _tmp63_;
#line 77 "../src/EditorToolbar.vala"
	_tmp61_ = (_vala_array_free (_tmp61_, _tmp61__length1, (GDestroyNotify) g_free), NULL);
#line 77 "../src/EditorToolbar.vala"
	_g_free0 (_tmp58_);
#line 77 "../src/EditorToolbar.vala"
	_g_variant_unref0 (_tmp56_);
#line 77 "../src/EditorToolbar.vala"
	strikethrough = _tmp64_;
#line 89 "../src/EditorToolbar.vala"
	_tmp65_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 89 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp65_);
#line 89 "../src/EditorToolbar.vala"
	formatting_buttons = _tmp65_;
#line 90 "../src/EditorToolbar.vala"
	_tmp66_ = formatting_buttons;
#line 90 "../src/EditorToolbar.vala"
	_tmp67_ = gtk_widget_get_style_context ((GtkWidget*) _tmp66_);
#line 90 "../src/EditorToolbar.vala"
	gtk_style_context_add_class (_tmp67_, GTK_STYLE_CLASS_LINKED);
#line 91 "../src/EditorToolbar.vala"
	_tmp68_ = formatting_buttons;
#line 91 "../src/EditorToolbar.vala"
	_tmp69_ = bold;
#line 91 "../src/EditorToolbar.vala"
	gtk_container_add ((GtkContainer*) _tmp68_, (GtkWidget*) _tmp69_);
#line 92 "../src/EditorToolbar.vala"
	_tmp70_ = formatting_buttons;
#line 92 "../src/EditorToolbar.vala"
	_tmp71_ = italic;
#line 92 "../src/EditorToolbar.vala"
	gtk_container_add ((GtkContainer*) _tmp70_, (GtkWidget*) _tmp71_);
#line 93 "../src/EditorToolbar.vala"
	_tmp72_ = formatting_buttons;
#line 93 "../src/EditorToolbar.vala"
	_tmp73_ = underline;
#line 93 "../src/EditorToolbar.vala"
	gtk_container_add ((GtkContainer*) _tmp72_, (GtkWidget*) _tmp73_);
#line 94 "../src/EditorToolbar.vala"
	_tmp74_ = formatting_buttons;
#line 94 "../src/EditorToolbar.vala"
	_tmp75_ = strikethrough;
#line 94 "../src/EditorToolbar.vala"
	gtk_container_add ((GtkContainer*) _tmp74_, (GtkWidget*) _tmp75_);
#line 96 "../src/EditorToolbar.vala"
	_tmp76_ = g_strdup (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_REMOVE_FORMAT);
#line 96 "../src/EditorToolbar.vala"
	_tmp77_ = application;
#line 96 "../src/EditorToolbar.vala"
	_tmp79_ = _tmp78_ = gtk_application_get_accels_for_action (_tmp77_, EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_REMOVE_FORMAT);
#line 96 "../src/EditorToolbar.vala"
	_tmp80_ = _tmp79_;
#line 96 "../src/EditorToolbar.vala"
	_tmp80__length1 = _vala_array_length (_tmp78_);
#line 96 "../src/EditorToolbar.vala"
	_tmp81_ = granite_markup_accel_tooltip (_tmp80_, (gint) _vala_array_length (_tmp78_), _ ("Remove formatting"));
#line 96 "../src/EditorToolbar.vala"
	_tmp82_ = (GtkButton*) gtk_button_new_from_icon_name ("format-text-clear-formatting-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 96 "../src/EditorToolbar.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp82_, _tmp76_);
#line 96 "../src/EditorToolbar.vala"
	_g_free0 (_tmp76_);
#line 96 "../src/EditorToolbar.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp82_, _tmp81_);
#line 96 "../src/EditorToolbar.vala"
	_g_free0 (_tmp81_);
#line 96 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp82_);
#line 96 "../src/EditorToolbar.vala"
	_tmp83_ = _tmp82_;
#line 96 "../src/EditorToolbar.vala"
	_tmp80_ = (_vala_array_free (_tmp80_, _tmp80__length1, (GDestroyNotify) g_free), NULL);
#line 96 "../src/EditorToolbar.vala"
	clear_format = _tmp83_;
#line 104 "../src/EditorToolbar.vala"
	_tmp84_ = g_strdup (EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_INSERT_LINK);
#line 104 "../src/EditorToolbar.vala"
	_tmp85_ = application;
#line 104 "../src/EditorToolbar.vala"
	_tmp87_ = _tmp86_ = gtk_application_get_accels_for_action (_tmp85_, EDITOR_TOOLBAR_ACTION_PREFIX EDITOR_TOOLBAR_ACTION_INSERT_LINK);
#line 104 "../src/EditorToolbar.vala"
	_tmp88_ = _tmp87_;
#line 104 "../src/EditorToolbar.vala"
	_tmp88__length1 = _vala_array_length (_tmp86_);
#line 104 "../src/EditorToolbar.vala"
	_tmp89_ = granite_markup_accel_tooltip (_tmp88_, (gint) _vala_array_length (_tmp86_), _ ("Insert Link"));
#line 104 "../src/EditorToolbar.vala"
	_tmp90_ = (GtkButton*) gtk_button_new_from_icon_name ("insert-link-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 104 "../src/EditorToolbar.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp90_, _tmp84_);
#line 104 "../src/EditorToolbar.vala"
	_g_free0 (_tmp84_);
#line 104 "../src/EditorToolbar.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp90_, _tmp89_);
#line 104 "../src/EditorToolbar.vala"
	_g_free0 (_tmp89_);
#line 104 "../src/EditorToolbar.vala"
	g_object_ref_sink (_tmp90_);
#line 104 "../src/EditorToolbar.vala"
	_tmp91_ = _tmp90_;
#line 104 "../src/EditorToolbar.vala"
	_tmp88_ = (_vala_array_free (_tmp88_, _tmp88__length1, (GDestroyNotify) g_free), NULL);
#line 104 "../src/EditorToolbar.vala"
	link = _tmp91_;
#line 112 "../src/EditorToolbar.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 6);
#line 113 "../src/EditorToolbar.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 6);
#line 114 "../src/EditorToolbar.vala"
	gtk_box_set_spacing ((GtkBox*) self, 6);
#line 115 "../src/EditorToolbar.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
#line 116 "../src/EditorToolbar.vala"
	_tmp92_ = formatting_buttons;
#line 116 "../src/EditorToolbar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp92_);
#line 117 "../src/EditorToolbar.vala"
	_tmp93_ = clear_format;
#line 117 "../src/EditorToolbar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp93_);
#line 118 "../src/EditorToolbar.vala"
	_tmp94_ = link;
#line 118 "../src/EditorToolbar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp94_);
#line 120 "../src/EditorToolbar.vala"
	g_signal_connect_object ((GtkWidget*) self, "map", (GCallback) __editor_toolbar___lambda91__gtk_widget_map, self, 0);
#line 124 "../src/EditorToolbar.vala"
	_tmp95_ = self->priv->_web_view;
#line 124 "../src/EditorToolbar.vala"
	g_signal_connect_object (_tmp95_, "selection-changed", (GCallback) _editor_toolbar_update_actions_mail_web_view_selection_changed, self, 0);
#line 36 "../src/EditorToolbar.vala"
	_g_object_unref0 (link);
#line 36 "../src/EditorToolbar.vala"
	_g_object_unref0 (clear_format);
#line 36 "../src/EditorToolbar.vala"
	_g_object_unref0 (formatting_buttons);
#line 36 "../src/EditorToolbar.vala"
	_g_object_unref0 (strikethrough);
#line 36 "../src/EditorToolbar.vala"
	_g_object_unref0 (underline);
#line 36 "../src/EditorToolbar.vala"
	_g_object_unref0 (italic);
#line 36 "../src/EditorToolbar.vala"
	_g_object_unref0 (bold);
#line 36 "../src/EditorToolbar.vala"
	return obj;
#line 1597 "EditorToolbar.c"
}

static void
editor_toolbar_class_init (EditorToolbarClass * klass,
                           gpointer klass_data)
{
#line 6 "../src/EditorToolbar.vala"
	editor_toolbar_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/EditorToolbar.vala"
	g_type_class_adjust_private_offset (klass, &EditorToolbar_private_offset);
#line 6 "../src/EditorToolbar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_editor_toolbar_get_property;
#line 6 "../src/EditorToolbar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_editor_toolbar_set_property;
#line 6 "../src/EditorToolbar.vala"
	G_OBJECT_CLASS (klass)->constructor = editor_toolbar_constructor;
#line 6 "../src/EditorToolbar.vala"
	G_OBJECT_CLASS (klass)->finalize = editor_toolbar_finalize;
#line 6 "../src/EditorToolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITOR_TOOLBAR_WEB_VIEW_PROPERTY, editor_toolbar_properties[EDITOR_TOOLBAR_WEB_VIEW_PROPERTY] = g_param_spec_object ("web-view", "web-view", "web-view", MAIL_TYPE_WEB_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1618 "EditorToolbar.c"
}

static void
editor_toolbar_instance_init (EditorToolbar * self,
                              gpointer klass)
{
#line 6 "../src/EditorToolbar.vala"
	self->priv = editor_toolbar_get_instance_private (self);
#line 1627 "EditorToolbar.c"
}

static void
editor_toolbar_finalize (GObject * obj)
{
	EditorToolbar * self;
#line 6 "../src/EditorToolbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EDITOR_TOOLBAR, EditorToolbar);
#line 26 "../src/EditorToolbar.vala"
	_g_object_unref0 (self->priv->_web_view);
#line 28 "../src/EditorToolbar.vala"
	_g_object_unref0 (self->priv->action_group);
#line 6 "../src/EditorToolbar.vala"
	G_OBJECT_CLASS (editor_toolbar_parent_class)->finalize (obj);
#line 1642 "EditorToolbar.c"
}

static GType
editor_toolbar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditorToolbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editor_toolbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditorToolbar), 0, (GInstanceInitFunc) editor_toolbar_instance_init, NULL };
	GType editor_toolbar_type_id;
	editor_toolbar_type_id = g_type_register_static (gtk_box_get_type (), "EditorToolbar", &g_define_type_info, 0);
	EditorToolbar_private_offset = g_type_add_instance_private (editor_toolbar_type_id, sizeof (EditorToolbarPrivate));
	return editor_toolbar_type_id;
}

GType
editor_toolbar_get_type (void)
{
	static volatile gsize editor_toolbar_type_id__once = 0;
	if (g_once_init_enter (&editor_toolbar_type_id__once)) {
		GType editor_toolbar_type_id;
		editor_toolbar_type_id = editor_toolbar_get_type_once ();
		g_once_init_leave (&editor_toolbar_type_id__once, editor_toolbar_type_id);
	}
	return editor_toolbar_type_id__once;
}

static void
_vala_editor_toolbar_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	EditorToolbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EDITOR_TOOLBAR, EditorToolbar);
#line 6 "../src/EditorToolbar.vala"
	switch (property_id) {
#line 6 "../src/EditorToolbar.vala"
		case EDITOR_TOOLBAR_WEB_VIEW_PROPERTY:
#line 6 "../src/EditorToolbar.vala"
		g_value_set_object (value, editor_toolbar_get_web_view (self));
#line 6 "../src/EditorToolbar.vala"
		break;
#line 1683 "EditorToolbar.c"
		default:
#line 6 "../src/EditorToolbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/EditorToolbar.vala"
		break;
#line 1689 "EditorToolbar.c"
	}
}

static void
_vala_editor_toolbar_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	EditorToolbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EDITOR_TOOLBAR, EditorToolbar);
#line 6 "../src/EditorToolbar.vala"
	switch (property_id) {
#line 6 "../src/EditorToolbar.vala"
		case EDITOR_TOOLBAR_WEB_VIEW_PROPERTY:
#line 6 "../src/EditorToolbar.vala"
		editor_toolbar_set_web_view (self, g_value_get_object (value));
#line 6 "../src/EditorToolbar.vala"
		break;
#line 1709 "EditorToolbar.c"
		default:
#line 6 "../src/EditorToolbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/EditorToolbar.vala"
		break;
#line 1715 "EditorToolbar.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

