/* AttachmentButton.c generated by valac 0.56.14, the Vala compiler
 * generated from AttachmentButton.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <camel/camel.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define ATTACHMENT_BUTTON_ACTION_GROUP_PREFIX "attachmentbutton"
#define ATTACHMENT_BUTTON_ACTION_PREFIX ATTACHMENT_BUTTON_ACTION_GROUP_PREFIX "."
#define ATTACHMENT_BUTTON_ACTION_OPEN "open"
#define ATTACHMENT_BUTTON_ACTION_SAVE_AS "save-as"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ATTACHMENT_BUTTON (attachment_button_get_type ())
#define ATTACHMENT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ATTACHMENT_BUTTON, AttachmentButton))
#define ATTACHMENT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ATTACHMENT_BUTTON, AttachmentButtonClass))
#define IS_ATTACHMENT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ATTACHMENT_BUTTON))
#define IS_ATTACHMENT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ATTACHMENT_BUTTON))
#define ATTACHMENT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ATTACHMENT_BUTTON, AttachmentButtonClass))

typedef struct _AttachmentButton AttachmentButton;
typedef struct _AttachmentButtonClass AttachmentButtonClass;
typedef struct _AttachmentButtonPrivate AttachmentButtonPrivate;
enum  {
	ATTACHMENT_BUTTON_0_PROPERTY,
	ATTACHMENT_BUTTON_MIME_PART_PROPERTY,
	ATTACHMENT_BUTTON_LOADING_CANCELLABLE_PROPERTY,
	ATTACHMENT_BUTTON_NUM_PROPERTIES
};
static GParamSpec* attachment_button_properties[ATTACHMENT_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _AttachmentButtonWriteToFileData AttachmentButtonWriteToFileData;
typedef struct _Block38Data Block38Data;
typedef struct _Block39Data Block39Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

struct _AttachmentButton {
	GtkFlowBoxChild parent_instance;
	AttachmentButtonPrivate * priv;
};

struct _AttachmentButtonClass {
	GtkFlowBoxChildClass parent_class;
};

struct _AttachmentButtonPrivate {
	CamelMimePart* _mime_part;
	GCancellable* _loading_cancellable;
	GtkImage* preview_image;
	GtkLabel* name_label;
	GtkLabel* size_label;
};

struct _AttachmentButtonWriteToFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AttachmentButton* self;
	GFile* file;
	GFileIOStream* iostream;
	GFileIOStream* _tmp0_;
	CamelMimePart* _tmp1_;
	CamelDataWrapper* _tmp2_;
	CamelDataWrapper* _tmp3_;
	GFileIOStream* _tmp4_;
	GOutputStream* _tmp5_;
	GOutputStream* _tmp6_;
	GError* e;
	GError* _tmp7_;
	const gchar* _tmp8_;
	GError* _inner_error0_;
};

struct _Block38Data {
	int _ref_count_;
	AttachmentButton* self;
	GtkMenu* menu;
};

struct _Block39Data {
	int _ref_count_;
	AttachmentButton* self;
	gchar* size_text;
};

static gint AttachmentButton_private_offset;
static gpointer attachment_button_parent_class = NULL;

VALA_EXTERN GType attachment_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AttachmentButton, g_object_unref)
VALA_EXTERN AttachmentButton* attachment_button_new (CamelMimePart* mime_part,
                                         GCancellable* loading_cancellable);
VALA_EXTERN AttachmentButton* attachment_button_construct (GType object_type,
                                               CamelMimePart* mime_part,
                                               GCancellable* loading_cancellable);
static void attachment_button_on_save_as (AttachmentButton* self);
VALA_EXTERN CamelMimePart* attachment_button_get_mime_part (AttachmentButton* self);
static void attachment_button_write_to_file (AttachmentButton* self,
                                      GFile* file,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void attachment_button_write_to_file_finish (AttachmentButton* self,
                                             GAsyncResult* _res_);
static void attachment_button_write_to_file_data_free (gpointer _data);
static gboolean attachment_button_write_to_file_co (AttachmentButtonWriteToFileData* _data_);
static void attachment_button_write_to_file_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void attachment_button_set_mime_part (AttachmentButton* self,
                                      CamelMimePart* value);
VALA_EXTERN GCancellable* attachment_button_get_loading_cancellable (AttachmentButton* self);
static void attachment_button_set_loading_cancellable (AttachmentButton* self,
                                                GCancellable* value);
static GObject * attachment_button_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block38Data* block38_data_ref (Block38Data* _data38_);
static void block38_data_unref (void * _userdata_);
static void _attachment_button___lambda51_ (AttachmentButton* self);
static void __attachment_button___lambda51__g_simple_action_activate (GSimpleAction* _sender,
                                                               GVariant* parameter,
                                                               gpointer self);
static void _attachment_button_on_save_as_g_simple_action_activate (GSimpleAction* _sender,
                                                             GVariant* parameter,
                                                             gpointer self);
static gboolean _attachment_button___lambda52_ (Block38Data* _data38_,
                                         GdkEventButton* event);
static gboolean __attachment_button___lambda52__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                        GdkEventButton* event,
                                                                        gpointer self);
static void* _attachment_button___lambda53_ (AttachmentButton* self);
static Block39Data* block39_data_ref (Block39Data* _data39_);
static void block39_data_unref (void * _userdata_);
static gboolean __lambda54_ (Block39Data* _data39_);
static gboolean ___lambda54__gsource_func (gpointer self);
static gpointer __attachment_button___lambda53__gthread_func (gpointer self);
static void attachment_button_finalize (GObject * obj);
static GType attachment_button_get_type_once (void);
static void _vala_attachment_button_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_attachment_button_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
attachment_button_get_instance_private (AttachmentButton* self)
{
	return G_STRUCT_MEMBER_P (self, AttachmentButton_private_offset);
}

AttachmentButton*
attachment_button_construct (GType object_type,
                             CamelMimePart* mime_part,
                             GCancellable* loading_cancellable)
{
	AttachmentButton * self = NULL;
#line 34 "../src/MessageList/AttachmentButton.vala"
	g_return_val_if_fail (mime_part != NULL, NULL);
#line 34 "../src/MessageList/AttachmentButton.vala"
	g_return_val_if_fail (loading_cancellable != NULL, NULL);
#line 35 "../src/MessageList/AttachmentButton.vala"
	self = (AttachmentButton*) g_object_new (object_type, "mime-part", mime_part, "loading-cancellable", loading_cancellable, NULL);
#line 34 "../src/MessageList/AttachmentButton.vala"
	return self;
#line 208 "AttachmentButton.c"
}

AttachmentButton*
attachment_button_new (CamelMimePart* mime_part,
                       GCancellable* loading_cancellable)
{
#line 34 "../src/MessageList/AttachmentButton.vala"
	return attachment_button_construct (TYPE_ATTACHMENT_BUTTON, mime_part, loading_cancellable);
#line 217 "AttachmentButton.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 133 "../src/MessageList/AttachmentButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 225 "AttachmentButton.c"
}

static void
attachment_button_on_save_as (AttachmentButton* self)
{
	GtkWindow* parent_window = NULL;
	GtkWidget* _tmp0_;
	GtkWindow* _tmp1_;
	GtkFileChooserNative* chooser = NULL;
	GtkWindow* _tmp2_;
	GtkFileChooserNative* _tmp3_;
	GtkFileChooserNative* _tmp4_;
	CamelMimePart* _tmp5_;
	const gchar* _tmp6_;
	GtkFileChooserNative* _tmp7_;
	GtkFileChooserNative* _tmp8_;
	GtkFileChooserNative* _tmp12_;
#line 132 "../src/MessageList/AttachmentButton.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/MessageList/AttachmentButton.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 133 "../src/MessageList/AttachmentButton.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL);
#line 133 "../src/MessageList/AttachmentButton.vala"
	parent_window = _tmp1_;
#line 134 "../src/MessageList/AttachmentButton.vala"
	_tmp2_ = parent_window;
#line 134 "../src/MessageList/AttachmentButton.vala"
	_tmp3_ = gtk_file_chooser_native_new (NULL, _tmp2_, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("Save"), _ ("Cancel"));
#line 134 "../src/MessageList/AttachmentButton.vala"
	chooser = _tmp3_;
#line 142 "../src/MessageList/AttachmentButton.vala"
	_tmp4_ = chooser;
#line 142 "../src/MessageList/AttachmentButton.vala"
	_tmp5_ = self->priv->_mime_part;
#line 142 "../src/MessageList/AttachmentButton.vala"
	_tmp6_ = camel_mime_part_get_filename (_tmp5_);
#line 142 "../src/MessageList/AttachmentButton.vala"
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp4_, _tmp6_);
#line 143 "../src/MessageList/AttachmentButton.vala"
	_tmp7_ = chooser;
#line 143 "../src/MessageList/AttachmentButton.vala"
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp7_, TRUE);
#line 145 "../src/MessageList/AttachmentButton.vala"
	_tmp8_ = chooser;
#line 145 "../src/MessageList/AttachmentButton.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp8_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 273 "AttachmentButton.c"
		GtkFileChooserNative* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
#line 146 "../src/MessageList/AttachmentButton.vala"
		_tmp9_ = chooser;
#line 146 "../src/MessageList/AttachmentButton.vala"
		_tmp10_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp9_);
#line 146 "../src/MessageList/AttachmentButton.vala"
		_tmp11_ = _tmp10_;
#line 146 "../src/MessageList/AttachmentButton.vala"
		attachment_button_write_to_file (self, _tmp11_, NULL, NULL);
#line 146 "../src/MessageList/AttachmentButton.vala"
		_g_object_unref0 (_tmp11_);
#line 287 "AttachmentButton.c"
	}
#line 149 "../src/MessageList/AttachmentButton.vala"
	_tmp12_ = chooser;
#line 149 "../src/MessageList/AttachmentButton.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp12_);
#line 132 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (chooser);
#line 132 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (parent_window);
#line 297 "AttachmentButton.c"
}

static void
attachment_button_write_to_file_data_free (gpointer _data)
{
	AttachmentButtonWriteToFileData* _data_;
	_data_ = _data;
#line 21 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (_data_->file);
#line 21 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/MessageList/AttachmentButton.vala"
	g_slice_free (AttachmentButtonWriteToFileData, _data_);
#line 311 "AttachmentButton.c"
}

static void
attachment_button_write_to_file (AttachmentButton* self,
                                 GFile* file,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	AttachmentButtonWriteToFileData* _data_;
	AttachmentButton* _tmp0_;
	GFile* _tmp1_;
#line 21 "../src/MessageList/AttachmentButton.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/MessageList/AttachmentButton.vala"
	g_return_if_fail (file != NULL);
#line 21 "../src/MessageList/AttachmentButton.vala"
	_data_ = g_slice_new0 (AttachmentButtonWriteToFileData);
#line 21 "../src/MessageList/AttachmentButton.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/MessageList/AttachmentButton.vala"
	g_task_set_task_data (_data_->_async_result, _data_, attachment_button_write_to_file_data_free);
#line 21 "../src/MessageList/AttachmentButton.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/MessageList/AttachmentButton.vala"
	_data_->self = _tmp0_;
#line 21 "../src/MessageList/AttachmentButton.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 21 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (_data_->file);
#line 21 "../src/MessageList/AttachmentButton.vala"
	_data_->file = _tmp1_;
#line 21 "../src/MessageList/AttachmentButton.vala"
	attachment_button_write_to_file_co (_data_);
#line 345 "AttachmentButton.c"
}

static void
attachment_button_write_to_file_finish (AttachmentButton* self,
                                        GAsyncResult* _res_)
{
	AttachmentButtonWriteToFileData* _data_;
#line 21 "../src/MessageList/AttachmentButton.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 355 "AttachmentButton.c"
}

static void
attachment_button_write_to_file_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	AttachmentButtonWriteToFileData* _data_;
#line 154 "../src/MessageList/AttachmentButton.vala"
	_data_ = _user_data_;
#line 154 "../src/MessageList/AttachmentButton.vala"
	_data_->_source_object_ = source_object;
#line 154 "../src/MessageList/AttachmentButton.vala"
	_data_->_res_ = _res_;
#line 154 "../src/MessageList/AttachmentButton.vala"
	attachment_button_write_to_file_co (_data_);
#line 372 "AttachmentButton.c"
}

static gboolean
attachment_button_write_to_file_co (AttachmentButtonWriteToFileData* _data_)
{
#line 152 "../src/MessageList/AttachmentButton.vala"
	switch (_data_->_state_) {
#line 152 "../src/MessageList/AttachmentButton.vala"
		case 0:
#line 382 "AttachmentButton.c"
		goto _state_0;
#line 152 "../src/MessageList/AttachmentButton.vala"
		case 1:
#line 386 "AttachmentButton.c"
		goto _state_1;
#line 152 "../src/MessageList/AttachmentButton.vala"
		case 2:
#line 390 "AttachmentButton.c"
		goto _state_2;
		default:
#line 152 "../src/MessageList/AttachmentButton.vala"
		g_assert_not_reached ();
#line 395 "AttachmentButton.c"
	}
	_state_0:
	{
#line 154 "../src/MessageList/AttachmentButton.vala"
		_data_->_state_ = 1;
#line 154 "../src/MessageList/AttachmentButton.vala"
		g_file_create_readwrite_async (_data_->file, G_FILE_CREATE_REPLACE_DESTINATION, G_PRIORITY_DEFAULT, NULL, attachment_button_write_to_file_ready, _data_);
#line 154 "../src/MessageList/AttachmentButton.vala"
		return FALSE;
#line 405 "AttachmentButton.c"
		_state_1:
#line 154 "../src/MessageList/AttachmentButton.vala"
		_data_->_tmp0_ = g_file_create_readwrite_finish (_data_->file, _data_->_res_, &_data_->_inner_error0_);
#line 154 "../src/MessageList/AttachmentButton.vala"
		_data_->iostream = _data_->_tmp0_;
#line 154 "../src/MessageList/AttachmentButton.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 413 "AttachmentButton.c"
			goto __catch0_g_error;
		}
#line 155 "../src/MessageList/AttachmentButton.vala"
		_data_->_tmp1_ = _data_->self->priv->_mime_part;
#line 155 "../src/MessageList/AttachmentButton.vala"
		_data_->_tmp2_ = camel_medium_get_content ((CamelMedium*) _data_->_tmp1_);
#line 155 "../src/MessageList/AttachmentButton.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 155 "../src/MessageList/AttachmentButton.vala"
		_data_->_tmp4_ = _data_->iostream;
#line 155 "../src/MessageList/AttachmentButton.vala"
		_data_->_tmp5_ = g_io_stream_get_output_stream ((GIOStream*) _data_->_tmp4_);
#line 155 "../src/MessageList/AttachmentButton.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 155 "../src/MessageList/AttachmentButton.vala"
		_data_->_state_ = 2;
#line 155 "../src/MessageList/AttachmentButton.vala"
		camel_data_wrapper_decode_to_output_stream (_data_->_tmp3_, _data_->_tmp6_, G_PRIORITY_DEFAULT, NULL, attachment_button_write_to_file_ready, _data_);
#line 155 "../src/MessageList/AttachmentButton.vala"
		return FALSE;
#line 434 "AttachmentButton.c"
		_state_2:
#line 155 "../src/MessageList/AttachmentButton.vala"
		camel_data_wrapper_decode_to_output_stream_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 155 "../src/MessageList/AttachmentButton.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 155 "../src/MessageList/AttachmentButton.vala"
			_g_object_unref0 (_data_->iostream);
#line 442 "AttachmentButton.c"
			goto __catch0_g_error;
		}
#line 153 "../src/MessageList/AttachmentButton.vala"
		_g_object_unref0 (_data_->iostream);
#line 447 "AttachmentButton.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 153 "../src/MessageList/AttachmentButton.vala"
		_data_->e = _data_->_inner_error0_;
#line 153 "../src/MessageList/AttachmentButton.vala"
		_data_->_inner_error0_ = NULL;
#line 157 "../src/MessageList/AttachmentButton.vala"
		_data_->_tmp7_ = _data_->e;
#line 157 "../src/MessageList/AttachmentButton.vala"
		_data_->_tmp8_ = _data_->_tmp7_->message;
#line 157 "../src/MessageList/AttachmentButton.vala"
		g_critical ("AttachmentButton.vala:157: %s", _data_->_tmp8_);
#line 153 "../src/MessageList/AttachmentButton.vala"
		_g_error_free0 (_data_->e);
#line 464 "AttachmentButton.c"
	}
	__finally0:
#line 153 "../src/MessageList/AttachmentButton.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 153 "../src/MessageList/AttachmentButton.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 153 "../src/MessageList/AttachmentButton.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 153 "../src/MessageList/AttachmentButton.vala"
		g_object_unref (_data_->_async_result);
#line 153 "../src/MessageList/AttachmentButton.vala"
		return FALSE;
#line 477 "AttachmentButton.c"
	}
#line 152 "../src/MessageList/AttachmentButton.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 152 "../src/MessageList/AttachmentButton.vala"
	if (_data_->_state_ != 0) {
#line 152 "../src/MessageList/AttachmentButton.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 152 "../src/MessageList/AttachmentButton.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 487 "AttachmentButton.c"
		}
	}
#line 152 "../src/MessageList/AttachmentButton.vala"
	g_object_unref (_data_->_async_result);
#line 152 "../src/MessageList/AttachmentButton.vala"
	return FALSE;
#line 494 "AttachmentButton.c"
}

CamelMimePart*
attachment_button_get_mime_part (AttachmentButton* self)
{
	CamelMimePart* result;
	CamelMimePart* _tmp0_;
#line 22 "../src/MessageList/AttachmentButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/MessageList/AttachmentButton.vala"
	_tmp0_ = self->priv->_mime_part;
#line 22 "../src/MessageList/AttachmentButton.vala"
	result = _tmp0_;
#line 22 "../src/MessageList/AttachmentButton.vala"
	return result;
#line 510 "AttachmentButton.c"
}

static void
attachment_button_set_mime_part (AttachmentButton* self,
                                 CamelMimePart* value)
{
	CamelMimePart* old_value;
#line 22 "../src/MessageList/AttachmentButton.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/MessageList/AttachmentButton.vala"
	old_value = attachment_button_get_mime_part (self);
#line 22 "../src/MessageList/AttachmentButton.vala"
	if (old_value != value) {
#line 524 "AttachmentButton.c"
		CamelMimePart* _tmp0_;
#line 22 "../src/MessageList/AttachmentButton.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 22 "../src/MessageList/AttachmentButton.vala"
		_g_object_unref0 (self->priv->_mime_part);
#line 22 "../src/MessageList/AttachmentButton.vala"
		self->priv->_mime_part = _tmp0_;
#line 22 "../src/MessageList/AttachmentButton.vala"
		g_object_notify_by_pspec ((GObject *) self, attachment_button_properties[ATTACHMENT_BUTTON_MIME_PART_PROPERTY]);
#line 534 "AttachmentButton.c"
	}
}

GCancellable*
attachment_button_get_loading_cancellable (AttachmentButton* self)
{
	GCancellable* result;
	GCancellable* _tmp0_;
#line 23 "../src/MessageList/AttachmentButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/MessageList/AttachmentButton.vala"
	_tmp0_ = self->priv->_loading_cancellable;
#line 23 "../src/MessageList/AttachmentButton.vala"
	result = _tmp0_;
#line 23 "../src/MessageList/AttachmentButton.vala"
	return result;
#line 551 "AttachmentButton.c"
}

static void
attachment_button_set_loading_cancellable (AttachmentButton* self,
                                           GCancellable* value)
{
	GCancellable* old_value;
#line 23 "../src/MessageList/AttachmentButton.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/MessageList/AttachmentButton.vala"
	old_value = attachment_button_get_loading_cancellable (self);
#line 23 "../src/MessageList/AttachmentButton.vala"
	if (old_value != value) {
#line 23 "../src/MessageList/AttachmentButton.vala"
		self->priv->_loading_cancellable = value;
#line 23 "../src/MessageList/AttachmentButton.vala"
		g_object_notify_by_pspec ((GObject *) self, attachment_button_properties[ATTACHMENT_BUTTON_LOADING_CANCELLABLE_PROPERTY]);
#line 569 "AttachmentButton.c"
	}
}

static Block38Data*
block38_data_ref (Block38Data* _data38_)
{
#line 40 "../src/MessageList/AttachmentButton.vala"
	g_atomic_int_inc (&_data38_->_ref_count_);
#line 40 "../src/MessageList/AttachmentButton.vala"
	return _data38_;
#line 580 "AttachmentButton.c"
}

static void
block38_data_unref (void * _userdata_)
{
	Block38Data* _data38_;
	_data38_ = (Block38Data*) _userdata_;
#line 40 "../src/MessageList/AttachmentButton.vala"
	if (g_atomic_int_dec_and_test (&_data38_->_ref_count_)) {
#line 590 "AttachmentButton.c"
		AttachmentButton* self;
#line 40 "../src/MessageList/AttachmentButton.vala"
		self = _data38_->self;
#line 40 "../src/MessageList/AttachmentButton.vala"
		_g_object_unref0 (_data38_->menu);
#line 40 "../src/MessageList/AttachmentButton.vala"
		_g_object_unref0 (self);
#line 40 "../src/MessageList/AttachmentButton.vala"
		g_slice_free (Block38Data, _data38_);
#line 600 "AttachmentButton.c"
	}
}

static void
_attachment_button___lambda51_ (AttachmentButton* self)
{
#line 47 "../src/MessageList/AttachmentButton.vala"
	g_signal_emit_by_name ((GtkFlowBoxChild*) self, "activate");
#line 609 "AttachmentButton.c"
}

static void
__attachment_button___lambda51__g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 47 "../src/MessageList/AttachmentButton.vala"
	_attachment_button___lambda51_ ((AttachmentButton*) self);
#line 619 "AttachmentButton.c"
}

static void
_attachment_button_on_save_as_g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self)
{
#line 49 "../src/MessageList/AttachmentButton.vala"
	attachment_button_on_save_as ((AttachmentButton*) self);
#line 629 "AttachmentButton.c"
}

static gboolean
_attachment_button___lambda52_ (Block38Data* _data38_,
                                GdkEventButton* event)
{
	AttachmentButton* self;
	gboolean result;
#line 64 "../src/MessageList/AttachmentButton.vala"
	self = _data38_->self;
#line 64 "../src/MessageList/AttachmentButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 65 "../src/MessageList/AttachmentButton.vala"
	if (event->button == ((guint) GDK_BUTTON_SECONDARY)) {
#line 644 "AttachmentButton.c"
		GtkMenu* _tmp0_;
		GtkMenu* _tmp1_;
		GtkMenu* _tmp2_;
#line 66 "../src/MessageList/AttachmentButton.vala"
		_tmp0_ = _data38_->menu;
#line 66 "../src/MessageList/AttachmentButton.vala"
		g_object_set (_tmp0_, "attach-widget", (GtkWidget*) self, NULL);
#line 67 "../src/MessageList/AttachmentButton.vala"
		_tmp1_ = _data38_->menu;
#line 67 "../src/MessageList/AttachmentButton.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp1_);
#line 68 "../src/MessageList/AttachmentButton.vala"
		_tmp2_ = _data38_->menu;
#line 68 "../src/MessageList/AttachmentButton.vala"
		gtk_menu_popup_at_pointer (_tmp2_, (GdkEvent*) event);
#line 660 "AttachmentButton.c"
	} else {
#line 70 "../src/MessageList/AttachmentButton.vala"
		g_signal_emit_by_name ((GtkFlowBoxChild*) self, "activate");
#line 664 "AttachmentButton.c"
	}
#line 73 "../src/MessageList/AttachmentButton.vala"
	result = TRUE;
#line 73 "../src/MessageList/AttachmentButton.vala"
	return result;
#line 670 "AttachmentButton.c"
}

static gboolean
__attachment_button___lambda52__gtk_widget_button_press_event (GtkWidget* _sender,
                                                               GdkEventButton* event,
                                                               gpointer self)
{
	gboolean result;
	result = _attachment_button___lambda52_ (self, event);
#line 64 "../src/MessageList/AttachmentButton.vala"
	return result;
#line 682 "AttachmentButton.c"
}

static Block39Data*
block39_data_ref (Block39Data* _data39_)
{
#line 101 "../src/MessageList/AttachmentButton.vala"
	g_atomic_int_inc (&_data39_->_ref_count_);
#line 101 "../src/MessageList/AttachmentButton.vala"
	return _data39_;
#line 692 "AttachmentButton.c"
}

static void
block39_data_unref (void * _userdata_)
{
	Block39Data* _data39_;
	_data39_ = (Block39Data*) _userdata_;
#line 101 "../src/MessageList/AttachmentButton.vala"
	if (g_atomic_int_dec_and_test (&_data39_->_ref_count_)) {
#line 702 "AttachmentButton.c"
		AttachmentButton* self;
#line 101 "../src/MessageList/AttachmentButton.vala"
		self = _data39_->self;
#line 101 "../src/MessageList/AttachmentButton.vala"
		_g_free0 (_data39_->size_text);
#line 101 "../src/MessageList/AttachmentButton.vala"
		_g_object_unref0 (self);
#line 101 "../src/MessageList/AttachmentButton.vala"
		g_slice_free (Block39Data, _data39_);
#line 712 "AttachmentButton.c"
	}
}

static gboolean
__lambda54_ (Block39Data* _data39_)
{
	AttachmentButton* self;
	const gchar* _tmp0_;
	gboolean result;
#line 110 "../src/MessageList/AttachmentButton.vala"
	self = _data39_->self;
#line 111 "../src/MessageList/AttachmentButton.vala"
	_tmp0_ = _data39_->size_text;
#line 111 "../src/MessageList/AttachmentButton.vala"
	if (_tmp0_ != NULL) {
#line 728 "AttachmentButton.c"
		GtkLabel* _tmp1_;
		const gchar* _tmp2_;
#line 112 "../src/MessageList/AttachmentButton.vala"
		_tmp1_ = self->priv->size_label;
#line 112 "../src/MessageList/AttachmentButton.vala"
		_tmp2_ = _data39_->size_text;
#line 112 "../src/MessageList/AttachmentButton.vala"
		gtk_label_set_label (_tmp1_, _tmp2_);
#line 737 "AttachmentButton.c"
	} else {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		GtkStyleContext* _tmp5_;
#line 114 "../src/MessageList/AttachmentButton.vala"
		_tmp3_ = self->priv->size_label;
#line 114 "../src/MessageList/AttachmentButton.vala"
		gtk_label_set_label (_tmp3_, _ ("Unknown"));
#line 115 "../src/MessageList/AttachmentButton.vala"
		_tmp4_ = self->priv->size_label;
#line 115 "../src/MessageList/AttachmentButton.vala"
		_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 115 "../src/MessageList/AttachmentButton.vala"
		gtk_style_context_add_class (_tmp5_, GTK_STYLE_CLASS_ERROR);
#line 752 "AttachmentButton.c"
	}
#line 118 "../src/MessageList/AttachmentButton.vala"
	result = G_SOURCE_REMOVE;
#line 118 "../src/MessageList/AttachmentButton.vala"
	return result;
#line 758 "AttachmentButton.c"
}

static gboolean
___lambda54__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda54_ (self);
#line 110 "../src/MessageList/AttachmentButton.vala"
	return result;
#line 768 "AttachmentButton.c"
}

static void*
_attachment_button___lambda53_ (AttachmentButton* self)
{
	Block39Data* _data39_;
	GError* _inner_error0_ = NULL;
	void* result;
#line 101 "../src/MessageList/AttachmentButton.vala"
	_data39_ = g_slice_new0 (Block39Data);
#line 101 "../src/MessageList/AttachmentButton.vala"
	_data39_->_ref_count_ = 1;
#line 101 "../src/MessageList/AttachmentButton.vala"
	_data39_->self = g_object_ref (self);
#line 102 "../src/MessageList/AttachmentButton.vala"
	_data39_->size_text = NULL;
#line 785 "AttachmentButton.c"
	{
		gsize size = 0UL;
		CamelMimePart* _tmp0_;
		GCancellable* _tmp1_;
		gchar* _tmp2_;
#line 104 "../src/MessageList/AttachmentButton.vala"
		_tmp0_ = self->priv->_mime_part;
#line 104 "../src/MessageList/AttachmentButton.vala"
		_tmp1_ = self->priv->_loading_cancellable;
#line 104 "../src/MessageList/AttachmentButton.vala"
		size = camel_data_wrapper_calculate_decoded_size_sync ((CamelDataWrapper*) _tmp0_, _tmp1_, &_inner_error0_);
#line 104 "../src/MessageList/AttachmentButton.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 799 "AttachmentButton.c"
			goto __catch0_g_error;
		}
#line 105 "../src/MessageList/AttachmentButton.vala"
		_tmp2_ = g_format_size_full ((guint64) size, G_FORMAT_SIZE_DEFAULT);
#line 105 "../src/MessageList/AttachmentButton.vala"
		_g_free0 (_data39_->size_text);
#line 105 "../src/MessageList/AttachmentButton.vala"
		_data39_->size_text = _tmp2_;
#line 808 "AttachmentButton.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 103 "../src/MessageList/AttachmentButton.vala"
		e = _inner_error0_;
#line 103 "../src/MessageList/AttachmentButton.vala"
		_inner_error0_ = NULL;
#line 107 "../src/MessageList/AttachmentButton.vala"
		_tmp3_ = e;
#line 107 "../src/MessageList/AttachmentButton.vala"
		_tmp4_ = _tmp3_->message;
#line 107 "../src/MessageList/AttachmentButton.vala"
		g_critical ("AttachmentButton.vala:107: %s", _tmp4_);
#line 103 "../src/MessageList/AttachmentButton.vala"
		_g_error_free0 (e);
#line 828 "AttachmentButton.c"
	}
	__finally0:
#line 103 "../src/MessageList/AttachmentButton.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "../src/MessageList/AttachmentButton.vala"
		block39_data_unref (_data39_);
#line 103 "../src/MessageList/AttachmentButton.vala"
		_data39_ = NULL;
#line 103 "../src/MessageList/AttachmentButton.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "../src/MessageList/AttachmentButton.vala"
		g_clear_error (&_inner_error0_);
#line 103 "../src/MessageList/AttachmentButton.vala"
		return NULL;
#line 843 "AttachmentButton.c"
	}
#line 110 "../src/MessageList/AttachmentButton.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda54__gsource_func, block39_data_ref (_data39_), block39_data_unref);
#line 121 "../src/MessageList/AttachmentButton.vala"
	result = NULL;
#line 121 "../src/MessageList/AttachmentButton.vala"
	block39_data_unref (_data39_);
#line 121 "../src/MessageList/AttachmentButton.vala"
	_data39_ = NULL;
#line 121 "../src/MessageList/AttachmentButton.vala"
	return result;
#line 855 "AttachmentButton.c"
}

static gpointer
__attachment_button___lambda53__gthread_func (gpointer self)
{
	gpointer result;
	result = _attachment_button___lambda53_ ((AttachmentButton*) self);
#line 101 "../src/MessageList/AttachmentButton.vala"
	g_object_unref (self);
#line 101 "../src/MessageList/AttachmentButton.vala"
	return result;
#line 867 "AttachmentButton.c"
}

static GObject *
attachment_button_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AttachmentButton * self;
	Block38Data* _data38_;
	GSimpleAction* open_action = NULL;
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* save_as_action = NULL;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleActionGroup* actions = NULL;
	GSimpleActionGroup* _tmp4_;
	GSimpleActionGroup* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleActionGroup* _tmp7_;
	GSimpleAction* _tmp8_;
	GSimpleActionGroup* _tmp9_;
	GMenu* context_menu_model = NULL;
	GMenu* _tmp10_;
	GMenu* _tmp11_;
	GMenu* _tmp12_;
	GMenu* _tmp13_;
	GtkMenu* _tmp14_;
	GtkEventBox* event_box = NULL;
	GtkEventBox* _tmp15_;
	GtkEventBox* _tmp16_;
	GtkEventBox* _tmp17_;
	GdkEventMask _tmp18_;
	GdkEventMask _tmp19_;
	GtkEventBox* _tmp20_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp21_ = NULL;
	gchar* mime_type = NULL;
	CamelMimePart* _tmp22_;
	CamelContentType* _tmp23_;
	gchar* _tmp24_;
	gchar* glib_type = NULL;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	GIcon* content_icon = NULL;
	const gchar* _tmp27_;
	GIcon* _tmp28_;
	GIcon* _tmp29_;
	GtkImage* _tmp30_ = NULL;
	CamelMimePart* _tmp31_;
	const gchar* _tmp32_;
	GtkLabel* _tmp33_ = NULL;
	GtkLabel* _tmp34_ = NULL;
	GtkLabel* _tmp35_;
	GtkStyleContext* _tmp36_;
	GThread* _tmp37_;
	GThread* _tmp38_;
	GtkGrid* _tmp39_;
	GtkImage* _tmp40_;
	GtkGrid* _tmp41_;
	GtkLabel* _tmp42_;
	GtkGrid* _tmp43_;
	GtkLabel* _tmp44_;
	GtkEventBox* _tmp45_;
	GtkGrid* _tmp46_;
	GtkEventBox* _tmp47_;
#line 40 "../src/MessageList/AttachmentButton.vala"
	parent_class = G_OBJECT_CLASS (attachment_button_parent_class);
#line 40 "../src/MessageList/AttachmentButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/MessageList/AttachmentButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ATTACHMENT_BUTTON, AttachmentButton);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_data38_ = g_slice_new0 (Block38Data);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_data38_->_ref_count_ = 1;
#line 40 "../src/MessageList/AttachmentButton.vala"
	_data38_->self = g_object_ref (self);
#line 41 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_margin_top ((GtkWidget*) self, 6);
#line 42 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 6);
#line 43 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 6);
#line 44 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 6);
#line 46 "../src/MessageList/AttachmentButton.vala"
	_tmp0_ = g_simple_action_new (ATTACHMENT_BUTTON_ACTION_OPEN, NULL);
#line 46 "../src/MessageList/AttachmentButton.vala"
	open_action = _tmp0_;
#line 47 "../src/MessageList/AttachmentButton.vala"
	_tmp1_ = open_action;
#line 47 "../src/MessageList/AttachmentButton.vala"
	g_signal_connect_object (_tmp1_, "activate", (GCallback) __attachment_button___lambda51__g_simple_action_activate, self, 0);
#line 48 "../src/MessageList/AttachmentButton.vala"
	_tmp2_ = g_simple_action_new (ATTACHMENT_BUTTON_ACTION_SAVE_AS, NULL);
#line 48 "../src/MessageList/AttachmentButton.vala"
	save_as_action = _tmp2_;
#line 49 "../src/MessageList/AttachmentButton.vala"
	_tmp3_ = save_as_action;
#line 49 "../src/MessageList/AttachmentButton.vala"
	g_signal_connect_object (_tmp3_, "activate", (GCallback) _attachment_button_on_save_as_g_simple_action_activate, self, 0);
#line 51 "../src/MessageList/AttachmentButton.vala"
	_tmp4_ = g_simple_action_group_new ();
#line 51 "../src/MessageList/AttachmentButton.vala"
	actions = _tmp4_;
#line 52 "../src/MessageList/AttachmentButton.vala"
	_tmp5_ = actions;
#line 52 "../src/MessageList/AttachmentButton.vala"
	_tmp6_ = open_action;
#line 52 "../src/MessageList/AttachmentButton.vala"
	g_action_map_add_action ((GActionMap*) _tmp5_, (GAction*) _tmp6_);
#line 53 "../src/MessageList/AttachmentButton.vala"
	_tmp7_ = actions;
#line 53 "../src/MessageList/AttachmentButton.vala"
	_tmp8_ = save_as_action;
#line 53 "../src/MessageList/AttachmentButton.vala"
	g_action_map_add_action ((GActionMap*) _tmp7_, (GAction*) _tmp8_);
#line 54 "../src/MessageList/AttachmentButton.vala"
	_tmp9_ = actions;
#line 54 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, ATTACHMENT_BUTTON_ACTION_GROUP_PREFIX, (GActionGroup*) _tmp9_);
#line 56 "../src/MessageList/AttachmentButton.vala"
	_tmp10_ = g_menu_new ();
#line 56 "../src/MessageList/AttachmentButton.vala"
	context_menu_model = _tmp10_;
#line 57 "../src/MessageList/AttachmentButton.vala"
	_tmp11_ = context_menu_model;
#line 57 "../src/MessageList/AttachmentButton.vala"
	g_menu_append (_tmp11_, _ ("Open"), ATTACHMENT_BUTTON_ACTION_PREFIX ATTACHMENT_BUTTON_ACTION_OPEN);
#line 58 "../src/MessageList/AttachmentButton.vala"
	_tmp12_ = context_menu_model;
#line 58 "../src/MessageList/AttachmentButton.vala"
	g_menu_append (_tmp12_, _ ("Save As…"), ATTACHMENT_BUTTON_ACTION_PREFIX ATTACHMENT_BUTTON_ACTION_SAVE_AS);
#line 60 "../src/MessageList/AttachmentButton.vala"
	_tmp13_ = context_menu_model;
#line 60 "../src/MessageList/AttachmentButton.vala"
	_tmp14_ = (GtkMenu*) gtk_menu_new_from_model ((GMenuModel*) _tmp13_);
#line 60 "../src/MessageList/AttachmentButton.vala"
	g_object_ref_sink (_tmp14_);
#line 60 "../src/MessageList/AttachmentButton.vala"
	_data38_->menu = _tmp14_;
#line 62 "../src/MessageList/AttachmentButton.vala"
	_tmp15_ = (GtkEventBox*) gtk_event_box_new ();
#line 62 "../src/MessageList/AttachmentButton.vala"
	g_object_ref_sink (_tmp15_);
#line 62 "../src/MessageList/AttachmentButton.vala"
	event_box = _tmp15_;
#line 63 "../src/MessageList/AttachmentButton.vala"
	_tmp16_ = event_box;
#line 63 "../src/MessageList/AttachmentButton.vala"
	_tmp17_ = event_box;
#line 63 "../src/MessageList/AttachmentButton.vala"
	_tmp18_ = gtk_widget_get_events ((GtkWidget*) _tmp17_);
#line 63 "../src/MessageList/AttachmentButton.vala"
	_tmp19_ = _tmp18_;
#line 63 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_events ((GtkWidget*) _tmp17_, _tmp19_ | GDK_BUTTON_PRESS_MASK);
#line 64 "../src/MessageList/AttachmentButton.vala"
	_tmp20_ = event_box;
#line 64 "../src/MessageList/AttachmentButton.vala"
	g_signal_connect_data ((GtkWidget*) _tmp20_, "button-press-event", (GCallback) __attachment_button___lambda52__gtk_widget_button_press_event, block38_data_ref (_data38_), (GClosureNotify) block38_data_unref, 0);
#line 76 "../src/MessageList/AttachmentButton.vala"
	_tmp21_ = (GtkGrid*) gtk_grid_new ();
#line 76 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp21_, 6);
#line 76 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp21_, 6);
#line 76 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp21_, 6);
#line 76 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp21_, 6);
#line 76 "../src/MessageList/AttachmentButton.vala"
	gtk_grid_set_column_spacing (_tmp21_, 6);
#line 76 "../src/MessageList/AttachmentButton.vala"
	g_object_ref_sink (_tmp21_);
#line 76 "../src/MessageList/AttachmentButton.vala"
	grid = _tmp21_;
#line 84 "../src/MessageList/AttachmentButton.vala"
	_tmp22_ = self->priv->_mime_part;
#line 84 "../src/MessageList/AttachmentButton.vala"
	_tmp23_ = camel_mime_part_get_content_type (_tmp22_);
#line 84 "../src/MessageList/AttachmentButton.vala"
	_tmp24_ = camel_content_type_simple (_tmp23_);
#line 84 "../src/MessageList/AttachmentButton.vala"
	mime_type = _tmp24_;
#line 85 "../src/MessageList/AttachmentButton.vala"
	_tmp25_ = mime_type;
#line 85 "../src/MessageList/AttachmentButton.vala"
	_tmp26_ = g_content_type_from_mime_type (_tmp25_);
#line 85 "../src/MessageList/AttachmentButton.vala"
	glib_type = _tmp26_;
#line 86 "../src/MessageList/AttachmentButton.vala"
	_tmp27_ = glib_type;
#line 86 "../src/MessageList/AttachmentButton.vala"
	_tmp28_ = g_content_type_get_icon (_tmp27_);
#line 86 "../src/MessageList/AttachmentButton.vala"
	content_icon = _tmp28_;
#line 88 "../src/MessageList/AttachmentButton.vala"
	_tmp29_ = content_icon;
#line 88 "../src/MessageList/AttachmentButton.vala"
	_tmp30_ = (GtkImage*) gtk_image_new_from_gicon (_tmp29_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 88 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp30_, GTK_ALIGN_CENTER);
#line 88 "../src/MessageList/AttachmentButton.vala"
	g_object_ref_sink (_tmp30_);
#line 88 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (self->priv->preview_image);
#line 88 "../src/MessageList/AttachmentButton.vala"
	self->priv->preview_image = _tmp30_;
#line 92 "../src/MessageList/AttachmentButton.vala"
	_tmp31_ = self->priv->_mime_part;
#line 92 "../src/MessageList/AttachmentButton.vala"
	_tmp32_ = camel_mime_part_get_filename (_tmp31_);
#line 92 "../src/MessageList/AttachmentButton.vala"
	_tmp33_ = (GtkLabel*) gtk_label_new (_tmp32_);
#line 92 "../src/MessageList/AttachmentButton.vala"
	gtk_label_set_xalign (_tmp33_, (gfloat) 0);
#line 92 "../src/MessageList/AttachmentButton.vala"
	g_object_ref_sink (_tmp33_);
#line 92 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (self->priv->name_label);
#line 92 "../src/MessageList/AttachmentButton.vala"
	self->priv->name_label = _tmp33_;
#line 96 "../src/MessageList/AttachmentButton.vala"
	_tmp34_ = (GtkLabel*) gtk_label_new (NULL);
#line 96 "../src/MessageList/AttachmentButton.vala"
	gtk_label_set_xalign (_tmp34_, (gfloat) 0);
#line 96 "../src/MessageList/AttachmentButton.vala"
	g_object_ref_sink (_tmp34_);
#line 96 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (self->priv->size_label);
#line 96 "../src/MessageList/AttachmentButton.vala"
	self->priv->size_label = _tmp34_;
#line 99 "../src/MessageList/AttachmentButton.vala"
	_tmp35_ = self->priv->size_label;
#line 99 "../src/MessageList/AttachmentButton.vala"
	_tmp36_ = gtk_widget_get_style_context ((GtkWidget*) _tmp35_);
#line 99 "../src/MessageList/AttachmentButton.vala"
	gtk_style_context_add_class (_tmp36_, GTK_STYLE_CLASS_DIM_LABEL);
#line 101 "../src/MessageList/AttachmentButton.vala"
	_tmp37_ = g_thread_new (NULL, __attachment_button___lambda53__gthread_func, g_object_ref (self));
#line 101 "../src/MessageList/AttachmentButton.vala"
	_tmp38_ = _tmp37_;
#line 101 "../src/MessageList/AttachmentButton.vala"
	_g_thread_unref0 (_tmp38_);
#line 124 "../src/MessageList/AttachmentButton.vala"
	_tmp39_ = grid;
#line 124 "../src/MessageList/AttachmentButton.vala"
	_tmp40_ = self->priv->preview_image;
#line 124 "../src/MessageList/AttachmentButton.vala"
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp40_, 0, 0, 1, 2);
#line 125 "../src/MessageList/AttachmentButton.vala"
	_tmp41_ = grid;
#line 125 "../src/MessageList/AttachmentButton.vala"
	_tmp42_ = self->priv->name_label;
#line 125 "../src/MessageList/AttachmentButton.vala"
	gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp42_, 1, 0, 1, 1);
#line 126 "../src/MessageList/AttachmentButton.vala"
	_tmp43_ = grid;
#line 126 "../src/MessageList/AttachmentButton.vala"
	_tmp44_ = self->priv->size_label;
#line 126 "../src/MessageList/AttachmentButton.vala"
	gtk_grid_attach (_tmp43_, (GtkWidget*) _tmp44_, 1, 1, 1, 1);
#line 127 "../src/MessageList/AttachmentButton.vala"
	_tmp45_ = event_box;
#line 127 "../src/MessageList/AttachmentButton.vala"
	_tmp46_ = grid;
#line 127 "../src/MessageList/AttachmentButton.vala"
	gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
#line 128 "../src/MessageList/AttachmentButton.vala"
	_tmp47_ = event_box;
#line 128 "../src/MessageList/AttachmentButton.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp47_);
#line 129 "../src/MessageList/AttachmentButton.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (content_icon);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_g_free0 (glib_type);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_g_free0 (mime_type);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (grid);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (event_box);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (context_menu_model);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (actions);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (save_as_action);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (open_action);
#line 40 "../src/MessageList/AttachmentButton.vala"
	block38_data_unref (_data38_);
#line 40 "../src/MessageList/AttachmentButton.vala"
	_data38_ = NULL;
#line 40 "../src/MessageList/AttachmentButton.vala"
	return obj;
#line 1170 "AttachmentButton.c"
}

static void
attachment_button_class_init (AttachmentButtonClass * klass,
                              gpointer klass_data)
{
#line 21 "../src/MessageList/AttachmentButton.vala"
	attachment_button_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/MessageList/AttachmentButton.vala"
	g_type_class_adjust_private_offset (klass, &AttachmentButton_private_offset);
#line 21 "../src/MessageList/AttachmentButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_attachment_button_get_property;
#line 21 "../src/MessageList/AttachmentButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_attachment_button_set_property;
#line 21 "../src/MessageList/AttachmentButton.vala"
	G_OBJECT_CLASS (klass)->constructor = attachment_button_constructor;
#line 21 "../src/MessageList/AttachmentButton.vala"
	G_OBJECT_CLASS (klass)->finalize = attachment_button_finalize;
#line 21 "../src/MessageList/AttachmentButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ATTACHMENT_BUTTON_MIME_PART_PROPERTY, attachment_button_properties[ATTACHMENT_BUTTON_MIME_PART_PROPERTY] = g_param_spec_object ("mime-part", "mime-part", "mime-part", camel_mime_part_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/MessageList/AttachmentButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ATTACHMENT_BUTTON_LOADING_CANCELLABLE_PROPERTY, attachment_button_properties[ATTACHMENT_BUTTON_LOADING_CANCELLABLE_PROPERTY] = g_param_spec_object ("loading-cancellable", "loading-cancellable", "loading-cancellable", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1193 "AttachmentButton.c"
}

static void
attachment_button_instance_init (AttachmentButton * self,
                                 gpointer klass)
{
#line 21 "../src/MessageList/AttachmentButton.vala"
	self->priv = attachment_button_get_instance_private (self);
#line 1202 "AttachmentButton.c"
}

static void
attachment_button_finalize (GObject * obj)
{
	AttachmentButton * self;
#line 21 "../src/MessageList/AttachmentButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ATTACHMENT_BUTTON, AttachmentButton);
#line 22 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (self->priv->_mime_part);
#line 30 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (self->priv->preview_image);
#line 31 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (self->priv->name_label);
#line 32 "../src/MessageList/AttachmentButton.vala"
	_g_object_unref0 (self->priv->size_label);
#line 21 "../src/MessageList/AttachmentButton.vala"
	G_OBJECT_CLASS (attachment_button_parent_class)->finalize (obj);
#line 1221 "AttachmentButton.c"
}

static GType
attachment_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AttachmentButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) attachment_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AttachmentButton), 0, (GInstanceInitFunc) attachment_button_instance_init, NULL };
	GType attachment_button_type_id;
	attachment_button_type_id = g_type_register_static (gtk_flow_box_child_get_type (), "AttachmentButton", &g_define_type_info, 0);
	AttachmentButton_private_offset = g_type_add_instance_private (attachment_button_type_id, sizeof (AttachmentButtonPrivate));
	return attachment_button_type_id;
}

GType
attachment_button_get_type (void)
{
	static volatile gsize attachment_button_type_id__once = 0;
	if (g_once_init_enter (&attachment_button_type_id__once)) {
		GType attachment_button_type_id;
		attachment_button_type_id = attachment_button_get_type_once ();
		g_once_init_leave (&attachment_button_type_id__once, attachment_button_type_id);
	}
	return attachment_button_type_id__once;
}

static void
_vala_attachment_button_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	AttachmentButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ATTACHMENT_BUTTON, AttachmentButton);
#line 21 "../src/MessageList/AttachmentButton.vala"
	switch (property_id) {
#line 21 "../src/MessageList/AttachmentButton.vala"
		case ATTACHMENT_BUTTON_MIME_PART_PROPERTY:
#line 21 "../src/MessageList/AttachmentButton.vala"
		g_value_set_object (value, attachment_button_get_mime_part (self));
#line 21 "../src/MessageList/AttachmentButton.vala"
		break;
#line 21 "../src/MessageList/AttachmentButton.vala"
		case ATTACHMENT_BUTTON_LOADING_CANCELLABLE_PROPERTY:
#line 21 "../src/MessageList/AttachmentButton.vala"
		g_value_set_object (value, attachment_button_get_loading_cancellable (self));
#line 21 "../src/MessageList/AttachmentButton.vala"
		break;
#line 1268 "AttachmentButton.c"
		default:
#line 21 "../src/MessageList/AttachmentButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/MessageList/AttachmentButton.vala"
		break;
#line 1274 "AttachmentButton.c"
	}
}

static void
_vala_attachment_button_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	AttachmentButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ATTACHMENT_BUTTON, AttachmentButton);
#line 21 "../src/MessageList/AttachmentButton.vala"
	switch (property_id) {
#line 21 "../src/MessageList/AttachmentButton.vala"
		case ATTACHMENT_BUTTON_MIME_PART_PROPERTY:
#line 21 "../src/MessageList/AttachmentButton.vala"
		attachment_button_set_mime_part (self, g_value_get_object (value));
#line 21 "../src/MessageList/AttachmentButton.vala"
		break;
#line 21 "../src/MessageList/AttachmentButton.vala"
		case ATTACHMENT_BUTTON_LOADING_CANCELLABLE_PROPERTY:
#line 21 "../src/MessageList/AttachmentButton.vala"
		attachment_button_set_loading_cancellable (self, g_value_get_object (value));
#line 21 "../src/MessageList/AttachmentButton.vala"
		break;
#line 1300 "AttachmentButton.c"
		default:
#line 21 "../src/MessageList/AttachmentButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/MessageList/AttachmentButton.vala"
		break;
#line 1306 "AttachmentButton.c"
	}
}

