/* MessageList.c generated by valac 0.56.14, the Vala compiler
 * generated from MessageList.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2017-2023 elementary, Inc. (https://elementary.io)
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <camel/camel.h>
#include <gio/gio.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define MAIL_MAIN_WINDOW_ACTION_FORWARD "forward"
#define MAIL_MAIN_WINDOW_ACTION_REPLY_ALL "reply-all"
#define MAIL_MAIN_WINDOW_ACTION_REPLY "reply"
#define MAIL_MAIN_WINDOW_ACTION_MODIFY "modify"
#define MAIL_MAIN_WINDOW_ACTION_ARCHIVE "archive"
#define MAIL_MAIN_WINDOW_ACTION_MOVE "move"
#define MAIL_MAIN_WINDOW_ACTION_MOVE_TO_TRASH "trash"
#define MAIL_MAIN_WINDOW_ACTION_GROUP_PREFIX "win"
#define MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_GROUP_PREFIX "."
#define MAIL_MAIN_WINDOW_ACTION_MARK_UNREAD "mark-unread"
#define MAIL_MAIN_WINDOW_ACTION_MARK_READ "mark-read"
#define MAIL_MAIN_WINDOW_ACTION_MARK_STAR "mark-star"
#define MAIL_MAIN_WINDOW_ACTION_MARK_UNSTAR "mark-unstar"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MAIL_TYPE_MESSAGE_LIST (mail_message_list_get_type ())
#define MAIL_MESSAGE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_MESSAGE_LIST, MailMessageList))
#define MAIL_MESSAGE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_MESSAGE_LIST, MailMessageListClass))
#define MAIL_IS_MESSAGE_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_MESSAGE_LIST))
#define MAIL_IS_MESSAGE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_MESSAGE_LIST))
#define MAIL_MESSAGE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_MESSAGE_LIST, MailMessageListClass))

typedef struct _MailMessageList MailMessageList;
typedef struct _MailMessageListClass MailMessageListClass;
typedef struct _MailMessageListPrivate MailMessageListPrivate;

#define MAIL_TYPE_FOLDER_POPOVER (mail_folder_popover_get_type ())
#define MAIL_FOLDER_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_FOLDER_POPOVER, MailFolderPopover))
#define MAIL_FOLDER_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_FOLDER_POPOVER, MailFolderPopoverClass))
#define MAIL_IS_FOLDER_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_FOLDER_POPOVER))
#define MAIL_IS_FOLDER_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_FOLDER_POPOVER))
#define MAIL_FOLDER_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_FOLDER_POPOVER, MailFolderPopoverClass))

typedef struct _MailFolderPopover MailFolderPopover;
typedef struct _MailFolderPopoverClass MailFolderPopoverClass;

#define MAIL_TYPE_MESSAGE_LIST_ITEM (mail_message_list_item_get_type ())
#define MAIL_MESSAGE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_MESSAGE_LIST_ITEM, MailMessageListItem))
#define MAIL_MESSAGE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_MESSAGE_LIST_ITEM, MailMessageListItemClass))
#define MAIL_IS_MESSAGE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_MESSAGE_LIST_ITEM))
#define MAIL_IS_MESSAGE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_MESSAGE_LIST_ITEM))
#define MAIL_MESSAGE_LIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_MESSAGE_LIST_ITEM, MailMessageListItemClass))

typedef struct _MailMessageListItem MailMessageListItem;
typedef struct _MailMessageListItemClass MailMessageListItemClass;
enum  {
	MAIL_MESSAGE_LIST_0_PROPERTY,
	MAIL_MESSAGE_LIST_HEADERBAR_PROPERTY,
	MAIL_MESSAGE_LIST_NUM_PROPERTIES
};
static GParamSpec* mail_message_list_properties[MAIL_MESSAGE_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block41Data Block41Data;
typedef enum  {
	MAIL_COMPOSER_TYPE_REPLY,
	MAIL_COMPOSER_TYPE_REPLY_ALL,
	MAIL_COMPOSER_TYPE_FORWARD,
	MAIL_COMPOSER_TYPE_DRAFT
} MailComposerType;

#define MAIL_COMPOSER_TYPE_TYPE (mail_composer_type_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define MAIL_TYPE_COMPOSER (mail_composer_get_type ())
#define MAIL_COMPOSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_COMPOSER, MailComposer))
#define MAIL_COMPOSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_COMPOSER, MailComposerClass))
#define MAIL_IS_COMPOSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_COMPOSER))
#define MAIL_IS_COMPOSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_COMPOSER))
#define MAIL_COMPOSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_COMPOSER, MailComposerClass))

typedef struct _MailComposer MailComposer;
typedef struct _MailComposerClass MailComposerClass;
typedef struct _MailMessageListComposeData MailMessageListComposeData;
enum  {
	MAIL_MESSAGE_LIST_HOVERING_OVER_LINK_SIGNAL,
	MAIL_MESSAGE_LIST_NUM_SIGNALS
};
static guint mail_message_list_signals[MAIL_MESSAGE_LIST_NUM_SIGNALS] = {0};

struct _MailMessageList {
	GtkBox parent_instance;
	MailMessageListPrivate * priv;
};

struct _MailMessageListClass {
	GtkBoxClass parent_class;
};

struct _MailMessageListPrivate {
	HdyHeaderBar* _headerbar;
	MailFolderPopover* folder_popover;
	GtkListBox* list_box;
	GtkScrolledWindow* scrolled_window;
	GeeHashMap* messages;
};

struct _Block41Data {
	int _ref_count_;
	MailMessageList* self;
	MailMessageListItem* list_item;
};

struct _MailMessageListComposeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MailMessageList* self;
	MailComposerType type;
	GVariant* uid;
	GtkListBoxRow* last_child;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GtkListBoxRow* _tmp4_;
	GtkListBoxRow* _tmp5_;
	GtkListBoxRow* _tmp6_;
	GtkListBoxRow* _tmp7_;
	MailMessageListItem* message_item;
	const gchar* _tmp8_;
	GtkListBoxRow* _tmp9_;
	MailMessageListItem* _tmp10_;
	GeeHashMap* _tmp11_;
	const gchar* _tmp12_;
	gpointer _tmp13_;
	gchar* content_to_quote;
	gchar* _tmp14_;
	CamelMimeMessage* mime_message;
	CamelMessageInfo* message_info;
	MailMessageListItem* _tmp15_;
	gchar* _tmp16_;
	MailMessageListItem* _tmp17_;
	CamelMimeMessage* _tmp18_;
	CamelMimeMessage* _tmp19_;
	CamelMimeMessage* _tmp20_;
	MailMessageListItem* _tmp21_;
	CamelMessageInfo* _tmp22_;
	CamelMessageInfo* _tmp23_;
	CamelMessageInfo* _tmp24_;
	MailComposer* composer;
	CamelMessageInfo* _tmp25_;
	CamelMimeMessage* _tmp26_;
	const gchar* _tmp27_;
	MailComposer* _tmp28_;
	MailComposer* _tmp29_;
	MailComposer* _tmp30_;
};

static gint MailMessageList_private_offset;
static gpointer mail_message_list_parent_class = NULL;

VALA_EXTERN GType mail_message_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailMessageList, g_object_unref)
VALA_EXTERN GType mail_folder_popover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailFolderPopover, g_object_unref)
VALA_EXTERN GType mail_message_list_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailMessageListItem, g_object_unref)
VALA_EXTERN void mail_message_list_set_conversation (MailMessageList* self,
                                         CamelFolderThreadNode* node);
static void mail_message_list_can_reply (MailMessageList* self,
                                  gboolean enabled);
static void mail_message_list_can_move_thread (MailMessageList* self,
                                        gboolean enabled);
static void __lambda68_ (MailMessageList* self,
                  GtkWidget* child);
static void ___lambda68__gfunc (gconstpointer data,
                         gpointer self);
VALA_EXTERN void mail_folder_popover_set_store (MailFolderPopover* self,
                                    CamelStore* store);
VALA_EXTERN MailMessageListItem* mail_message_list_item_new (CamelMessageInfo* message_info);
VALA_EXTERN MailMessageListItem* mail_message_list_item_construct (GType object_type,
                                                       CamelMessageInfo* message_info);
static void mail_message_list_go_down (MailMessageList* self,
                                CamelFolderThreadNode* node);
static Block41Data* block41_data_ref (Block41Data* _data41_);
static void block41_data_unref (void * _userdata_);
VALA_EXTERN void mail_message_list_item_set_expanded (MailMessageListItem* self,
                                          gboolean value);
VALA_EXTERN gboolean mail_message_list_item_get_loaded (MailMessageListItem* self);
static void ____lambda69_ (Block41Data* _data41_);
static void _____lambda69__g_object_notify (GObject* _sender,
                                     GParamSpec* pspec,
                                     gpointer self);
VALA_EXTERN GType mail_composer_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void mail_message_list_compose (MailMessageList* self,
                                MailComposerType type,
                                GVariant* uid,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
VALA_EXTERN void mail_message_list_compose_finish (MailMessageList* self,
                                       GAsyncResult* _res_);
static GVariant* _variant_new20 (const gchar* value);
static void mail_message_list_compose_data_free (gpointer _data);
static gboolean mail_message_list_compose_co (MailMessageListComposeData* _data_);
VALA_EXTERN void mail_message_list_item_get_message_body_html (MailMessageListItem* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN gchar* mail_message_list_item_get_message_body_html_finish (MailMessageListItem* self,
                                                            GAsyncResult* _res_);
static void mail_message_list_compose_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
VALA_EXTERN CamelMimeMessage* mail_message_list_item_get_mime_message (MailMessageListItem* self);
VALA_EXTERN CamelMessageInfo* mail_message_list_item_get_message_info (MailMessageListItem* self);
VALA_EXTERN GType mail_composer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailComposer, g_object_unref)
VALA_EXTERN MailComposer* mail_composer_new_with_quote (MailComposerType type,
                                            CamelMessageInfo* info,
                                            CamelMimeMessage* message,
                                            const gchar* content);
VALA_EXTERN MailComposer* mail_composer_construct_with_quote (GType object_type,
                                                  MailComposerType type,
                                                  CamelMessageInfo* info,
                                                  CamelMimeMessage* message,
                                                  const gchar* content);
static void __lambda105_ (MailMessageList* self);
static void ___lambda105__mail_composer_finished (MailComposer* _sender,
                                           gpointer self);
VALA_EXTERN void mail_message_list_print (MailMessageList* self,
                              GVariant* uid);
VALA_EXTERN void mail_message_list_item_print (MailMessageListItem* self);
static gint mail_message_list_message_sort_function (GtkListBoxRow* item1,
                                              GtkListBoxRow* item2);
VALA_EXTERN MailMessageList* mail_message_list_new (void);
VALA_EXTERN MailMessageList* mail_message_list_construct (GType object_type);
VALA_EXTERN HdyHeaderBar* mail_message_list_get_headerbar (MailMessageList* self);
static void mail_message_list_set_headerbar (MailMessageList* self,
                                      HdyHeaderBar* value);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GObject * mail_message_list_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static GVariant* _variant_new21 (const gchar* value);
static GVariant* _variant_new22 (const gchar* value);
static GVariant* _variant_new23 (const gchar* value);
VALA_EXTERN MailFolderPopover* mail_folder_popover_new (void);
VALA_EXTERN MailFolderPopover* mail_folder_popover_construct (GType object_type);
static gint _mail_message_list_message_sort_function_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                      GtkListBoxRow* row2,
                                                                      gpointer self);
static void mail_message_list_finalize (GObject * obj);
static GType mail_message_list_get_type_once (void);
static void _vala_mail_message_list_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_mail_message_list_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
mail_message_list_get_instance_private (MailMessageList* self)
{
	return G_STRUCT_MEMBER_P (self, MailMessageList_private_offset);
}

static void
__lambda68_ (MailMessageList* self,
             GtkWidget* child)
{
#line 167 "../src/MessageList/MessageList.vala"
	g_return_if_fail (child != NULL);
#line 168 "../src/MessageList/MessageList.vala"
	gtk_widget_destroy (child);
#line 313 "MessageList.c"
}

static void
___lambda68__gfunc (gconstpointer data,
                    gpointer self)
{
#line 167 "../src/MessageList/MessageList.vala"
	__lambda68_ ((MailMessageList*) self, (GtkWidget*) data);
#line 322 "MessageList.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 182 "../src/MessageList/MessageList.vala"
	return self ? g_object_ref (self) : NULL;
#line 330 "MessageList.c"
}

static Block41Data*
block41_data_ref (Block41Data* _data41_)
{
#line 196 "../src/MessageList/MessageList.vala"
	g_atomic_int_inc (&_data41_->_ref_count_);
#line 196 "../src/MessageList/MessageList.vala"
	return _data41_;
#line 340 "MessageList.c"
}

static void
block41_data_unref (void * _userdata_)
{
	Block41Data* _data41_;
	_data41_ = (Block41Data*) _userdata_;
#line 196 "../src/MessageList/MessageList.vala"
	if (g_atomic_int_dec_and_test (&_data41_->_ref_count_)) {
#line 350 "MessageList.c"
		MailMessageList* self;
#line 196 "../src/MessageList/MessageList.vala"
		self = _data41_->self;
#line 196 "../src/MessageList/MessageList.vala"
		_g_object_unref0 (_data41_->list_item);
#line 196 "../src/MessageList/MessageList.vala"
		_g_object_unref0 (self);
#line 196 "../src/MessageList/MessageList.vala"
		g_slice_free (Block41Data, _data41_);
#line 360 "MessageList.c"
	}
}

static void
____lambda69_ (Block41Data* _data41_)
{
	MailMessageList* self;
	MailMessageListItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 200 "../src/MessageList/MessageList.vala"
	self = _data41_->self;
#line 201 "../src/MessageList/MessageList.vala"
	_tmp0_ = _data41_->list_item;
#line 201 "../src/MessageList/MessageList.vala"
	_tmp1_ = mail_message_list_item_get_loaded (_tmp0_);
#line 201 "../src/MessageList/MessageList.vala"
	_tmp2_ = _tmp1_;
#line 201 "../src/MessageList/MessageList.vala"
	mail_message_list_can_reply (self, _tmp2_);
#line 381 "MessageList.c"
}

static void
_____lambda69__g_object_notify (GObject* _sender,
                                GParamSpec* pspec,
                                gpointer self)
{
#line 200 "../src/MessageList/MessageList.vala"
	____lambda69_ (self);
#line 391 "MessageList.c"
}

static GVariant*
_variant_new20 (const gchar* value)
{
#line 207 "../src/MessageList/MessageList.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 399 "MessageList.c"
}

void
mail_message_list_set_conversation (MailMessageList* self,
                                    CamelFolderThreadNode* node)
{
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GeeHashMap* _tmp3_;
	CamelStore* store = NULL;
	CamelMessageInfo* _tmp4_;
	CamelFolderSummary* _tmp5_;
	CamelFolderSummary* _tmp6_;
	CamelFolderSummary* _tmp7_;
	CamelFolder* _tmp8_;
	CamelFolder* _tmp9_;
	CamelStore* _tmp10_;
	CamelStore* _tmp11_;
	CamelStore* _tmp12_;
	CamelStore* _tmp13_;
	MailFolderPopover* _tmp14_;
	CamelStore* _tmp15_;
	MailMessageListItem* item = NULL;
	CamelMessageInfo* _tmp16_;
	MailMessageListItem* _tmp17_;
	GtkListBox* _tmp18_;
	MailMessageListItem* _tmp19_;
	GeeHashMap* _tmp20_;
	CamelMessageInfo* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	MailMessageListItem* _tmp24_;
	CamelFolderThreadNode* _tmp25_;
	GList* children = NULL;
	GtkListBox* _tmp27_;
	GList* _tmp28_;
	guint num_children = 0U;
	GList* _tmp29_;
	gboolean _tmp43_ = FALSE;
	CamelMessageInfo* _tmp44_;
#line 158 "../src/MessageList/MessageList.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/MessageList/MessageList.vala"
	mail_message_list_can_reply (self, FALSE);
#line 165 "../src/MessageList/MessageList.vala"
	mail_message_list_can_move_thread (self, FALSE);
#line 167 "../src/MessageList/MessageList.vala"
	_tmp0_ = self->priv->list_box;
#line 167 "../src/MessageList/MessageList.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 167 "../src/MessageList/MessageList.vala"
	_tmp2_ = _tmp1_;
#line 167 "../src/MessageList/MessageList.vala"
	g_list_foreach (_tmp2_, ___lambda68__gfunc, self);
#line 167 "../src/MessageList/MessageList.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 170 "../src/MessageList/MessageList.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, MAIL_TYPE_MESSAGE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 170 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (self->priv->messages);
#line 170 "../src/MessageList/MessageList.vala"
	self->priv->messages = _tmp3_;
#line 172 "../src/MessageList/MessageList.vala"
	if (node == NULL) {
#line 173 "../src/MessageList/MessageList.vala"
		return;
#line 467 "MessageList.c"
	}
#line 180 "../src/MessageList/MessageList.vala"
	mail_message_list_can_move_thread (self, TRUE);
#line 182 "../src/MessageList/MessageList.vala"
	_tmp4_ = node->message;
#line 182 "../src/MessageList/MessageList.vala"
	g_object_get (_tmp4_, "summary", &_tmp5_, NULL);
#line 182 "../src/MessageList/MessageList.vala"
	_tmp6_ = _tmp5_;
#line 182 "../src/MessageList/MessageList.vala"
	_tmp7_ = _tmp6_;
#line 182 "../src/MessageList/MessageList.vala"
	_tmp8_ = camel_folder_summary_get_folder (_tmp7_);
#line 182 "../src/MessageList/MessageList.vala"
	_tmp9_ = _tmp8_;
#line 182 "../src/MessageList/MessageList.vala"
	_tmp10_ = camel_folder_get_parent_store (_tmp9_);
#line 182 "../src/MessageList/MessageList.vala"
	_tmp11_ = _tmp10_;
#line 182 "../src/MessageList/MessageList.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 182 "../src/MessageList/MessageList.vala"
	_tmp13_ = _tmp12_;
#line 182 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp7_);
#line 182 "../src/MessageList/MessageList.vala"
	store = _tmp13_;
#line 183 "../src/MessageList/MessageList.vala"
	_tmp14_ = self->priv->folder_popover;
#line 183 "../src/MessageList/MessageList.vala"
	_tmp15_ = store;
#line 183 "../src/MessageList/MessageList.vala"
	mail_folder_popover_set_store (_tmp14_, _tmp15_);
#line 185 "../src/MessageList/MessageList.vala"
	_tmp16_ = node->message;
#line 185 "../src/MessageList/MessageList.vala"
	_tmp17_ = mail_message_list_item_new (_tmp16_);
#line 185 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp17_);
#line 185 "../src/MessageList/MessageList.vala"
	item = _tmp17_;
#line 186 "../src/MessageList/MessageList.vala"
	_tmp18_ = self->priv->list_box;
#line 186 "../src/MessageList/MessageList.vala"
	_tmp19_ = item;
#line 186 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 187 "../src/MessageList/MessageList.vala"
	_tmp20_ = self->priv->messages;
#line 187 "../src/MessageList/MessageList.vala"
	_tmp21_ = node->message;
#line 187 "../src/MessageList/MessageList.vala"
	_tmp22_ = camel_message_info_get_uid (_tmp21_);
#line 187 "../src/MessageList/MessageList.vala"
	_tmp23_ = _tmp22_;
#line 187 "../src/MessageList/MessageList.vala"
	_tmp24_ = item;
#line 187 "../src/MessageList/MessageList.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp20_, _tmp23_, _tmp24_);
#line 188 "../src/MessageList/MessageList.vala"
	_tmp25_ = node->child;
#line 188 "../src/MessageList/MessageList.vala"
	if (_tmp25_ != NULL) {
#line 531 "MessageList.c"
		CamelFolderThreadNode* _tmp26_;
#line 189 "../src/MessageList/MessageList.vala"
		_tmp26_ = node->child;
#line 189 "../src/MessageList/MessageList.vala"
		mail_message_list_go_down (self, (CamelFolderThreadNode*) _tmp26_);
#line 537 "MessageList.c"
	}
#line 192 "../src/MessageList/MessageList.vala"
	_tmp27_ = self->priv->list_box;
#line 192 "../src/MessageList/MessageList.vala"
	_tmp28_ = gtk_container_get_children ((GtkContainer*) _tmp27_);
#line 192 "../src/MessageList/MessageList.vala"
	children = _tmp28_;
#line 193 "../src/MessageList/MessageList.vala"
	_tmp29_ = children;
#line 193 "../src/MessageList/MessageList.vala"
	num_children = g_list_length (_tmp29_);
#line 194 "../src/MessageList/MessageList.vala"
	if (num_children > ((guint) 0)) {
#line 551 "MessageList.c"
		GtkListBoxRow* child = NULL;
		GtkListBox* _tmp30_;
		GtkListBoxRow* _tmp31_;
		GtkListBoxRow* _tmp32_;
		gboolean _tmp33_ = FALSE;
		GtkListBoxRow* _tmp34_;
#line 195 "../src/MessageList/MessageList.vala"
		_tmp30_ = self->priv->list_box;
#line 195 "../src/MessageList/MessageList.vala"
		_tmp31_ = gtk_list_box_get_row_at_index (_tmp30_, ((gint) num_children) - 1);
#line 195 "../src/MessageList/MessageList.vala"
		_tmp32_ = _g_object_ref0 (_tmp31_);
#line 195 "../src/MessageList/MessageList.vala"
		child = _tmp32_;
#line 196 "../src/MessageList/MessageList.vala"
		_tmp34_ = child;
#line 196 "../src/MessageList/MessageList.vala"
		if (_tmp34_ != NULL) {
#line 570 "MessageList.c"
			GtkListBoxRow* _tmp35_;
#line 196 "../src/MessageList/MessageList.vala"
			_tmp35_ = child;
#line 196 "../src/MessageList/MessageList.vala"
			_tmp33_ = MAIL_IS_MESSAGE_LIST_ITEM (_tmp35_);
#line 576 "MessageList.c"
		} else {
#line 196 "../src/MessageList/MessageList.vala"
			_tmp33_ = FALSE;
#line 580 "MessageList.c"
		}
#line 196 "../src/MessageList/MessageList.vala"
		if (_tmp33_) {
#line 584 "MessageList.c"
			Block41Data* _data41_;
			GtkListBoxRow* _tmp36_;
			MailMessageListItem* _tmp37_;
			MailMessageListItem* _tmp38_;
			MailMessageListItem* _tmp39_;
			gboolean _tmp40_;
			gboolean _tmp41_;
			MailMessageListItem* _tmp42_;
#line 196 "../src/MessageList/MessageList.vala"
			_data41_ = g_slice_new0 (Block41Data);
#line 196 "../src/MessageList/MessageList.vala"
			_data41_->_ref_count_ = 1;
#line 196 "../src/MessageList/MessageList.vala"
			_data41_->self = g_object_ref (self);
#line 197 "../src/MessageList/MessageList.vala"
			_tmp36_ = child;
#line 197 "../src/MessageList/MessageList.vala"
			_tmp37_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, MAIL_TYPE_MESSAGE_LIST_ITEM, MailMessageListItem));
#line 197 "../src/MessageList/MessageList.vala"
			_data41_->list_item = _tmp37_;
#line 198 "../src/MessageList/MessageList.vala"
			_tmp38_ = _data41_->list_item;
#line 198 "../src/MessageList/MessageList.vala"
			mail_message_list_item_set_expanded (_tmp38_, TRUE);
#line 199 "../src/MessageList/MessageList.vala"
			_tmp39_ = _data41_->list_item;
#line 199 "../src/MessageList/MessageList.vala"
			_tmp40_ = mail_message_list_item_get_loaded (_tmp39_);
#line 199 "../src/MessageList/MessageList.vala"
			_tmp41_ = _tmp40_;
#line 199 "../src/MessageList/MessageList.vala"
			mail_message_list_can_reply (self, _tmp41_);
#line 200 "../src/MessageList/MessageList.vala"
			_tmp42_ = _data41_->list_item;
#line 200 "../src/MessageList/MessageList.vala"
			g_signal_connect_data ((GObject*) _tmp42_, "notify::loaded", (GCallback) _____lambda69__g_object_notify, block41_data_ref (_data41_), (GClosureNotify) block41_data_unref, 0);
#line 196 "../src/MessageList/MessageList.vala"
			block41_data_unref (_data41_);
#line 196 "../src/MessageList/MessageList.vala"
			_data41_ = NULL;
#line 625 "MessageList.c"
		}
#line 194 "../src/MessageList/MessageList.vala"
		_g_object_unref0 (child);
#line 629 "MessageList.c"
	}
#line 206 "../src/MessageList/MessageList.vala"
	_tmp44_ = node->message;
#line 206 "../src/MessageList/MessageList.vala"
	if (_tmp44_ != NULL) {
#line 635 "MessageList.c"
		CamelMessageInfo* _tmp45_;
		CamelMessageFlags _tmp46_;
		CamelMessageFlags _tmp47_;
#line 206 "../src/MessageList/MessageList.vala"
		_tmp45_ = node->message;
#line 206 "../src/MessageList/MessageList.vala"
		g_object_get (_tmp45_, "flags", &_tmp46_, NULL);
#line 206 "../src/MessageList/MessageList.vala"
		_tmp47_ = _tmp46_;
#line 206 "../src/MessageList/MessageList.vala"
		_tmp43_ = (((gint) _tmp47_) & CAMEL_MESSAGE_DRAFT) == CAMEL_MESSAGE_DRAFT;
#line 647 "MessageList.c"
	} else {
#line 206 "../src/MessageList/MessageList.vala"
		_tmp43_ = FALSE;
#line 651 "MessageList.c"
	}
#line 206 "../src/MessageList/MessageList.vala"
	if (_tmp43_) {
#line 655 "MessageList.c"
		GVariant* _tmp48_;
#line 207 "../src/MessageList/MessageList.vala"
		_tmp48_ = _variant_new20 ("");
#line 207 "../src/MessageList/MessageList.vala"
		mail_message_list_compose (self, MAIL_COMPOSER_TYPE_DRAFT, _tmp48_, NULL, NULL);
#line 207 "../src/MessageList/MessageList.vala"
		_g_variant_unref0 (_tmp48_);
#line 663 "MessageList.c"
	}
#line 158 "../src/MessageList/MessageList.vala"
	(children == NULL) ? NULL : (children = (g_list_free (children), NULL));
#line 158 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (item);
#line 158 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (store);
#line 671 "MessageList.c"
}

static void
mail_message_list_go_down (MailMessageList* self,
                           CamelFolderThreadNode* node)
{
	CamelFolderThreadNode* current_node = NULL;
#line 211 "../src/MessageList/MessageList.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/MessageList/MessageList.vala"
	g_return_if_fail (node != NULL);
#line 212 "../src/MessageList/MessageList.vala"
	current_node = node;
#line 213 "../src/MessageList/MessageList.vala"
	while (TRUE) {
#line 687 "MessageList.c"
		CamelFolderThreadNode* _tmp0_;
		MailMessageListItem* item = NULL;
		CamelFolderThreadNode* _tmp1_;
		CamelMessageInfo* _tmp2_;
		MailMessageListItem* _tmp3_;
		GtkListBox* _tmp4_;
		MailMessageListItem* _tmp5_;
		GeeHashMap* _tmp6_;
		CamelFolderThreadNode* _tmp7_;
		CamelMessageInfo* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		MailMessageListItem* _tmp11_;
		CamelFolderThreadNode* _tmp12_;
		CamelFolderThreadNode* _tmp13_;
		CamelFolderThreadNode* _tmp16_;
		CamelFolderThreadNode* _tmp17_;
#line 213 "../src/MessageList/MessageList.vala"
		_tmp0_ = current_node;
#line 213 "../src/MessageList/MessageList.vala"
		if (!(_tmp0_ != NULL)) {
#line 213 "../src/MessageList/MessageList.vala"
			break;
#line 711 "MessageList.c"
		}
#line 214 "../src/MessageList/MessageList.vala"
		_tmp1_ = current_node;
#line 214 "../src/MessageList/MessageList.vala"
		_tmp2_ = _tmp1_->message;
#line 214 "../src/MessageList/MessageList.vala"
		_tmp3_ = mail_message_list_item_new (_tmp2_);
#line 214 "../src/MessageList/MessageList.vala"
		g_object_ref_sink (_tmp3_);
#line 214 "../src/MessageList/MessageList.vala"
		item = _tmp3_;
#line 215 "../src/MessageList/MessageList.vala"
		_tmp4_ = self->priv->list_box;
#line 215 "../src/MessageList/MessageList.vala"
		_tmp5_ = item;
#line 215 "../src/MessageList/MessageList.vala"
		gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 216 "../src/MessageList/MessageList.vala"
		_tmp6_ = self->priv->messages;
#line 216 "../src/MessageList/MessageList.vala"
		_tmp7_ = current_node;
#line 216 "../src/MessageList/MessageList.vala"
		_tmp8_ = _tmp7_->message;
#line 216 "../src/MessageList/MessageList.vala"
		_tmp9_ = camel_message_info_get_uid (_tmp8_);
#line 216 "../src/MessageList/MessageList.vala"
		_tmp10_ = _tmp9_;
#line 216 "../src/MessageList/MessageList.vala"
		_tmp11_ = item;
#line 216 "../src/MessageList/MessageList.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp10_, _tmp11_);
#line 217 "../src/MessageList/MessageList.vala"
		_tmp12_ = current_node;
#line 217 "../src/MessageList/MessageList.vala"
		_tmp13_ = _tmp12_->next;
#line 217 "../src/MessageList/MessageList.vala"
		if (_tmp13_ != NULL) {
#line 749 "MessageList.c"
			CamelFolderThreadNode* _tmp14_;
			CamelFolderThreadNode* _tmp15_;
#line 218 "../src/MessageList/MessageList.vala"
			_tmp14_ = current_node;
#line 218 "../src/MessageList/MessageList.vala"
			_tmp15_ = _tmp14_->next;
#line 218 "../src/MessageList/MessageList.vala"
			mail_message_list_go_down (self, (CamelFolderThreadNode*) _tmp15_);
#line 758 "MessageList.c"
		}
#line 221 "../src/MessageList/MessageList.vala"
		_tmp16_ = current_node;
#line 221 "../src/MessageList/MessageList.vala"
		_tmp17_ = _tmp16_->child;
#line 221 "../src/MessageList/MessageList.vala"
		current_node = (CamelFolderThreadNode*) _tmp17_;
#line 213 "../src/MessageList/MessageList.vala"
		_g_object_unref0 (item);
#line 768 "MessageList.c"
	}
}

static void
mail_message_list_compose_data_free (gpointer _data)
{
	MailMessageListComposeData* _data_;
	_data_ = _data;
#line 8 "../src/MessageList/MessageList.vala"
	_g_variant_unref0 (_data_->uid);
#line 8 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_data_->self);
#line 8 "../src/MessageList/MessageList.vala"
	g_slice_free (MailMessageListComposeData, _data_);
#line 783 "MessageList.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 8 "../src/MessageList/MessageList.vala"
	return self ? g_variant_ref (self) : NULL;
#line 791 "MessageList.c"
}

void
mail_message_list_compose (MailMessageList* self,
                           MailComposerType type,
                           GVariant* uid,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	MailMessageListComposeData* _data_;
	MailMessageList* _tmp0_;
	GVariant* _tmp1_;
#line 8 "../src/MessageList/MessageList.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/MessageList/MessageList.vala"
	g_return_if_fail (uid != NULL);
#line 8 "../src/MessageList/MessageList.vala"
	_data_ = g_slice_new0 (MailMessageListComposeData);
#line 8 "../src/MessageList/MessageList.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 8 "../src/MessageList/MessageList.vala"
	g_task_set_task_data (_data_->_async_result, _data_, mail_message_list_compose_data_free);
#line 8 "../src/MessageList/MessageList.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 8 "../src/MessageList/MessageList.vala"
	_data_->self = _tmp0_;
#line 8 "../src/MessageList/MessageList.vala"
	_data_->type = type;
#line 8 "../src/MessageList/MessageList.vala"
	_tmp1_ = _g_variant_ref0 (uid);
#line 8 "../src/MessageList/MessageList.vala"
	_g_variant_unref0 (_data_->uid);
#line 8 "../src/MessageList/MessageList.vala"
	_data_->uid = _tmp1_;
#line 8 "../src/MessageList/MessageList.vala"
	mail_message_list_compose_co (_data_);
#line 828 "MessageList.c"
}

void
mail_message_list_compose_finish (MailMessageList* self,
                                  GAsyncResult* _res_)
{
	MailMessageListComposeData* _data_;
#line 8 "../src/MessageList/MessageList.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 838 "MessageList.c"
}

static void
mail_message_list_compose_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	MailMessageListComposeData* _data_;
#line 243 "../src/MessageList/MessageList.vala"
	_data_ = _user_data_;
#line 243 "../src/MessageList/MessageList.vala"
	_data_->_source_object_ = source_object;
#line 243 "../src/MessageList/MessageList.vala"
	_data_->_res_ = _res_;
#line 243 "../src/MessageList/MessageList.vala"
	mail_message_list_compose_co (_data_);
#line 855 "MessageList.c"
}

static void
__lambda105_ (MailMessageList* self)
{
#line 250 "../src/MessageList/MessageList.vala"
	mail_message_list_can_reply (self, TRUE);
#line 251 "../src/MessageList/MessageList.vala"
	mail_message_list_can_move_thread (self, TRUE);
#line 865 "MessageList.c"
}

static void
___lambda105__mail_composer_finished (MailComposer* _sender,
                                      gpointer self)
{
#line 249 "../src/MessageList/MessageList.vala"
	__lambda105_ ((MailMessageList*) self);
#line 874 "MessageList.c"
}

static gboolean
mail_message_list_compose_co (MailMessageListComposeData* _data_)
{
#line 225 "../src/MessageList/MessageList.vala"
	switch (_data_->_state_) {
#line 225 "../src/MessageList/MessageList.vala"
		case 0:
#line 884 "MessageList.c"
		goto _state_0;
#line 225 "../src/MessageList/MessageList.vala"
		case 1:
#line 888 "MessageList.c"
		goto _state_1;
		default:
#line 225 "../src/MessageList/MessageList.vala"
		g_assert_not_reached ();
#line 893 "MessageList.c"
	}
	_state_0:
#line 227 "../src/MessageList/MessageList.vala"
	_data_->_tmp0_ = _data_->self->priv->list_box;
#line 227 "../src/MessageList/MessageList.vala"
	_data_->_tmp1_ = _data_->self->priv->list_box;
#line 227 "../src/MessageList/MessageList.vala"
	_data_->_tmp2_ = gtk_container_get_children ((GtkContainer*) _data_->_tmp1_);
#line 227 "../src/MessageList/MessageList.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 227 "../src/MessageList/MessageList.vala"
	_data_->_tmp4_ = gtk_list_box_get_row_at_index (_data_->_tmp0_, ((gint) g_list_length (_data_->_tmp3_)) - 1);
#line 227 "../src/MessageList/MessageList.vala"
	_data_->_tmp5_ = _g_object_ref0 (_data_->_tmp4_);
#line 227 "../src/MessageList/MessageList.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 227 "../src/MessageList/MessageList.vala"
	(_data_->_tmp3_ == NULL) ? NULL : (_data_->_tmp3_ = (g_list_free (_data_->_tmp3_), NULL));
#line 227 "../src/MessageList/MessageList.vala"
	_data_->last_child = _data_->_tmp6_;
#line 228 "../src/MessageList/MessageList.vala"
	_data_->_tmp7_ = _data_->last_child;
#line 228 "../src/MessageList/MessageList.vala"
	if (_data_->_tmp7_ == NULL) {
#line 229 "../src/MessageList/MessageList.vala"
		_g_object_unref0 (_data_->last_child);
#line 229 "../src/MessageList/MessageList.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 229 "../src/MessageList/MessageList.vala"
		if (_data_->_state_ != 0) {
#line 229 "../src/MessageList/MessageList.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 229 "../src/MessageList/MessageList.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 928 "MessageList.c"
			}
		}
#line 229 "../src/MessageList/MessageList.vala"
		g_object_unref (_data_->_async_result);
#line 229 "../src/MessageList/MessageList.vala"
		return FALSE;
#line 935 "MessageList.c"
	}
#line 232 "../src/MessageList/MessageList.vala"
	_data_->message_item = NULL;
#line 234 "../src/MessageList/MessageList.vala"
	_data_->_tmp8_ = g_variant_get_string (_data_->uid, NULL);
#line 234 "../src/MessageList/MessageList.vala"
	if (g_strcmp0 (_data_->_tmp8_, "") == 0) {
#line 235 "../src/MessageList/MessageList.vala"
		_data_->_tmp9_ = _data_->last_child;
#line 235 "../src/MessageList/MessageList.vala"
		_data_->_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, MAIL_TYPE_MESSAGE_LIST_ITEM, MailMessageListItem));
#line 235 "../src/MessageList/MessageList.vala"
		_g_object_unref0 (_data_->message_item);
#line 235 "../src/MessageList/MessageList.vala"
		_data_->message_item = _data_->_tmp10_;
#line 951 "MessageList.c"
	} else {
#line 237 "../src/MessageList/MessageList.vala"
		_data_->_tmp11_ = _data_->self->priv->messages;
#line 237 "../src/MessageList/MessageList.vala"
		_data_->_tmp12_ = g_variant_get_string (_data_->uid, NULL);
#line 237 "../src/MessageList/MessageList.vala"
		_data_->_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp11_, _data_->_tmp12_);
#line 237 "../src/MessageList/MessageList.vala"
		_g_object_unref0 (_data_->message_item);
#line 237 "../src/MessageList/MessageList.vala"
		_data_->message_item = (MailMessageListItem*) _data_->_tmp13_;
#line 963 "MessageList.c"
	}
#line 240 "../src/MessageList/MessageList.vala"
	_data_->_tmp14_ = g_strdup ("");
#line 240 "../src/MessageList/MessageList.vala"
	_data_->content_to_quote = _data_->_tmp14_;
#line 241 "../src/MessageList/MessageList.vala"
	_data_->mime_message = NULL;
#line 242 "../src/MessageList/MessageList.vala"
	_data_->message_info = NULL;
#line 243 "../src/MessageList/MessageList.vala"
	_data_->_tmp15_ = _data_->message_item;
#line 243 "../src/MessageList/MessageList.vala"
	_data_->_state_ = 1;
#line 243 "../src/MessageList/MessageList.vala"
	mail_message_list_item_get_message_body_html (_data_->_tmp15_, mail_message_list_compose_ready, _data_);
#line 243 "../src/MessageList/MessageList.vala"
	return FALSE;
#line 981 "MessageList.c"
	_state_1:
#line 243 "../src/MessageList/MessageList.vala"
	_data_->_tmp16_ = mail_message_list_item_get_message_body_html_finish (_data_->_tmp15_, _data_->_res_);
#line 243 "../src/MessageList/MessageList.vala"
	_g_free0 (_data_->content_to_quote);
#line 243 "../src/MessageList/MessageList.vala"
	_data_->content_to_quote = _data_->_tmp16_;
#line 244 "../src/MessageList/MessageList.vala"
	_data_->_tmp17_ = _data_->message_item;
#line 244 "../src/MessageList/MessageList.vala"
	_data_->_tmp18_ = mail_message_list_item_get_mime_message (_data_->_tmp17_);
#line 244 "../src/MessageList/MessageList.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 244 "../src/MessageList/MessageList.vala"
	_data_->_tmp20_ = _g_object_ref0 (_data_->_tmp19_);
#line 244 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_data_->mime_message);
#line 244 "../src/MessageList/MessageList.vala"
	_data_->mime_message = _data_->_tmp20_;
#line 245 "../src/MessageList/MessageList.vala"
	_data_->_tmp21_ = _data_->message_item;
#line 245 "../src/MessageList/MessageList.vala"
	_data_->_tmp22_ = mail_message_list_item_get_message_info (_data_->_tmp21_);
#line 245 "../src/MessageList/MessageList.vala"
	_data_->_tmp23_ = _data_->_tmp22_;
#line 245 "../src/MessageList/MessageList.vala"
	_data_->_tmp24_ = _g_object_ref0 (_data_->_tmp23_);
#line 245 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_data_->message_info);
#line 245 "../src/MessageList/MessageList.vala"
	_data_->message_info = _data_->_tmp24_;
#line 247 "../src/MessageList/MessageList.vala"
	_data_->_tmp25_ = _data_->message_info;
#line 247 "../src/MessageList/MessageList.vala"
	_data_->_tmp26_ = _data_->mime_message;
#line 247 "../src/MessageList/MessageList.vala"
	_data_->_tmp27_ = _data_->content_to_quote;
#line 247 "../src/MessageList/MessageList.vala"
	_data_->_tmp28_ = mail_composer_new_with_quote (_data_->type, _data_->_tmp25_, _data_->_tmp26_, _data_->_tmp27_);
#line 247 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_data_->_tmp28_);
#line 247 "../src/MessageList/MessageList.vala"
	_data_->composer = _data_->_tmp28_;
#line 248 "../src/MessageList/MessageList.vala"
	_data_->_tmp29_ = _data_->composer;
#line 248 "../src/MessageList/MessageList.vala"
	gtk_window_present ((GtkWindow*) _data_->_tmp29_);
#line 249 "../src/MessageList/MessageList.vala"
	_data_->_tmp30_ = _data_->composer;
#line 249 "../src/MessageList/MessageList.vala"
	g_signal_connect_object (_data_->_tmp30_, "finished", (GCallback) ___lambda105__mail_composer_finished, _data_->self, 0);
#line 253 "../src/MessageList/MessageList.vala"
	mail_message_list_can_reply (_data_->self, FALSE);
#line 254 "../src/MessageList/MessageList.vala"
	mail_message_list_can_move_thread (_data_->self, TRUE);
#line 225 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_data_->composer);
#line 225 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_data_->message_info);
#line 225 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_data_->mime_message);
#line 225 "../src/MessageList/MessageList.vala"
	_g_free0 (_data_->content_to_quote);
#line 225 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_data_->message_item);
#line 225 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_data_->last_child);
#line 225 "../src/MessageList/MessageList.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 225 "../src/MessageList/MessageList.vala"
	if (_data_->_state_ != 0) {
#line 225 "../src/MessageList/MessageList.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 225 "../src/MessageList/MessageList.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1057 "MessageList.c"
		}
	}
#line 225 "../src/MessageList/MessageList.vala"
	g_object_unref (_data_->_async_result);
#line 225 "../src/MessageList/MessageList.vala"
	return FALSE;
#line 1064 "MessageList.c"
}

void
mail_message_list_print (MailMessageList* self,
                         GVariant* uid)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	MailMessageListItem* _tmp3_;
#line 257 "../src/MessageList/MessageList.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/MessageList/MessageList.vala"
	g_return_if_fail (uid != NULL);
#line 258 "../src/MessageList/MessageList.vala"
	_tmp0_ = self->priv->messages;
#line 258 "../src/MessageList/MessageList.vala"
	_tmp1_ = g_variant_get_string (uid, NULL);
#line 258 "../src/MessageList/MessageList.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 258 "../src/MessageList/MessageList.vala"
	_tmp3_ = (MailMessageListItem*) _tmp2_;
#line 258 "../src/MessageList/MessageList.vala"
	mail_message_list_item_print (_tmp3_);
#line 258 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp3_);
#line 1091 "MessageList.c"
}

static void
mail_message_list_can_reply (MailMessageList* self,
                             gboolean enabled)
{
	GtkApplicationWindow* main_window = NULL;
	GtkWidget* _tmp0_;
	GAction* _tmp1_;
	GAction* _tmp2_;
	GAction* _tmp3_;
#line 261 "../src/MessageList/MessageList.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/MessageList/MessageList.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 262 "../src/MessageList/MessageList.vala"
	main_window = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_window_get_type (), GtkApplicationWindow);
#line 263 "../src/MessageList/MessageList.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) main_window, MAIL_MAIN_WINDOW_ACTION_FORWARD);
#line 263 "../src/MessageList/MessageList.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction), enabled);
#line 264 "../src/MessageList/MessageList.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) main_window, MAIL_MAIN_WINDOW_ACTION_REPLY_ALL);
#line 264 "../src/MessageList/MessageList.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_simple_action_get_type (), GSimpleAction), enabled);
#line 265 "../src/MessageList/MessageList.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) main_window, MAIL_MAIN_WINDOW_ACTION_REPLY);
#line 265 "../src/MessageList/MessageList.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction), enabled);
#line 1121 "MessageList.c"
}

static void
mail_message_list_can_move_thread (MailMessageList* self,
                                   gboolean enabled)
{
	GtkApplicationWindow* main_window = NULL;
	GtkWidget* _tmp0_;
	GAction* _tmp1_;
	GAction* _tmp2_;
	GAction* _tmp3_;
	GAction* _tmp4_;
#line 268 "../src/MessageList/MessageList.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/MessageList/MessageList.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 269 "../src/MessageList/MessageList.vala"
	main_window = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_window_get_type (), GtkApplicationWindow);
#line 270 "../src/MessageList/MessageList.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) main_window, MAIL_MAIN_WINDOW_ACTION_MODIFY);
#line 270 "../src/MessageList/MessageList.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction), enabled);
#line 271 "../src/MessageList/MessageList.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) main_window, MAIL_MAIN_WINDOW_ACTION_ARCHIVE);
#line 271 "../src/MessageList/MessageList.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_simple_action_get_type (), GSimpleAction), enabled);
#line 272 "../src/MessageList/MessageList.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) main_window, MAIL_MAIN_WINDOW_ACTION_MOVE);
#line 272 "../src/MessageList/MessageList.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction), enabled);
#line 273 "../src/MessageList/MessageList.vala"
	_tmp4_ = g_action_map_lookup_action ((GActionMap*) main_window, MAIL_MAIN_WINDOW_ACTION_MOVE_TO_TRASH);
#line 273 "../src/MessageList/MessageList.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, g_simple_action_get_type (), GSimpleAction), enabled);
#line 1156 "MessageList.c"
}

static gint
mail_message_list_message_sort_function (GtkListBoxRow* item1,
                                         GtkListBoxRow* item2)
{
	MailMessageListItem* message1 = NULL;
	MailMessageListItem* message2 = NULL;
	gint64 timestamp1 = 0LL;
	MailMessageListItem* _tmp0_;
	CamelMessageInfo* _tmp1_;
	CamelMessageInfo* _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	gint64 timestamp2 = 0LL;
	MailMessageListItem* _tmp10_;
	CamelMessageInfo* _tmp11_;
	CamelMessageInfo* _tmp12_;
	gint64 _tmp13_;
	gint64 _tmp14_;
	gint result;
#line 276 "../src/MessageList/MessageList.vala"
	g_return_val_if_fail (item1 != NULL, 0);
#line 276 "../src/MessageList/MessageList.vala"
	g_return_val_if_fail (item2 != NULL, 0);
#line 277 "../src/MessageList/MessageList.vala"
	message1 = G_TYPE_CHECK_INSTANCE_CAST (item1, MAIL_TYPE_MESSAGE_LIST_ITEM, MailMessageListItem);
#line 278 "../src/MessageList/MessageList.vala"
	message2 = G_TYPE_CHECK_INSTANCE_CAST (item2, MAIL_TYPE_MESSAGE_LIST_ITEM, MailMessageListItem);
#line 280 "../src/MessageList/MessageList.vala"
	_tmp0_ = message1;
#line 280 "../src/MessageList/MessageList.vala"
	_tmp1_ = mail_message_list_item_get_message_info (_tmp0_);
#line 280 "../src/MessageList/MessageList.vala"
	_tmp2_ = _tmp1_;
#line 280 "../src/MessageList/MessageList.vala"
	_tmp3_ = camel_message_info_get_date_received (_tmp2_);
#line 280 "../src/MessageList/MessageList.vala"
	_tmp4_ = _tmp3_;
#line 280 "../src/MessageList/MessageList.vala"
	timestamp1 = _tmp4_;
#line 281 "../src/MessageList/MessageList.vala"
	if (timestamp1 == ((gint64) 0)) {
#line 1200 "MessageList.c"
		MailMessageListItem* _tmp5_;
		CamelMessageInfo* _tmp6_;
		CamelMessageInfo* _tmp7_;
		gint64 _tmp8_;
		gint64 _tmp9_;
#line 282 "../src/MessageList/MessageList.vala"
		_tmp5_ = message1;
#line 282 "../src/MessageList/MessageList.vala"
		_tmp6_ = mail_message_list_item_get_message_info (_tmp5_);
#line 282 "../src/MessageList/MessageList.vala"
		_tmp7_ = _tmp6_;
#line 282 "../src/MessageList/MessageList.vala"
		_tmp8_ = camel_message_info_get_date_sent (_tmp7_);
#line 282 "../src/MessageList/MessageList.vala"
		_tmp9_ = _tmp8_;
#line 282 "../src/MessageList/MessageList.vala"
		timestamp1 = _tmp9_;
#line 1218 "MessageList.c"
	}
#line 285 "../src/MessageList/MessageList.vala"
	_tmp10_ = message2;
#line 285 "../src/MessageList/MessageList.vala"
	_tmp11_ = mail_message_list_item_get_message_info (_tmp10_);
#line 285 "../src/MessageList/MessageList.vala"
	_tmp12_ = _tmp11_;
#line 285 "../src/MessageList/MessageList.vala"
	_tmp13_ = camel_message_info_get_date_received (_tmp12_);
#line 285 "../src/MessageList/MessageList.vala"
	_tmp14_ = _tmp13_;
#line 285 "../src/MessageList/MessageList.vala"
	timestamp2 = _tmp14_;
#line 286 "../src/MessageList/MessageList.vala"
	if (timestamp2 == ((gint64) 0)) {
#line 1234 "MessageList.c"
		MailMessageListItem* _tmp15_;
		CamelMessageInfo* _tmp16_;
		CamelMessageInfo* _tmp17_;
		gint64 _tmp18_;
		gint64 _tmp19_;
#line 287 "../src/MessageList/MessageList.vala"
		_tmp15_ = message2;
#line 287 "../src/MessageList/MessageList.vala"
		_tmp16_ = mail_message_list_item_get_message_info (_tmp15_);
#line 287 "../src/MessageList/MessageList.vala"
		_tmp17_ = _tmp16_;
#line 287 "../src/MessageList/MessageList.vala"
		_tmp18_ = camel_message_info_get_date_sent (_tmp17_);
#line 287 "../src/MessageList/MessageList.vala"
		_tmp19_ = _tmp18_;
#line 287 "../src/MessageList/MessageList.vala"
		timestamp2 = _tmp19_;
#line 1252 "MessageList.c"
	}
#line 290 "../src/MessageList/MessageList.vala"
	result = (gint) (timestamp1 - timestamp2);
#line 290 "../src/MessageList/MessageList.vala"
	return result;
#line 1258 "MessageList.c"
}

MailMessageList*
mail_message_list_construct (GType object_type)
{
	MailMessageList * self = NULL;
#line 8 "../src/MessageList/MessageList.vala"
	self = (MailMessageList*) g_object_new (object_type, NULL);
#line 8 "../src/MessageList/MessageList.vala"
	return self;
#line 1269 "MessageList.c"
}

MailMessageList*
mail_message_list_new (void)
{
#line 8 "../src/MessageList/MessageList.vala"
	return mail_message_list_construct (MAIL_TYPE_MESSAGE_LIST);
#line 1277 "MessageList.c"
}

HdyHeaderBar*
mail_message_list_get_headerbar (MailMessageList* self)
{
	HdyHeaderBar* result;
	HdyHeaderBar* _tmp0_;
#line 10 "../src/MessageList/MessageList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10 "../src/MessageList/MessageList.vala"
	_tmp0_ = self->priv->_headerbar;
#line 10 "../src/MessageList/MessageList.vala"
	result = _tmp0_;
#line 10 "../src/MessageList/MessageList.vala"
	return result;
#line 1293 "MessageList.c"
}

static void
mail_message_list_set_headerbar (MailMessageList* self,
                                 HdyHeaderBar* value)
{
	HdyHeaderBar* old_value;
#line 10 "../src/MessageList/MessageList.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/MessageList/MessageList.vala"
	old_value = mail_message_list_get_headerbar (self);
#line 10 "../src/MessageList/MessageList.vala"
	if (old_value != value) {
#line 1307 "MessageList.c"
		HdyHeaderBar* _tmp0_;
#line 10 "../src/MessageList/MessageList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 10 "../src/MessageList/MessageList.vala"
		_g_object_unref0 (self->priv->_headerbar);
#line 10 "../src/MessageList/MessageList.vala"
		self->priv->_headerbar = _tmp0_;
#line 10 "../src/MessageList/MessageList.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_message_list_properties[MAIL_MESSAGE_LIST_HEADERBAR_PROPERTY]);
#line 1317 "MessageList.c"
	}
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 8 "../src/MessageList/MessageList.vala"
	g_return_if_fail (n_param_values == 3);
#line 8 "../src/MessageList/MessageList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 8 "../src/MessageList/MessageList.vala"
		data1 = closure->data;
#line 8 "../src/MessageList/MessageList.vala"
		data2 = param_values->data[0].v_pointer;
#line 1343 "MessageList.c"
	} else {
#line 8 "../src/MessageList/MessageList.vala"
		data1 = param_values->data[0].v_pointer;
#line 8 "../src/MessageList/MessageList.vala"
		data2 = closure->data;
#line 1349 "MessageList.c"
	}
#line 8 "../src/MessageList/MessageList.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 8 "../src/MessageList/MessageList.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 1355 "MessageList.c"
}

static GVariant*
_variant_new21 (const gchar* value)
{
#line 22 "../src/MessageList/MessageList.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1363 "MessageList.c"
}

static GVariant*
_variant_new22 (const gchar* value)
{
#line 31 "../src/MessageList/MessageList.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1371 "MessageList.c"
}

static GVariant*
_variant_new23 (const gchar* value)
{
#line 40 "../src/MessageList/MessageList.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1379 "MessageList.c"
}

static gint
_mail_message_list_message_sort_function_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                 GtkListBoxRow* row2,
                                                                 gpointer self)
{
	gint result;
	result = mail_message_list_message_sort_function (row1, row2);
#line 140 "../src/MessageList/MessageList.vala"
	return result;
#line 1391 "MessageList.c"
}

static GObject *
mail_message_list_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MailMessageList * self;
	GtkStyleContext* _tmp0_;
	GtkApplication* application_instance = NULL;
	GApplication* _tmp1_;
	GtkApplication* _tmp2_;
	GtkButton* reply_button = NULL;
	gchar* _tmp3_;
	GVariant* _tmp4_;
	GtkButton* _tmp5_ = NULL;
	GtkButton* _tmp6_;
	GtkApplication* _tmp7_;
	GtkButton* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GtkButton* reply_all_button = NULL;
	gchar* _tmp18_;
	GVariant* _tmp19_;
	GtkButton* _tmp20_ = NULL;
	GtkButton* _tmp21_;
	GtkApplication* _tmp22_;
	GtkButton* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar** _tmp28_;
	gchar** _tmp29_;
	gchar** _tmp30_;
	gint _tmp30__length1;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GtkButton* forward_button = NULL;
	gchar* _tmp33_;
	GVariant* _tmp34_;
	GtkButton* _tmp35_ = NULL;
	GtkButton* _tmp36_;
	GtkApplication* _tmp37_;
	GtkButton* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar** _tmp43_;
	gchar** _tmp44_;
	gchar** _tmp45_;
	gint _tmp45__length1;
	gchar* _tmp46_;
	gchar* _tmp47_;
	GtkMenuItem* mark_unread_item = NULL;
	gchar* _tmp48_;
	GtkMenuItem* _tmp49_ = NULL;
	GtkMenuItem* _tmp50_;
	GtkMenuItem* _tmp51_;
	GtkMenuItem* _tmp52_;
	GtkMenuItem* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	GraniteAccelLabel* _tmp56_;
	GraniteAccelLabel* _tmp57_;
	GtkMenuItem* mark_read_item = NULL;
	gchar* _tmp58_;
	GtkMenuItem* _tmp59_ = NULL;
	GtkMenuItem* _tmp60_;
	GtkMenuItem* _tmp61_;
	GtkMenuItem* _tmp62_;
	GtkMenuItem* _tmp63_;
	const gchar* _tmp64_;
	const gchar* _tmp65_;
	GraniteAccelLabel* _tmp66_;
	GraniteAccelLabel* _tmp67_;
	GtkMenuItem* mark_star_item = NULL;
	gchar* _tmp68_;
	GtkMenuItem* _tmp69_ = NULL;
	GtkMenuItem* _tmp70_;
	GtkMenuItem* _tmp71_;
	GtkMenuItem* _tmp72_;
	GtkMenuItem* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	GraniteAccelLabel* _tmp76_;
	GraniteAccelLabel* _tmp77_;
	GtkMenuItem* mark_unstar_item = NULL;
	gchar* _tmp78_;
	GtkMenuItem* _tmp79_ = NULL;
	GtkMenuItem* _tmp80_;
	GtkMenuItem* _tmp81_;
	GtkMenuItem* _tmp82_;
	GtkMenuItem* _tmp83_;
	const gchar* _tmp84_;
	const gchar* _tmp85_;
	GraniteAccelLabel* _tmp86_;
	GraniteAccelLabel* _tmp87_;
	GtkMenu* mark_menu = NULL;
	GtkMenu* _tmp88_;
	GtkMenu* _tmp89_;
	GtkMenuItem* _tmp90_;
	GtkMenu* _tmp91_;
	GtkMenuItem* _tmp92_;
	GtkMenu* _tmp93_;
	GtkMenuItem* _tmp94_;
	GtkMenu* _tmp95_;
	GtkMenuItem* _tmp96_;
	GtkMenu* _tmp97_;
	GtkMenuButton* mark_button = NULL;
	gchar* _tmp98_;
	GtkImage* _tmp99_;
	GtkMenu* _tmp100_;
	GtkMenu* _tmp101_;
	gchar* _tmp102_;
	GtkMenuButton* _tmp103_ = NULL;
	MailFolderPopover* _tmp104_;
	GtkMenuButton* move_button = NULL;
	gchar* _tmp105_;
	GtkImage* _tmp106_;
	gchar* _tmp107_;
	MailFolderPopover* _tmp108_;
	GtkPopover* _tmp109_;
	GtkMenuButton* _tmp110_ = NULL;
	GtkButton* archive_button = NULL;
	gchar* _tmp111_;
	GtkButton* _tmp112_ = NULL;
	GtkButton* _tmp113_;
	GtkApplication* _tmp114_;
	GtkButton* _tmp115_;
	const gchar* _tmp116_;
	const gchar* _tmp117_;
	gchar** _tmp118_;
	gchar** _tmp119_;
	gchar** _tmp120_;
	gint _tmp120__length1;
	gchar* _tmp121_;
	gchar* _tmp122_;
	GtkButton* trash_button = NULL;
	gchar* _tmp123_;
	GtkButton* _tmp124_ = NULL;
	GtkButton* _tmp125_;
	GtkApplication* _tmp126_;
	GtkButton* _tmp127_;
	const gchar* _tmp128_;
	const gchar* _tmp129_;
	gchar** _tmp130_;
	gchar** _tmp131_;
	gchar** _tmp132_;
	gint _tmp132__length1;
	gchar* _tmp133_;
	gchar* _tmp134_;
	HdyHeaderBar* _tmp135_ = NULL;
	HdyHeaderBar* _tmp136_;
	HdyHeaderBar* _tmp137_;
	GtkStyleContext* _tmp138_;
	HdyHeaderBar* _tmp139_;
	GtkButton* _tmp140_;
	HdyHeaderBar* _tmp141_;
	GtkButton* _tmp142_;
	HdyHeaderBar* _tmp143_;
	GtkButton* _tmp144_;
	HdyHeaderBar* _tmp145_;
	GtkButton* _tmp146_;
	HdyHeaderBar* _tmp147_;
	GtkButton* _tmp148_;
	HdyHeaderBar* _tmp149_;
	GtkMenuButton* _tmp150_;
	HdyHeaderBar* _tmp151_;
	GtkMenuButton* _tmp152_;
	GtkLabel* placeholder = NULL;
	GtkLabel* _tmp153_ = NULL;
	GtkStyleContext* placeholder_style_context = NULL;
	GtkLabel* _tmp154_;
	GtkStyleContext* _tmp155_;
	GtkStyleContext* _tmp156_;
	GtkStyleContext* _tmp157_;
	GtkStyleContext* _tmp158_;
	GtkListBox* _tmp159_ = NULL;
	GtkListBox* _tmp160_;
	GtkStyleContext* _tmp161_;
	GtkListBox* _tmp162_;
	GtkLabel* _tmp163_;
	GtkListBox* _tmp164_;
	GtkScrolledWindow* _tmp165_ = NULL;
	GtkScrolledWindow* _tmp166_;
	GtkListBox* _tmp167_;
	GtkWidget* scrolled_child = NULL;
	GtkScrolledWindow* _tmp168_;
	GtkWidget* _tmp169_;
	GtkWidget* _tmp170_;
	GtkWidget* _tmp171_;
	HdyHeaderBar* _tmp175_;
	GtkScrolledWindow* _tmp176_;
#line 17 "../src/MessageList/MessageList.vala"
	parent_class = G_OBJECT_CLASS (mail_message_list_parent_class);
#line 17 "../src/MessageList/MessageList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 17 "../src/MessageList/MessageList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_MESSAGE_LIST, MailMessageList);
#line 18 "../src/MessageList/MessageList.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 18 "../src/MessageList/MessageList.vala"
	gtk_style_context_add_class (_tmp0_, GTK_STYLE_CLASS_BACKGROUND);
#line 20 "../src/MessageList/MessageList.vala"
	_tmp1_ = g_application_get_default ();
#line 20 "../src/MessageList/MessageList.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_application_get_type (), GtkApplication));
#line 20 "../src/MessageList/MessageList.vala"
	application_instance = _tmp2_;
#line 22 "../src/MessageList/MessageList.vala"
	_tmp3_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_REPLY);
#line 22 "../src/MessageList/MessageList.vala"
	_tmp4_ = _variant_new21 ("");
#line 22 "../src/MessageList/MessageList.vala"
	_tmp5_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-reply-sender", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 22 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp5_, _tmp3_);
#line 22 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp3_);
#line 22 "../src/MessageList/MessageList.vala"
	g_object_set ((GtkActionable*) _tmp5_, "action-target", _tmp4_, NULL);
#line 22 "../src/MessageList/MessageList.vala"
	_g_variant_unref0 (_tmp4_);
#line 22 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp5_);
#line 22 "../src/MessageList/MessageList.vala"
	reply_button = _tmp5_;
#line 26 "../src/MessageList/MessageList.vala"
	_tmp6_ = reply_button;
#line 26 "../src/MessageList/MessageList.vala"
	_tmp7_ = application_instance;
#line 26 "../src/MessageList/MessageList.vala"
	_tmp8_ = reply_button;
#line 26 "../src/MessageList/MessageList.vala"
	_tmp9_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp8_);
#line 26 "../src/MessageList/MessageList.vala"
	_tmp10_ = _tmp9_;
#line 26 "../src/MessageList/MessageList.vala"
	_tmp11_ = g_strconcat (_tmp10_, "::", NULL);
#line 26 "../src/MessageList/MessageList.vala"
	_tmp12_ = _tmp11_;
#line 26 "../src/MessageList/MessageList.vala"
	_tmp14_ = _tmp13_ = gtk_application_get_accels_for_action (_tmp7_, _tmp12_);
#line 26 "../src/MessageList/MessageList.vala"
	_tmp15_ = _tmp14_;
#line 26 "../src/MessageList/MessageList.vala"
	_tmp15__length1 = _vala_array_length (_tmp13_);
#line 26 "../src/MessageList/MessageList.vala"
	_tmp16_ = granite_markup_accel_tooltip (_tmp15_, (gint) _vala_array_length (_tmp13_), _ ("Reply"));
#line 26 "../src/MessageList/MessageList.vala"
	_tmp17_ = _tmp16_;
#line 26 "../src/MessageList/MessageList.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp6_, _tmp17_);
#line 26 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp17_);
#line 26 "../src/MessageList/MessageList.vala"
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 26 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp12_);
#line 31 "../src/MessageList/MessageList.vala"
	_tmp18_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_REPLY_ALL);
#line 31 "../src/MessageList/MessageList.vala"
	_tmp19_ = _variant_new22 ("");
#line 31 "../src/MessageList/MessageList.vala"
	_tmp20_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-reply-all", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 31 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp20_, _tmp18_);
#line 31 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp18_);
#line 31 "../src/MessageList/MessageList.vala"
	g_object_set ((GtkActionable*) _tmp20_, "action-target", _tmp19_, NULL);
#line 31 "../src/MessageList/MessageList.vala"
	_g_variant_unref0 (_tmp19_);
#line 31 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp20_);
#line 31 "../src/MessageList/MessageList.vala"
	reply_all_button = _tmp20_;
#line 35 "../src/MessageList/MessageList.vala"
	_tmp21_ = reply_all_button;
#line 35 "../src/MessageList/MessageList.vala"
	_tmp22_ = application_instance;
#line 35 "../src/MessageList/MessageList.vala"
	_tmp23_ = reply_all_button;
#line 35 "../src/MessageList/MessageList.vala"
	_tmp24_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp23_);
#line 35 "../src/MessageList/MessageList.vala"
	_tmp25_ = _tmp24_;
#line 35 "../src/MessageList/MessageList.vala"
	_tmp26_ = g_strconcat (_tmp25_, "::", NULL);
#line 35 "../src/MessageList/MessageList.vala"
	_tmp27_ = _tmp26_;
#line 35 "../src/MessageList/MessageList.vala"
	_tmp29_ = _tmp28_ = gtk_application_get_accels_for_action (_tmp22_, _tmp27_);
#line 35 "../src/MessageList/MessageList.vala"
	_tmp30_ = _tmp29_;
#line 35 "../src/MessageList/MessageList.vala"
	_tmp30__length1 = _vala_array_length (_tmp28_);
#line 35 "../src/MessageList/MessageList.vala"
	_tmp31_ = granite_markup_accel_tooltip (_tmp30_, (gint) _vala_array_length (_tmp28_), _ ("Reply All"));
#line 35 "../src/MessageList/MessageList.vala"
	_tmp32_ = _tmp31_;
#line 35 "../src/MessageList/MessageList.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp21_, _tmp32_);
#line 35 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp32_);
#line 35 "../src/MessageList/MessageList.vala"
	_tmp30_ = (_vala_array_free (_tmp30_, _tmp30__length1, (GDestroyNotify) g_free), NULL);
#line 35 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp27_);
#line 40 "../src/MessageList/MessageList.vala"
	_tmp33_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_FORWARD);
#line 40 "../src/MessageList/MessageList.vala"
	_tmp34_ = _variant_new23 ("");
#line 40 "../src/MessageList/MessageList.vala"
	_tmp35_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-forward", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 40 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp35_, _tmp33_);
#line 40 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp33_);
#line 40 "../src/MessageList/MessageList.vala"
	g_object_set ((GtkActionable*) _tmp35_, "action-target", _tmp34_, NULL);
#line 40 "../src/MessageList/MessageList.vala"
	_g_variant_unref0 (_tmp34_);
#line 40 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp35_);
#line 40 "../src/MessageList/MessageList.vala"
	forward_button = _tmp35_;
#line 44 "../src/MessageList/MessageList.vala"
	_tmp36_ = forward_button;
#line 44 "../src/MessageList/MessageList.vala"
	_tmp37_ = application_instance;
#line 44 "../src/MessageList/MessageList.vala"
	_tmp38_ = forward_button;
#line 44 "../src/MessageList/MessageList.vala"
	_tmp39_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp38_);
#line 44 "../src/MessageList/MessageList.vala"
	_tmp40_ = _tmp39_;
#line 44 "../src/MessageList/MessageList.vala"
	_tmp41_ = g_strconcat (_tmp40_, "::", NULL);
#line 44 "../src/MessageList/MessageList.vala"
	_tmp42_ = _tmp41_;
#line 44 "../src/MessageList/MessageList.vala"
	_tmp44_ = _tmp43_ = gtk_application_get_accels_for_action (_tmp37_, _tmp42_);
#line 44 "../src/MessageList/MessageList.vala"
	_tmp45_ = _tmp44_;
#line 44 "../src/MessageList/MessageList.vala"
	_tmp45__length1 = _vala_array_length (_tmp43_);
#line 44 "../src/MessageList/MessageList.vala"
	_tmp46_ = granite_markup_accel_tooltip (_tmp45_, (gint) _vala_array_length (_tmp43_), _ ("Forward"));
#line 44 "../src/MessageList/MessageList.vala"
	_tmp47_ = _tmp46_;
#line 44 "../src/MessageList/MessageList.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp36_, _tmp47_);
#line 44 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp47_);
#line 44 "../src/MessageList/MessageList.vala"
	_tmp45_ = (_vala_array_free (_tmp45_, _tmp45__length1, (GDestroyNotify) g_free), NULL);
#line 44 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp42_);
#line 49 "../src/MessageList/MessageList.vala"
	_tmp48_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MARK_UNREAD);
#line 49 "../src/MessageList/MessageList.vala"
	_tmp49_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 49 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp49_, _tmp48_);
#line 49 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp48_);
#line 49 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp49_);
#line 49 "../src/MessageList/MessageList.vala"
	mark_unread_item = _tmp49_;
#line 52 "../src/MessageList/MessageList.vala"
	_tmp50_ = mark_unread_item;
#line 52 "../src/MessageList/MessageList.vala"
	_tmp51_ = mark_unread_item;
#line 52 "../src/MessageList/MessageList.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp50_, "sensitive", (GObject*) _tmp51_, "visible", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 53 "../src/MessageList/MessageList.vala"
	_tmp52_ = mark_unread_item;
#line 53 "../src/MessageList/MessageList.vala"
	_tmp53_ = mark_unread_item;
#line 53 "../src/MessageList/MessageList.vala"
	_tmp54_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp53_);
#line 53 "../src/MessageList/MessageList.vala"
	_tmp55_ = _tmp54_;
#line 53 "../src/MessageList/MessageList.vala"
	_tmp56_ = granite_accel_label_new_from_action_name (_ ("Mark as Unread"), _tmp55_);
#line 53 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp56_);
#line 53 "../src/MessageList/MessageList.vala"
	_tmp57_ = _tmp56_;
#line 53 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp57_);
#line 53 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp57_);
#line 55 "../src/MessageList/MessageList.vala"
	_tmp58_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MARK_READ);
#line 55 "../src/MessageList/MessageList.vala"
	_tmp59_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 55 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp59_, _tmp58_);
#line 55 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp58_);
#line 55 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp59_);
#line 55 "../src/MessageList/MessageList.vala"
	mark_read_item = _tmp59_;
#line 58 "../src/MessageList/MessageList.vala"
	_tmp60_ = mark_read_item;
#line 58 "../src/MessageList/MessageList.vala"
	_tmp61_ = mark_read_item;
#line 58 "../src/MessageList/MessageList.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp60_, "sensitive", (GObject*) _tmp61_, "visible", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 59 "../src/MessageList/MessageList.vala"
	_tmp62_ = mark_read_item;
#line 59 "../src/MessageList/MessageList.vala"
	_tmp63_ = mark_read_item;
#line 59 "../src/MessageList/MessageList.vala"
	_tmp64_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp63_);
#line 59 "../src/MessageList/MessageList.vala"
	_tmp65_ = _tmp64_;
#line 59 "../src/MessageList/MessageList.vala"
	_tmp66_ = granite_accel_label_new_from_action_name (_ ("Mark as Read"), _tmp65_);
#line 59 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp66_);
#line 59 "../src/MessageList/MessageList.vala"
	_tmp67_ = _tmp66_;
#line 59 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp67_);
#line 59 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp67_);
#line 61 "../src/MessageList/MessageList.vala"
	_tmp68_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MARK_STAR);
#line 61 "../src/MessageList/MessageList.vala"
	_tmp69_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 61 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp69_, _tmp68_);
#line 61 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp68_);
#line 61 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp69_);
#line 61 "../src/MessageList/MessageList.vala"
	mark_star_item = _tmp69_;
#line 64 "../src/MessageList/MessageList.vala"
	_tmp70_ = mark_star_item;
#line 64 "../src/MessageList/MessageList.vala"
	_tmp71_ = mark_star_item;
#line 64 "../src/MessageList/MessageList.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp70_, "sensitive", (GObject*) _tmp71_, "visible", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 65 "../src/MessageList/MessageList.vala"
	_tmp72_ = mark_star_item;
#line 65 "../src/MessageList/MessageList.vala"
	_tmp73_ = mark_star_item;
#line 65 "../src/MessageList/MessageList.vala"
	_tmp74_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp73_);
#line 65 "../src/MessageList/MessageList.vala"
	_tmp75_ = _tmp74_;
#line 65 "../src/MessageList/MessageList.vala"
	_tmp76_ = granite_accel_label_new_from_action_name (_ ("Star"), _tmp75_);
#line 65 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp76_);
#line 65 "../src/MessageList/MessageList.vala"
	_tmp77_ = _tmp76_;
#line 65 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp72_, (GtkWidget*) _tmp77_);
#line 65 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp77_);
#line 67 "../src/MessageList/MessageList.vala"
	_tmp78_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MARK_UNSTAR);
#line 67 "../src/MessageList/MessageList.vala"
	_tmp79_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 67 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp79_, _tmp78_);
#line 67 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp78_);
#line 67 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp79_);
#line 67 "../src/MessageList/MessageList.vala"
	mark_unstar_item = _tmp79_;
#line 70 "../src/MessageList/MessageList.vala"
	_tmp80_ = mark_unstar_item;
#line 70 "../src/MessageList/MessageList.vala"
	_tmp81_ = mark_unstar_item;
#line 70 "../src/MessageList/MessageList.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp80_, "sensitive", (GObject*) _tmp81_, "visible", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 71 "../src/MessageList/MessageList.vala"
	_tmp82_ = mark_unstar_item;
#line 71 "../src/MessageList/MessageList.vala"
	_tmp83_ = mark_unstar_item;
#line 71 "../src/MessageList/MessageList.vala"
	_tmp84_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp83_);
#line 71 "../src/MessageList/MessageList.vala"
	_tmp85_ = _tmp84_;
#line 71 "../src/MessageList/MessageList.vala"
	_tmp86_ = granite_accel_label_new_from_action_name (_ ("Unstar"), _tmp85_);
#line 71 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp86_);
#line 71 "../src/MessageList/MessageList.vala"
	_tmp87_ = _tmp86_;
#line 71 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp82_, (GtkWidget*) _tmp87_);
#line 71 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp87_);
#line 73 "../src/MessageList/MessageList.vala"
	_tmp88_ = (GtkMenu*) gtk_menu_new ();
#line 73 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp88_);
#line 73 "../src/MessageList/MessageList.vala"
	mark_menu = _tmp88_;
#line 74 "../src/MessageList/MessageList.vala"
	_tmp89_ = mark_menu;
#line 74 "../src/MessageList/MessageList.vala"
	_tmp90_ = mark_unread_item;
#line 74 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp89_, (GtkWidget*) _tmp90_);
#line 75 "../src/MessageList/MessageList.vala"
	_tmp91_ = mark_menu;
#line 75 "../src/MessageList/MessageList.vala"
	_tmp92_ = mark_read_item;
#line 75 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp91_, (GtkWidget*) _tmp92_);
#line 76 "../src/MessageList/MessageList.vala"
	_tmp93_ = mark_menu;
#line 76 "../src/MessageList/MessageList.vala"
	_tmp94_ = mark_star_item;
#line 76 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp93_, (GtkWidget*) _tmp94_);
#line 77 "../src/MessageList/MessageList.vala"
	_tmp95_ = mark_menu;
#line 77 "../src/MessageList/MessageList.vala"
	_tmp96_ = mark_unstar_item;
#line 77 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp95_, (GtkWidget*) _tmp96_);
#line 78 "../src/MessageList/MessageList.vala"
	_tmp97_ = mark_menu;
#line 78 "../src/MessageList/MessageList.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp97_);
#line 80 "../src/MessageList/MessageList.vala"
	_tmp98_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MODIFY);
#line 80 "../src/MessageList/MessageList.vala"
	_tmp99_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-mark", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 80 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp99_);
#line 80 "../src/MessageList/MessageList.vala"
	_tmp100_ = mark_menu;
#line 80 "../src/MessageList/MessageList.vala"
	_tmp101_ = _g_object_ref0 (_tmp100_);
#line 80 "../src/MessageList/MessageList.vala"
	_tmp102_ = g_strdup (_ ("Mark Conversation"));
#line 80 "../src/MessageList/MessageList.vala"
	_tmp103_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 80 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp103_, _tmp98_);
#line 80 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp98_);
#line 80 "../src/MessageList/MessageList.vala"
	gtk_button_set_image ((GtkButton*) _tmp103_, (GtkWidget*) _tmp99_);
#line 80 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp99_);
#line 80 "../src/MessageList/MessageList.vala"
	gtk_menu_button_set_popup (_tmp103_, _tmp101_);
#line 80 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp101_);
#line 80 "../src/MessageList/MessageList.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp103_, _tmp102_);
#line 80 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp102_);
#line 80 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp103_);
#line 80 "../src/MessageList/MessageList.vala"
	mark_button = _tmp103_;
#line 87 "../src/MessageList/MessageList.vala"
	_tmp104_ = mail_folder_popover_new ();
#line 87 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp104_);
#line 87 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (self->priv->folder_popover);
#line 87 "../src/MessageList/MessageList.vala"
	self->priv->folder_popover = _tmp104_;
#line 89 "../src/MessageList/MessageList.vala"
	_tmp105_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MODIFY);
#line 89 "../src/MessageList/MessageList.vala"
	_tmp106_ = (GtkImage*) gtk_image_new_from_icon_name ("mail-move", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 89 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp106_);
#line 89 "../src/MessageList/MessageList.vala"
	_tmp107_ = g_strdup (_ ("Move Conversation to…"));
#line 89 "../src/MessageList/MessageList.vala"
	_tmp108_ = self->priv->folder_popover;
#line 89 "../src/MessageList/MessageList.vala"
	_tmp109_ = _g_object_ref0 ((GtkPopover*) _tmp108_);
#line 89 "../src/MessageList/MessageList.vala"
	_tmp110_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 89 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp110_, _tmp105_);
#line 89 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp105_);
#line 89 "../src/MessageList/MessageList.vala"
	gtk_button_set_image ((GtkButton*) _tmp110_, (GtkWidget*) _tmp106_);
#line 89 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp106_);
#line 89 "../src/MessageList/MessageList.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp110_, _tmp107_);
#line 89 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp107_);
#line 89 "../src/MessageList/MessageList.vala"
	gtk_menu_button_set_popover (_tmp110_, _tmp109_);
#line 89 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp109_);
#line 89 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp110_);
#line 89 "../src/MessageList/MessageList.vala"
	move_button = _tmp110_;
#line 96 "../src/MessageList/MessageList.vala"
	_tmp111_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_ARCHIVE);
#line 96 "../src/MessageList/MessageList.vala"
	_tmp112_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-archive", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 96 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp112_, _tmp111_);
#line 96 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp111_);
#line 96 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp112_);
#line 96 "../src/MessageList/MessageList.vala"
	archive_button = _tmp112_;
#line 99 "../src/MessageList/MessageList.vala"
	_tmp113_ = archive_button;
#line 99 "../src/MessageList/MessageList.vala"
	_tmp114_ = application_instance;
#line 99 "../src/MessageList/MessageList.vala"
	_tmp115_ = archive_button;
#line 99 "../src/MessageList/MessageList.vala"
	_tmp116_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp115_);
#line 99 "../src/MessageList/MessageList.vala"
	_tmp117_ = _tmp116_;
#line 99 "../src/MessageList/MessageList.vala"
	_tmp119_ = _tmp118_ = gtk_application_get_accels_for_action (_tmp114_, _tmp117_);
#line 99 "../src/MessageList/MessageList.vala"
	_tmp120_ = _tmp119_;
#line 99 "../src/MessageList/MessageList.vala"
	_tmp120__length1 = _vala_array_length (_tmp118_);
#line 99 "../src/MessageList/MessageList.vala"
	_tmp121_ = granite_markup_accel_tooltip (_tmp120_, (gint) _vala_array_length (_tmp118_), _ ("Move conversations to archive"));
#line 99 "../src/MessageList/MessageList.vala"
	_tmp122_ = _tmp121_;
#line 99 "../src/MessageList/MessageList.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp113_, _tmp122_);
#line 99 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp122_);
#line 99 "../src/MessageList/MessageList.vala"
	_tmp120_ = (_vala_array_free (_tmp120_, _tmp120__length1, (GDestroyNotify) g_free), NULL);
#line 104 "../src/MessageList/MessageList.vala"
	_tmp123_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MOVE_TO_TRASH);
#line 104 "../src/MessageList/MessageList.vala"
	_tmp124_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-delete", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 104 "../src/MessageList/MessageList.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp124_, _tmp123_);
#line 104 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp123_);
#line 104 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp124_);
#line 104 "../src/MessageList/MessageList.vala"
	trash_button = _tmp124_;
#line 107 "../src/MessageList/MessageList.vala"
	_tmp125_ = trash_button;
#line 107 "../src/MessageList/MessageList.vala"
	_tmp126_ = application_instance;
#line 107 "../src/MessageList/MessageList.vala"
	_tmp127_ = trash_button;
#line 107 "../src/MessageList/MessageList.vala"
	_tmp128_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp127_);
#line 107 "../src/MessageList/MessageList.vala"
	_tmp129_ = _tmp128_;
#line 107 "../src/MessageList/MessageList.vala"
	_tmp131_ = _tmp130_ = gtk_application_get_accels_for_action (_tmp126_, _tmp129_);
#line 107 "../src/MessageList/MessageList.vala"
	_tmp132_ = _tmp131_;
#line 107 "../src/MessageList/MessageList.vala"
	_tmp132__length1 = _vala_array_length (_tmp130_);
#line 107 "../src/MessageList/MessageList.vala"
	_tmp133_ = granite_markup_accel_tooltip (_tmp132_, (gint) _vala_array_length (_tmp130_), _ ("Move conversations to Trash"));
#line 107 "../src/MessageList/MessageList.vala"
	_tmp134_ = _tmp133_;
#line 107 "../src/MessageList/MessageList.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp125_, _tmp134_);
#line 107 "../src/MessageList/MessageList.vala"
	_g_free0 (_tmp134_);
#line 107 "../src/MessageList/MessageList.vala"
	_tmp132_ = (_vala_array_free (_tmp132_, _tmp132__length1, (GDestroyNotify) g_free), NULL);
#line 112 "../src/MessageList/MessageList.vala"
	_tmp135_ = (HdyHeaderBar*) hdy_header_bar_new ();
#line 112 "../src/MessageList/MessageList.vala"
	hdy_header_bar_set_show_close_button (_tmp135_, TRUE);
#line 112 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp135_);
#line 112 "../src/MessageList/MessageList.vala"
	_tmp136_ = _tmp135_;
#line 112 "../src/MessageList/MessageList.vala"
	mail_message_list_set_headerbar (self, _tmp136_);
#line 112 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (_tmp136_);
#line 115 "../src/MessageList/MessageList.vala"
	_tmp137_ = self->priv->_headerbar;
#line 115 "../src/MessageList/MessageList.vala"
	_tmp138_ = gtk_widget_get_style_context ((GtkWidget*) _tmp137_);
#line 115 "../src/MessageList/MessageList.vala"
	gtk_style_context_add_class (_tmp138_, GTK_STYLE_CLASS_FLAT);
#line 116 "../src/MessageList/MessageList.vala"
	_tmp139_ = self->priv->_headerbar;
#line 116 "../src/MessageList/MessageList.vala"
	_tmp140_ = reply_button;
#line 116 "../src/MessageList/MessageList.vala"
	hdy_header_bar_pack_start (_tmp139_, (GtkWidget*) _tmp140_);
#line 117 "../src/MessageList/MessageList.vala"
	_tmp141_ = self->priv->_headerbar;
#line 117 "../src/MessageList/MessageList.vala"
	_tmp142_ = reply_all_button;
#line 117 "../src/MessageList/MessageList.vala"
	hdy_header_bar_pack_start (_tmp141_, (GtkWidget*) _tmp142_);
#line 118 "../src/MessageList/MessageList.vala"
	_tmp143_ = self->priv->_headerbar;
#line 118 "../src/MessageList/MessageList.vala"
	_tmp144_ = forward_button;
#line 118 "../src/MessageList/MessageList.vala"
	hdy_header_bar_pack_start (_tmp143_, (GtkWidget*) _tmp144_);
#line 119 "../src/MessageList/MessageList.vala"
	_tmp145_ = self->priv->_headerbar;
#line 119 "../src/MessageList/MessageList.vala"
	_tmp146_ = trash_button;
#line 119 "../src/MessageList/MessageList.vala"
	hdy_header_bar_pack_end (_tmp145_, (GtkWidget*) _tmp146_);
#line 120 "../src/MessageList/MessageList.vala"
	_tmp147_ = self->priv->_headerbar;
#line 120 "../src/MessageList/MessageList.vala"
	_tmp148_ = archive_button;
#line 120 "../src/MessageList/MessageList.vala"
	hdy_header_bar_pack_end (_tmp147_, (GtkWidget*) _tmp148_);
#line 121 "../src/MessageList/MessageList.vala"
	_tmp149_ = self->priv->_headerbar;
#line 121 "../src/MessageList/MessageList.vala"
	_tmp150_ = move_button;
#line 121 "../src/MessageList/MessageList.vala"
	hdy_header_bar_pack_end (_tmp149_, (GtkWidget*) _tmp150_);
#line 122 "../src/MessageList/MessageList.vala"
	_tmp151_ = self->priv->_headerbar;
#line 122 "../src/MessageList/MessageList.vala"
	_tmp152_ = mark_button;
#line 122 "../src/MessageList/MessageList.vala"
	hdy_header_bar_pack_end (_tmp151_, (GtkWidget*) _tmp152_);
#line 124 "../src/MessageList/MessageList.vala"
	_tmp153_ = (GtkLabel*) gtk_label_new (_ ("No Message Selected"));
#line 124 "../src/MessageList/MessageList.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp153_, TRUE);
#line 124 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp153_);
#line 124 "../src/MessageList/MessageList.vala"
	placeholder = _tmp153_;
#line 128 "../src/MessageList/MessageList.vala"
	_tmp154_ = placeholder;
#line 128 "../src/MessageList/MessageList.vala"
	_tmp155_ = gtk_widget_get_style_context ((GtkWidget*) _tmp154_);
#line 128 "../src/MessageList/MessageList.vala"
	_tmp156_ = _g_object_ref0 (_tmp155_);
#line 128 "../src/MessageList/MessageList.vala"
	placeholder_style_context = _tmp156_;
#line 129 "../src/MessageList/MessageList.vala"
	_tmp157_ = placeholder_style_context;
#line 129 "../src/MessageList/MessageList.vala"
	gtk_style_context_add_class (_tmp157_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 130 "../src/MessageList/MessageList.vala"
	_tmp158_ = placeholder_style_context;
#line 130 "../src/MessageList/MessageList.vala"
	gtk_style_context_add_class (_tmp158_, GTK_STYLE_CLASS_DIM_LABEL);
#line 132 "../src/MessageList/MessageList.vala"
	_tmp159_ = (GtkListBox*) gtk_list_box_new ();
#line 132 "../src/MessageList/MessageList.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp159_, TRUE);
#line 132 "../src/MessageList/MessageList.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp159_, TRUE);
#line 132 "../src/MessageList/MessageList.vala"
	gtk_list_box_set_selection_mode (_tmp159_, GTK_SELECTION_NONE);
#line 132 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp159_);
#line 132 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (self->priv->list_box);
#line 132 "../src/MessageList/MessageList.vala"
	self->priv->list_box = _tmp159_;
#line 138 "../src/MessageList/MessageList.vala"
	_tmp160_ = self->priv->list_box;
#line 138 "../src/MessageList/MessageList.vala"
	_tmp161_ = gtk_widget_get_style_context ((GtkWidget*) _tmp160_);
#line 138 "../src/MessageList/MessageList.vala"
	gtk_style_context_add_class (_tmp161_, GTK_STYLE_CLASS_BACKGROUND);
#line 139 "../src/MessageList/MessageList.vala"
	_tmp162_ = self->priv->list_box;
#line 139 "../src/MessageList/MessageList.vala"
	_tmp163_ = placeholder;
#line 139 "../src/MessageList/MessageList.vala"
	gtk_list_box_set_placeholder (_tmp162_, (GtkWidget*) _tmp163_);
#line 140 "../src/MessageList/MessageList.vala"
	_tmp164_ = self->priv->list_box;
#line 140 "../src/MessageList/MessageList.vala"
	gtk_list_box_set_sort_func (_tmp164_, _mail_message_list_message_sort_function_gtk_list_box_sort_func, NULL, NULL);
#line 142 "../src/MessageList/MessageList.vala"
	_tmp165_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 142 "../src/MessageList/MessageList.vala"
	g_object_set (_tmp165_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 142 "../src/MessageList/MessageList.vala"
	g_object_ref_sink (_tmp165_);
#line 142 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (self->priv->scrolled_window);
#line 142 "../src/MessageList/MessageList.vala"
	self->priv->scrolled_window = _tmp165_;
#line 145 "../src/MessageList/MessageList.vala"
	_tmp166_ = self->priv->scrolled_window;
#line 145 "../src/MessageList/MessageList.vala"
	_tmp167_ = self->priv->list_box;
#line 145 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) _tmp166_, (GtkWidget*) _tmp167_);
#line 148 "../src/MessageList/MessageList.vala"
	_tmp168_ = self->priv->scrolled_window;
#line 148 "../src/MessageList/MessageList.vala"
	_tmp169_ = gtk_bin_get_child ((GtkBin*) _tmp168_);
#line 148 "../src/MessageList/MessageList.vala"
	_tmp170_ = _g_object_ref0 (_tmp169_);
#line 148 "../src/MessageList/MessageList.vala"
	scrolled_child = _tmp170_;
#line 149 "../src/MessageList/MessageList.vala"
	_tmp171_ = scrolled_child;
#line 149 "../src/MessageList/MessageList.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp171_, gtk_container_get_type ())) {
#line 2235 "MessageList.c"
		GtkWidget* _tmp172_;
		GtkAdjustment* _tmp173_;
		GtkAdjustment* _tmp174_;
#line 150 "../src/MessageList/MessageList.vala"
		_tmp172_ = scrolled_child;
#line 150 "../src/MessageList/MessageList.vala"
		_tmp173_ = gtk_adjustment_new ((gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 150 "../src/MessageList/MessageList.vala"
		g_object_ref_sink (_tmp173_);
#line 150 "../src/MessageList/MessageList.vala"
		_tmp174_ = _tmp173_;
#line 150 "../src/MessageList/MessageList.vala"
		gtk_container_set_focus_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (_tmp172_, gtk_container_get_type (), GtkContainer), _tmp174_);
#line 150 "../src/MessageList/MessageList.vala"
		_g_object_unref0 (_tmp174_);
#line 2251 "MessageList.c"
	}
#line 153 "../src/MessageList/MessageList.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 154 "../src/MessageList/MessageList.vala"
	_tmp175_ = self->priv->_headerbar;
#line 154 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp175_);
#line 155 "../src/MessageList/MessageList.vala"
	_tmp176_ = self->priv->scrolled_window;
#line 155 "../src/MessageList/MessageList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp176_);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (scrolled_child);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (placeholder_style_context);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (placeholder);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (trash_button);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (archive_button);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (move_button);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (mark_button);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (mark_menu);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (mark_unstar_item);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (mark_star_item);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (mark_read_item);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (mark_unread_item);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (forward_button);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (reply_all_button);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (reply_button);
#line 17 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (application_instance);
#line 17 "../src/MessageList/MessageList.vala"
	return obj;
#line 2297 "MessageList.c"
}

static void
mail_message_list_class_init (MailMessageListClass * klass,
                              gpointer klass_data)
{
#line 8 "../src/MessageList/MessageList.vala"
	mail_message_list_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/MessageList/MessageList.vala"
	g_type_class_adjust_private_offset (klass, &MailMessageList_private_offset);
#line 8 "../src/MessageList/MessageList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_mail_message_list_get_property;
#line 8 "../src/MessageList/MessageList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_mail_message_list_set_property;
#line 8 "../src/MessageList/MessageList.vala"
	G_OBJECT_CLASS (klass)->constructor = mail_message_list_constructor;
#line 8 "../src/MessageList/MessageList.vala"
	G_OBJECT_CLASS (klass)->finalize = mail_message_list_finalize;
#line 8 "../src/MessageList/MessageList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_MESSAGE_LIST_HEADERBAR_PROPERTY, mail_message_list_properties[MAIL_MESSAGE_LIST_HEADERBAR_PROPERTY] = g_param_spec_object ("headerbar", "headerbar", "headerbar", hdy_header_bar_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8 "../src/MessageList/MessageList.vala"
	mail_message_list_signals[MAIL_MESSAGE_LIST_HOVERING_OVER_LINK_SIGNAL] = g_signal_new ("hovering-over-link", MAIL_TYPE_MESSAGE_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
#line 2320 "MessageList.c"
}

static void
mail_message_list_instance_init (MailMessageList * self,
                                 gpointer klass)
{
#line 8 "../src/MessageList/MessageList.vala"
	self->priv = mail_message_list_get_instance_private (self);
#line 2329 "MessageList.c"
}

static void
mail_message_list_finalize (GObject * obj)
{
	MailMessageList * self;
#line 8 "../src/MessageList/MessageList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_MESSAGE_LIST, MailMessageList);
#line 10 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (self->priv->_headerbar);
#line 12 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (self->priv->folder_popover);
#line 13 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (self->priv->list_box);
#line 14 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (self->priv->scrolled_window);
#line 15 "../src/MessageList/MessageList.vala"
	_g_object_unref0 (self->priv->messages);
#line 8 "../src/MessageList/MessageList.vala"
	G_OBJECT_CLASS (mail_message_list_parent_class)->finalize (obj);
#line 2350 "MessageList.c"
}

static GType
mail_message_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailMessageListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_message_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailMessageList), 0, (GInstanceInitFunc) mail_message_list_instance_init, NULL };
	GType mail_message_list_type_id;
	mail_message_list_type_id = g_type_register_static (gtk_box_get_type (), "MailMessageList", &g_define_type_info, 0);
	MailMessageList_private_offset = g_type_add_instance_private (mail_message_list_type_id, sizeof (MailMessageListPrivate));
	return mail_message_list_type_id;
}

GType
mail_message_list_get_type (void)
{
	static volatile gsize mail_message_list_type_id__once = 0;
	if (g_once_init_enter (&mail_message_list_type_id__once)) {
		GType mail_message_list_type_id;
		mail_message_list_type_id = mail_message_list_get_type_once ();
		g_once_init_leave (&mail_message_list_type_id__once, mail_message_list_type_id);
	}
	return mail_message_list_type_id__once;
}

static void
_vala_mail_message_list_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	MailMessageList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_TYPE_MESSAGE_LIST, MailMessageList);
#line 8 "../src/MessageList/MessageList.vala"
	switch (property_id) {
#line 8 "../src/MessageList/MessageList.vala"
		case MAIL_MESSAGE_LIST_HEADERBAR_PROPERTY:
#line 8 "../src/MessageList/MessageList.vala"
		g_value_set_object (value, mail_message_list_get_headerbar (self));
#line 8 "../src/MessageList/MessageList.vala"
		break;
#line 2391 "MessageList.c"
		default:
#line 8 "../src/MessageList/MessageList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/MessageList/MessageList.vala"
		break;
#line 2397 "MessageList.c"
	}
}

static void
_vala_mail_message_list_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	MailMessageList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_TYPE_MESSAGE_LIST, MailMessageList);
#line 8 "../src/MessageList/MessageList.vala"
	switch (property_id) {
#line 8 "../src/MessageList/MessageList.vala"
		case MAIL_MESSAGE_LIST_HEADERBAR_PROPERTY:
#line 8 "../src/MessageList/MessageList.vala"
		mail_message_list_set_headerbar (self, g_value_get_object (value));
#line 8 "../src/MessageList/MessageList.vala"
		break;
#line 2417 "MessageList.c"
		default:
#line 8 "../src/MessageList/MessageList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/MessageList/MessageList.vala"
		break;
#line 2423 "MessageList.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

