/* Utils.c generated by valac 0.56.14, the Vala compiler
 * generated from Utils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: David Hewitt <davidmhewitt@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <camel/camel.h>
#include <libedataserver/libedataserver.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MAIL_TYPE_UTILS (mail_utils_get_type ())
#define MAIL_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_UTILS, MailUtils))
#define MAIL_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_UTILS, MailUtilsClass))
#define MAIL_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_UTILS))
#define MAIL_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_UTILS))
#define MAIL_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_UTILS, MailUtilsClass))

typedef struct _MailUtils MailUtils;
typedef struct _MailUtilsClass MailUtilsClass;
typedef struct _MailUtilsPrivate MailUtilsPrivate;
typedef gboolean (*MailUtilsAcceptAddress) (const gchar* address, gpointer user_data);

#define MAIL_BACKEND_TYPE_SESSION (mail_backend_session_get_type ())
#define MAIL_BACKEND_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_BACKEND_TYPE_SESSION, MailBackendSession))
#define MAIL_BACKEND_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_BACKEND_TYPE_SESSION, MailBackendSessionClass))
#define MAIL_BACKEND_IS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_BACKEND_TYPE_SESSION))
#define MAIL_BACKEND_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_BACKEND_TYPE_SESSION))
#define MAIL_BACKEND_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_BACKEND_TYPE_SESSION, MailBackendSessionClass))

typedef struct _MailBackendSession MailBackendSession;
typedef struct _MailBackendSessionClass MailBackendSessionClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _MailParamSpecUtils MailParamSpecUtils;

struct _MailUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MailUtilsPrivate * priv;
};

struct _MailUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (MailUtils *self);
};

struct _MailParamSpecUtils {
	GParamSpec parent_instance;
};

static gpointer mail_utils_parent_class = NULL;

VALA_EXTERN gpointer mail_utils_ref (gpointer instance);
VALA_EXTERN void mail_utils_unref (gpointer instance);
VALA_EXTERN GParamSpec* mail_param_spec_utils (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void mail_value_set_utils (GValue* value,
                           gpointer v_object);
VALA_EXTERN void mail_value_take_utils (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer mail_value_get_utils (const GValue* value);
VALA_EXTERN GType mail_utils_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailUtils, mail_utils_unref)
VALA_EXTERN gchar* mail_utils_get_reply_addresses (const gchar* raw_addresses,
                                       MailUtilsAcceptAddress should_add,
                                       gpointer should_add_target);
VALA_EXTERN GType mail_backend_session_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailBackendSession, g_object_unref)
VALA_EXTERN MailBackendSession* mail_backend_session_get_default (void);
VALA_EXTERN GeeArrayList* mail_backend_session_get_own_addresses (MailBackendSession* self);
VALA_EXTERN gchar* mail_utils_escape_html_tags (const gchar* input);
VALA_EXTERN gchar* mail_utils_strip_folder_full_name (const gchar* service_uid,
                                          const gchar* folder_uri);
VALA_EXTERN CamelFolderInfoFlags mail_utils_get_full_folder_info_flags (CamelService* service,
                                                            CamelFolderInfo* folderinfo);
VALA_EXTERN gchar* mail_utils_build_folder_uri (const gchar* service_uid,
                                    const gchar* folder_name);
VALA_EXTERN ESource* mail_backend_session_ref_source (MailBackendSession* self,
                                          const gchar* source_uid);
VALA_EXTERN MailUtils* mail_utils_new (void);
VALA_EXTERN MailUtils* mail_utils_construct (GType object_type);
static void mail_utils_finalize (MailUtils * obj);
static GType mail_utils_get_type_once (void);

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 138 "Utils.c"
}

gchar*
mail_utils_get_reply_addresses (const gchar* raw_addresses,
                                MailUtilsAcceptAddress should_add,
                                gpointer should_add_target)
{
	GeeArrayList* own_addresses = NULL;
	MailBackendSession* _tmp0_;
	GeeArrayList* _tmp1_;
	gchar* output = NULL;
	gchar* _tmp2_;
	GeeArrayList* added_addresses = NULL;
	GeeArrayList* _tmp3_;
	CamelInternetAddress* addresses = NULL;
	CamelInternetAddress* _tmp4_;
	CamelInternetAddress* _tmp5_;
	CamelInternetAddress* _tmp6_;
	gchar* result;
#line 24 "../src/Utils.vala"
	g_return_val_if_fail (raw_addresses != NULL, NULL);
#line 25 "../src/Utils.vala"
	_tmp0_ = mail_backend_session_get_default ();
#line 25 "../src/Utils.vala"
	_tmp1_ = mail_backend_session_get_own_addresses (_tmp0_);
#line 25 "../src/Utils.vala"
	own_addresses = _tmp1_;
#line 26 "../src/Utils.vala"
	_tmp2_ = g_strdup ("");
#line 26 "../src/Utils.vala"
	output = _tmp2_;
#line 27 "../src/Utils.vala"
	_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 27 "../src/Utils.vala"
	added_addresses = _tmp3_;
#line 29 "../src/Utils.vala"
	_tmp4_ = camel_internet_address_new ();
#line 29 "../src/Utils.vala"
	addresses = _tmp4_;
#line 30 "../src/Utils.vala"
	_tmp5_ = addresses;
#line 30 "../src/Utils.vala"
	camel_address_decode ((CamelAddress*) _tmp5_, raw_addresses);
#line 31 "../src/Utils.vala"
	_tmp6_ = addresses;
#line 31 "../src/Utils.vala"
	g_object_ref ((GObject*) _tmp6_);
#line 186 "Utils.c"
	{
		gint i = 0;
#line 32 "../src/Utils.vala"
		i = 0;
#line 191 "Utils.c"
		{
			gboolean _tmp7_ = FALSE;
#line 32 "../src/Utils.vala"
			_tmp7_ = TRUE;
#line 32 "../src/Utils.vala"
			while (TRUE) {
#line 198 "Utils.c"
				CamelInternetAddress* _tmp9_;
				const gchar* _address = NULL;
				CamelInternetAddress* _tmp10_;
				const gchar* _tmp11_ = NULL;
				const gchar* _tmp12_;
				gchar* address = NULL;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gboolean is_own_address = FALSE;
				gboolean _tmp25_ = FALSE;
				gboolean _tmp26_ = FALSE;
#line 32 "../src/Utils.vala"
				if (!_tmp7_) {
#line 212 "Utils.c"
					gint _tmp8_;
#line 32 "../src/Utils.vala"
					_tmp8_ = i;
#line 32 "../src/Utils.vala"
					i = _tmp8_ + 1;
#line 218 "Utils.c"
				}
#line 32 "../src/Utils.vala"
				_tmp7_ = FALSE;
#line 32 "../src/Utils.vala"
				_tmp9_ = addresses;
#line 32 "../src/Utils.vala"
				if (!(i < camel_address_length ((CamelAddress*) _tmp9_))) {
#line 32 "../src/Utils.vala"
					break;
#line 228 "Utils.c"
				}
#line 34 "../src/Utils.vala"
				_tmp10_ = addresses;
#line 34 "../src/Utils.vala"
				camel_internet_address_get (_tmp10_, i, NULL, &_tmp11_);
#line 34 "../src/Utils.vala"
				_address = _tmp11_;
#line 35 "../src/Utils.vala"
				_tmp12_ = _address;
#line 35 "../src/Utils.vala"
				if (_tmp12_ == NULL) {
#line 36 "../src/Utils.vala"
					continue;
#line 242 "Utils.c"
				}
#line 39 "../src/Utils.vala"
				_tmp13_ = _address;
#line 39 "../src/Utils.vala"
				_tmp14_ = g_utf8_casefold (_tmp13_, (gssize) -1);
#line 39 "../src/Utils.vala"
				address = _tmp14_;
#line 40 "../src/Utils.vala"
				is_own_address = FALSE;
#line 252 "Utils.c"
				{
					GeeArrayList* _own_address_list = NULL;
					GeeArrayList* _tmp15_;
					gint _own_address_size = 0;
					GeeArrayList* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gint _own_address_index = 0;
#line 41 "../src/Utils.vala"
					_tmp15_ = own_addresses;
#line 41 "../src/Utils.vala"
					_own_address_list = _tmp15_;
#line 41 "../src/Utils.vala"
					_tmp16_ = _own_address_list;
#line 41 "../src/Utils.vala"
					_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 41 "../src/Utils.vala"
					_tmp18_ = _tmp17_;
#line 41 "../src/Utils.vala"
					_own_address_size = _tmp18_;
#line 41 "../src/Utils.vala"
					_own_address_index = -1;
#line 41 "../src/Utils.vala"
					while (TRUE) {
#line 277 "Utils.c"
						gint _tmp19_;
						gint _tmp20_;
						gchar* own_address = NULL;
						GeeArrayList* _tmp21_;
						gpointer _tmp22_;
						const gchar* _tmp23_;
						const gchar* _tmp24_;
#line 41 "../src/Utils.vala"
						_own_address_index = _own_address_index + 1;
#line 41 "../src/Utils.vala"
						_tmp19_ = _own_address_index;
#line 41 "../src/Utils.vala"
						_tmp20_ = _own_address_size;
#line 41 "../src/Utils.vala"
						if (!(_tmp19_ < _tmp20_)) {
#line 41 "../src/Utils.vala"
							break;
#line 295 "Utils.c"
						}
#line 41 "../src/Utils.vala"
						_tmp21_ = _own_address_list;
#line 41 "../src/Utils.vala"
						_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _tmp21_, _own_address_index);
#line 41 "../src/Utils.vala"
						own_address = (gchar*) _tmp22_;
#line 42 "../src/Utils.vala"
						_tmp23_ = address;
#line 42 "../src/Utils.vala"
						_tmp24_ = own_address;
#line 42 "../src/Utils.vala"
						if (string_contains (_tmp23_, _tmp24_)) {
#line 43 "../src/Utils.vala"
							is_own_address = TRUE;
#line 44 "../src/Utils.vala"
							_g_free0 (own_address);
#line 44 "../src/Utils.vala"
							break;
#line 315 "Utils.c"
						}
#line 41 "../src/Utils.vala"
						_g_free0 (own_address);
#line 319 "Utils.c"
					}
				}
#line 48 "../src/Utils.vala"
				if (!is_own_address) {
#line 324 "Utils.c"
					const gchar* _tmp27_;
#line 48 "../src/Utils.vala"
					_tmp27_ = address;
#line 48 "../src/Utils.vala"
					_tmp26_ = should_add (_tmp27_, should_add_target);
#line 330 "Utils.c"
				} else {
#line 48 "../src/Utils.vala"
					_tmp26_ = FALSE;
#line 334 "Utils.c"
				}
#line 48 "../src/Utils.vala"
				if (_tmp26_) {
#line 338 "Utils.c"
					GeeArrayList* _tmp28_;
					const gchar* _tmp29_;
#line 48 "../src/Utils.vala"
					_tmp28_ = added_addresses;
#line 48 "../src/Utils.vala"
					_tmp29_ = address;
#line 48 "../src/Utils.vala"
					_tmp25_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 347 "Utils.c"
				} else {
#line 48 "../src/Utils.vala"
					_tmp25_ = FALSE;
#line 351 "Utils.c"
				}
#line 48 "../src/Utils.vala"
				if (_tmp25_) {
#line 355 "Utils.c"
					GeeArrayList* _tmp30_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gint _tmp33_;
					gint _tmp34_;
#line 49 "../src/Utils.vala"
					_tmp30_ = added_addresses;
#line 49 "../src/Utils.vala"
					_tmp31_ = address;
#line 49 "../src/Utils.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 50 "../src/Utils.vala"
					_tmp32_ = output;
#line 50 "../src/Utils.vala"
					_tmp33_ = strlen (_tmp32_);
#line 50 "../src/Utils.vala"
					_tmp34_ = _tmp33_;
#line 50 "../src/Utils.vala"
					if (_tmp34_ > 0) {
#line 375 "Utils.c"
						const gchar* _tmp35_;
						const gchar* _tmp36_;
						gchar* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
#line 51 "../src/Utils.vala"
						_tmp35_ = output;
#line 51 "../src/Utils.vala"
						_tmp36_ = address;
#line 51 "../src/Utils.vala"
						_tmp37_ = g_strdup_printf (", %s", _tmp36_);
#line 51 "../src/Utils.vala"
						_tmp38_ = _tmp37_;
#line 51 "../src/Utils.vala"
						_tmp39_ = g_strconcat (_tmp35_, _tmp38_, NULL);
#line 51 "../src/Utils.vala"
						_g_free0 (output);
#line 51 "../src/Utils.vala"
						output = _tmp39_;
#line 51 "../src/Utils.vala"
						_g_free0 (_tmp38_);
#line 397 "Utils.c"
					} else {
						const gchar* _tmp40_;
						const gchar* _tmp41_;
						gchar* _tmp42_;
#line 53 "../src/Utils.vala"
						_tmp40_ = output;
#line 53 "../src/Utils.vala"
						_tmp41_ = address;
#line 53 "../src/Utils.vala"
						_tmp42_ = g_strconcat (_tmp40_, _tmp41_, NULL);
#line 53 "../src/Utils.vala"
						_g_free0 (output);
#line 53 "../src/Utils.vala"
						output = _tmp42_;
#line 412 "Utils.c"
					}
				}
#line 32 "../src/Utils.vala"
				_g_free0 (address);
#line 417 "Utils.c"
			}
		}
	}
#line 58 "../src/Utils.vala"
	result = output;
#line 58 "../src/Utils.vala"
	_g_object_unref0 (addresses);
#line 58 "../src/Utils.vala"
	_g_object_unref0 (added_addresses);
#line 58 "../src/Utils.vala"
	_g_object_unref0 (own_addresses);
#line 58 "../src/Utils.vala"
	return result;
#line 431 "Utils.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 453 "Utils.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 457 "Utils.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 463 "Utils.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 467 "Utils.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 471 "Utils.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 479 "Utils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 507 "Utils.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 516 "Utils.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 530 "Utils.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 539 "Utils.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 553 "Utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 562 "Utils.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 571 "Utils.c"
}

gchar*
mail_utils_escape_html_tags (const gchar* input)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 61 "../src/Utils.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 62 "../src/Utils.vala"
	_tmp0_ = string_replace (input, "<", "&lt;");
#line 62 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 62 "../src/Utils.vala"
	_tmp2_ = string_replace (_tmp1_, ">", "&gt;");
#line 62 "../src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 62 "../src/Utils.vala"
	_g_free0 (_tmp1_);
#line 62 "../src/Utils.vala"
	result = _tmp3_;
#line 62 "../src/Utils.vala"
	return result;
#line 598 "Utils.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 619 "Utils.c"
}

gchar*
mail_utils_strip_folder_full_name (const gchar* service_uid,
                                   const gchar* folder_uri)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 65 "../src/Utils.vala"
	g_return_val_if_fail (service_uid != NULL, NULL);
#line 66 "../src/Utils.vala"
	if (folder_uri != NULL) {
#line 632 "Utils.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 66 "../src/Utils.vala"
		_tmp1_ = string_strip (folder_uri);
#line 66 "../src/Utils.vala"
		_tmp2_ = _tmp1_;
#line 66 "../src/Utils.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "") != 0;
#line 66 "../src/Utils.vala"
		_g_free0 (_tmp2_);
#line 643 "Utils.c"
	} else {
#line 66 "../src/Utils.vala"
		_tmp0_ = FALSE;
#line 647 "Utils.c"
	}
#line 66 "../src/Utils.vala"
	if (_tmp0_) {
#line 651 "Utils.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 67 "../src/Utils.vala"
		_tmp3_ = g_strdup_printf ("folder://%s/", service_uid);
#line 67 "../src/Utils.vala"
		_tmp4_ = _tmp3_;
#line 67 "../src/Utils.vala"
		_tmp5_ = string_replace (folder_uri, _tmp4_, "");
#line 67 "../src/Utils.vala"
		_tmp6_ = _tmp5_;
#line 67 "../src/Utils.vala"
		_g_free0 (_tmp4_);
#line 67 "../src/Utils.vala"
		result = _tmp6_;
#line 67 "../src/Utils.vala"
		return result;
#line 670 "Utils.c"
	}
#line 70 "../src/Utils.vala"
	result = NULL;
#line 70 "../src/Utils.vala"
	return result;
#line 676 "Utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "../src/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 684 "Utils.c"
}

CamelFolderInfoFlags
mail_utils_get_full_folder_info_flags (CamelService* service,
                                       CamelFolderInfo* folderinfo)
{
	CamelFolderInfoFlags full_flags = 0U;
	gchar* folder_uri = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	MailBackendSession* session = NULL;
	MailBackendSession* _tmp4_;
	MailBackendSession* _tmp5_;
	ESource* service_source = NULL;
	MailBackendSession* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	ESource* _tmp9_;
	gboolean _tmp10_ = FALSE;
	ESource* _tmp11_;
	CamelFolderInfoFlags result;
#line 73 "../src/Utils.vala"
	g_return_val_if_fail (service != NULL, 0U);
#line 73 "../src/Utils.vala"
	g_return_val_if_fail (folderinfo != NULL, 0U);
#line 74 "../src/Utils.vala"
	full_flags = folderinfo->flags;
#line 76 "../src/Utils.vala"
	_tmp0_ = camel_service_get_uid (service);
#line 76 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 76 "../src/Utils.vala"
	_tmp2_ = folderinfo->full_name;
#line 76 "../src/Utils.vala"
	_tmp3_ = mail_utils_build_folder_uri (_tmp1_, _tmp2_);
#line 76 "../src/Utils.vala"
	folder_uri = _tmp3_;
#line 77 "../src/Utils.vala"
	_tmp4_ = mail_backend_session_get_default ();
#line 77 "../src/Utils.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 77 "../src/Utils.vala"
	session = _tmp5_;
#line 78 "../src/Utils.vala"
	_tmp6_ = session;
#line 78 "../src/Utils.vala"
	_tmp7_ = camel_service_get_uid (service);
#line 78 "../src/Utils.vala"
	_tmp8_ = _tmp7_;
#line 78 "../src/Utils.vala"
	_tmp9_ = mail_backend_session_ref_source (_tmp6_, _tmp8_);
#line 78 "../src/Utils.vala"
	service_source = _tmp9_;
#line 80 "../src/Utils.vala"
	_tmp11_ = service_source;
#line 80 "../src/Utils.vala"
	if (_tmp11_ != NULL) {
#line 744 "Utils.c"
		ESource* _tmp12_;
#line 80 "../src/Utils.vala"
		_tmp12_ = service_source;
#line 80 "../src/Utils.vala"
		_tmp10_ = e_source_has_extension (_tmp12_, E_SOURCE_EXTENSION_MAIL_ACCOUNT);
#line 750 "Utils.c"
	} else {
#line 80 "../src/Utils.vala"
		_tmp10_ = FALSE;
#line 754 "Utils.c"
	}
#line 80 "../src/Utils.vala"
	if (_tmp10_) {
#line 758 "Utils.c"
		ESourceMailAccount* mail_account_extension = NULL;
		ESource* _tmp13_;
		ESourceExtension* _tmp14_;
		ESourceMailAccount* _tmp15_;
		ESourceMailAccount* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp19_;
		gboolean _tmp20_;
		gchar* identity_uid = NULL;
		ESourceMailAccount* _tmp21_;
		gchar* _tmp22_;
		ESource* identity_source = NULL;
		MailBackendSession* _tmp23_;
		const gchar* _tmp24_;
		ESource* _tmp25_;
		ESource* _tmp26_;
#line 81 "../src/Utils.vala"
		_tmp13_ = service_source;
#line 81 "../src/Utils.vala"
		_tmp14_ = e_source_get_extension (_tmp13_, E_SOURCE_EXTENSION_MAIL_ACCOUNT);
#line 81 "../src/Utils.vala"
		_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, e_source_mail_account_get_type (), ESourceMailAccount));
#line 81 "../src/Utils.vala"
		mail_account_extension = _tmp15_;
#line 83 "../src/Utils.vala"
		_tmp16_ = mail_account_extension;
#line 83 "../src/Utils.vala"
		_tmp17_ = e_source_mail_account_dup_archive_folder (_tmp16_);
#line 83 "../src/Utils.vala"
		_tmp18_ = _tmp17_;
#line 83 "../src/Utils.vala"
		_tmp19_ = folder_uri;
#line 83 "../src/Utils.vala"
		_tmp20_ = g_strcmp0 (_tmp18_, _tmp19_) == 0;
#line 83 "../src/Utils.vala"
		_g_free0 (_tmp18_);
#line 83 "../src/Utils.vala"
		if (_tmp20_) {
#line 84 "../src/Utils.vala"
			full_flags = full_flags | CAMEL_FOLDER_TYPE_ARCHIVE;
#line 800 "Utils.c"
		}
#line 87 "../src/Utils.vala"
		_tmp21_ = mail_account_extension;
#line 87 "../src/Utils.vala"
		_tmp22_ = e_source_mail_account_dup_identity_uid (_tmp21_);
#line 87 "../src/Utils.vala"
		identity_uid = _tmp22_;
#line 88 "../src/Utils.vala"
		_tmp23_ = session;
#line 88 "../src/Utils.vala"
		_tmp24_ = identity_uid;
#line 88 "../src/Utils.vala"
		_tmp25_ = mail_backend_session_ref_source (_tmp23_, _tmp24_);
#line 88 "../src/Utils.vala"
		identity_source = _tmp25_;
#line 90 "../src/Utils.vala"
		_tmp26_ = identity_source;
#line 90 "../src/Utils.vala"
		if (_tmp26_ != NULL) {
#line 820 "Utils.c"
			ESourceMailComposition* mail_composition_extension = NULL;
			ESource* _tmp27_;
			ESourceExtension* _tmp28_;
			ESourceMailComposition* _tmp29_;
			ESourceMailSubmission* mail_submission_extension = NULL;
			ESource* _tmp30_;
			ESourceExtension* _tmp31_;
			ESourceMailSubmission* _tmp32_;
			gboolean _tmp33_ = FALSE;
			ESourceMailComposition* _tmp34_;
#line 91 "../src/Utils.vala"
			_tmp27_ = identity_source;
#line 91 "../src/Utils.vala"
			_tmp28_ = e_source_get_extension (_tmp27_, E_SOURCE_EXTENSION_MAIL_COMPOSITION);
#line 91 "../src/Utils.vala"
			_tmp29_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, e_source_mail_composition_get_type (), ESourceMailComposition));
#line 91 "../src/Utils.vala"
			mail_composition_extension = _tmp29_;
#line 92 "../src/Utils.vala"
			_tmp30_ = identity_source;
#line 92 "../src/Utils.vala"
			_tmp31_ = e_source_get_extension (_tmp30_, E_SOURCE_EXTENSION_MAIL_SUBMISSION);
#line 92 "../src/Utils.vala"
			_tmp32_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, e_source_mail_submission_get_type (), ESourceMailSubmission));
#line 92 "../src/Utils.vala"
			mail_submission_extension = _tmp32_;
#line 94 "../src/Utils.vala"
			_tmp34_ = mail_composition_extension;
#line 94 "../src/Utils.vala"
			if (_tmp34_ != NULL) {
#line 851 "Utils.c"
				ESourceMailComposition* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				const gchar* _tmp38_;
#line 94 "../src/Utils.vala"
				_tmp35_ = mail_composition_extension;
#line 94 "../src/Utils.vala"
				_tmp36_ = e_source_mail_composition_dup_drafts_folder (_tmp35_);
#line 94 "../src/Utils.vala"
				_tmp37_ = _tmp36_;
#line 94 "../src/Utils.vala"
				_tmp38_ = folder_uri;
#line 94 "../src/Utils.vala"
				_tmp33_ = g_strcmp0 (_tmp37_, _tmp38_) == 0;
#line 94 "../src/Utils.vala"
				_g_free0 (_tmp37_);
#line 868 "Utils.c"
			} else {
#line 94 "../src/Utils.vala"
				_tmp33_ = FALSE;
#line 872 "Utils.c"
			}
#line 94 "../src/Utils.vala"
			if (_tmp33_) {
#line 95 "../src/Utils.vala"
				full_flags = full_flags | CAMEL_FOLDER_TYPE_DRAFTS;
#line 878 "Utils.c"
			} else {
				gboolean _tmp39_ = FALSE;
				ESourceMailSubmission* _tmp40_;
#line 96 "../src/Utils.vala"
				_tmp40_ = mail_submission_extension;
#line 96 "../src/Utils.vala"
				if (_tmp40_ != NULL) {
#line 886 "Utils.c"
					ESourceMailSubmission* _tmp41_;
					gchar* _tmp42_;
					gchar* _tmp43_;
					const gchar* _tmp44_;
#line 96 "../src/Utils.vala"
					_tmp41_ = mail_submission_extension;
#line 96 "../src/Utils.vala"
					_tmp42_ = e_source_mail_submission_dup_sent_folder (_tmp41_);
#line 96 "../src/Utils.vala"
					_tmp43_ = _tmp42_;
#line 96 "../src/Utils.vala"
					_tmp44_ = folder_uri;
#line 96 "../src/Utils.vala"
					_tmp39_ = g_strcmp0 (_tmp43_, _tmp44_) == 0;
#line 96 "../src/Utils.vala"
					_g_free0 (_tmp43_);
#line 903 "Utils.c"
				} else {
#line 96 "../src/Utils.vala"
					_tmp39_ = FALSE;
#line 907 "Utils.c"
				}
#line 96 "../src/Utils.vala"
				if (_tmp39_) {
#line 97 "../src/Utils.vala"
					full_flags = full_flags | CAMEL_FOLDER_TYPE_SENT;
#line 913 "Utils.c"
				}
			}
#line 90 "../src/Utils.vala"
			_g_object_unref0 (mail_submission_extension);
#line 90 "../src/Utils.vala"
			_g_object_unref0 (mail_composition_extension);
#line 920 "Utils.c"
		}
#line 80 "../src/Utils.vala"
		_g_object_unref0 (identity_source);
#line 80 "../src/Utils.vala"
		_g_free0 (identity_uid);
#line 80 "../src/Utils.vala"
		_g_object_unref0 (mail_account_extension);
#line 928 "Utils.c"
	}
#line 102 "../src/Utils.vala"
	result = full_flags;
#line 102 "../src/Utils.vala"
	_g_object_unref0 (service_source);
#line 102 "../src/Utils.vala"
	_g_object_unref0 (session);
#line 102 "../src/Utils.vala"
	_g_free0 (folder_uri);
#line 102 "../src/Utils.vala"
	return result;
#line 940 "Utils.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 963 "Utils.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 972 "Utils.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 991 "Utils.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 995 "Utils.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1001 "Utils.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1011 "Utils.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1019 "Utils.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1023 "Utils.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 1029 "Utils.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 1039 "Utils.c"
}

gchar*
mail_utils_build_folder_uri (const gchar* service_uid,
                             const gchar* folder_name)
{
	gchar* normed_folder_name = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* encoded_service_uid = NULL;
	gchar* _tmp4_;
	gchar* encoded_normed_folder_name = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 105 "../src/Utils.vala"
	g_return_val_if_fail (service_uid != NULL, NULL);
#line 105 "../src/Utils.vala"
	g_return_val_if_fail (folder_name != NULL, NULL);
#line 106 "../src/Utils.vala"
	_tmp0_ = g_strdup (folder_name);
#line 106 "../src/Utils.vala"
	normed_folder_name = _tmp0_;
#line 109 "../src/Utils.vala"
	_tmp1_ = normed_folder_name;
#line 109 "../src/Utils.vala"
	if (g_str_has_prefix (_tmp1_, "/")) {
#line 1068 "Utils.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 110 "../src/Utils.vala"
		_tmp2_ = normed_folder_name;
#line 110 "../src/Utils.vala"
		_tmp3_ = string_substring (_tmp2_, (glong) 1, (glong) -1);
#line 110 "../src/Utils.vala"
		_g_free0 (normed_folder_name);
#line 110 "../src/Utils.vala"
		normed_folder_name = _tmp3_;
#line 1079 "Utils.c"
	}
#line 113 "../src/Utils.vala"
	_tmp4_ = camel_url_encode (service_uid, ":;@/");
#line 113 "../src/Utils.vala"
	encoded_service_uid = _tmp4_;
#line 114 "../src/Utils.vala"
	_tmp5_ = normed_folder_name;
#line 114 "../src/Utils.vala"
	_tmp6_ = camel_url_encode (_tmp5_, ":;@?#");
#line 114 "../src/Utils.vala"
	encoded_normed_folder_name = _tmp6_;
#line 116 "../src/Utils.vala"
	_tmp7_ = g_strdup_printf ("folder://%s/%s", encoded_service_uid, encoded_normed_folder_name);
#line 116 "../src/Utils.vala"
	result = _tmp7_;
#line 116 "../src/Utils.vala"
	_g_free0 (encoded_normed_folder_name);
#line 116 "../src/Utils.vala"
	_g_free0 (encoded_service_uid);
#line 116 "../src/Utils.vala"
	_g_free0 (normed_folder_name);
#line 116 "../src/Utils.vala"
	return result;
#line 1103 "Utils.c"
}

MailUtils*
mail_utils_construct (GType object_type)
{
	MailUtils* self = NULL;
#line 21 "../src/Utils.vala"
	self = (MailUtils*) g_type_create_instance (object_type);
#line 21 "../src/Utils.vala"
	return self;
#line 1114 "Utils.c"
}

MailUtils*
mail_utils_new (void)
{
#line 21 "../src/Utils.vala"
	return mail_utils_construct (MAIL_TYPE_UTILS);
#line 1122 "Utils.c"
}

static void
mail_value_utils_init (GValue* value)
{
#line 21 "../src/Utils.vala"
	value->data[0].v_pointer = NULL;
#line 1130 "Utils.c"
}

static void
mail_value_utils_free_value (GValue* value)
{
#line 21 "../src/Utils.vala"
	if (value->data[0].v_pointer) {
#line 21 "../src/Utils.vala"
		mail_utils_unref (value->data[0].v_pointer);
#line 1140 "Utils.c"
	}
}

static void
mail_value_utils_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 21 "../src/Utils.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../src/Utils.vala"
		dest_value->data[0].v_pointer = mail_utils_ref (src_value->data[0].v_pointer);
#line 1152 "Utils.c"
	} else {
#line 21 "../src/Utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1156 "Utils.c"
	}
}

static gpointer
mail_value_utils_peek_pointer (const GValue* value)
{
#line 21 "../src/Utils.vala"
	return value->data[0].v_pointer;
#line 1165 "Utils.c"
}

static gchar*
mail_value_utils_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 21 "../src/Utils.vala"
	if (collect_values[0].v_pointer) {
#line 1176 "Utils.c"
		MailUtils * object;
		object = collect_values[0].v_pointer;
#line 21 "../src/Utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../src/Utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1183 "Utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../src/Utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1187 "Utils.c"
		}
#line 21 "../src/Utils.vala"
		value->data[0].v_pointer = mail_utils_ref (object);
#line 1191 "Utils.c"
	} else {
#line 21 "../src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 1195 "Utils.c"
	}
#line 21 "../src/Utils.vala"
	return NULL;
#line 1199 "Utils.c"
}

static gchar*
mail_value_utils_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	MailUtils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../src/Utils.vala"
	if (!object_p) {
#line 21 "../src/Utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1214 "Utils.c"
	}
#line 21 "../src/Utils.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../src/Utils.vala"
		*object_p = NULL;
#line 1220 "Utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../src/Utils.vala"
		*object_p = value->data[0].v_pointer;
#line 1224 "Utils.c"
	} else {
#line 21 "../src/Utils.vala"
		*object_p = mail_utils_ref (value->data[0].v_pointer);
#line 1228 "Utils.c"
	}
#line 21 "../src/Utils.vala"
	return NULL;
#line 1232 "Utils.c"
}

GParamSpec*
mail_param_spec_utils (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	MailParamSpecUtils* spec;
#line 21 "../src/Utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, MAIL_TYPE_UTILS), NULL);
#line 21 "../src/Utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../src/Utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../src/Utils.vala"
	return G_PARAM_SPEC (spec);
#line 1251 "Utils.c"
}

gpointer
mail_value_get_utils (const GValue* value)
{
#line 21 "../src/Utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MAIL_TYPE_UTILS), NULL);
#line 21 "../src/Utils.vala"
	return value->data[0].v_pointer;
#line 1261 "Utils.c"
}

void
mail_value_set_utils (GValue* value,
                      gpointer v_object)
{
	MailUtils * old;
#line 21 "../src/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MAIL_TYPE_UTILS));
#line 21 "../src/Utils.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Utils.vala"
	if (v_object) {
#line 21 "../src/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MAIL_TYPE_UTILS));
#line 21 "../src/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../src/Utils.vala"
		mail_utils_ref (value->data[0].v_pointer);
#line 1283 "Utils.c"
	} else {
#line 21 "../src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 1287 "Utils.c"
	}
#line 21 "../src/Utils.vala"
	if (old) {
#line 21 "../src/Utils.vala"
		mail_utils_unref (old);
#line 1293 "Utils.c"
	}
}

void
mail_value_take_utils (GValue* value,
                       gpointer v_object)
{
	MailUtils * old;
#line 21 "../src/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MAIL_TYPE_UTILS));
#line 21 "../src/Utils.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Utils.vala"
	if (v_object) {
#line 21 "../src/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MAIL_TYPE_UTILS));
#line 21 "../src/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 1314 "Utils.c"
	} else {
#line 21 "../src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 1318 "Utils.c"
	}
#line 21 "../src/Utils.vala"
	if (old) {
#line 21 "../src/Utils.vala"
		mail_utils_unref (old);
#line 1324 "Utils.c"
	}
}

static void
mail_utils_class_init (MailUtilsClass * klass,
                       gpointer klass_data)
{
#line 21 "../src/Utils.vala"
	mail_utils_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Utils.vala"
	((MailUtilsClass *) klass)->finalize = mail_utils_finalize;
#line 1336 "Utils.c"
}

static void
mail_utils_instance_init (MailUtils * self,
                          gpointer klass)
{
#line 21 "../src/Utils.vala"
	self->ref_count = 1;
#line 1345 "Utils.c"
}

static void
mail_utils_finalize (MailUtils * obj)
{
	MailUtils * self;
#line 21 "../src/Utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_UTILS, MailUtils);
#line 21 "../src/Utils.vala"
	g_signal_handlers_destroy (self);
#line 1356 "Utils.c"
}

static GType
mail_utils_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { mail_value_utils_init, mail_value_utils_free_value, mail_value_utils_copy_value, mail_value_utils_peek_pointer, "p", mail_value_utils_collect_value, "p", mail_value_utils_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MailUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailUtils), 0, (GInstanceInitFunc) mail_utils_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType mail_utils_type_id;
	mail_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MailUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return mail_utils_type_id;
}

GType
mail_utils_get_type (void)
{
	static volatile gsize mail_utils_type_id__once = 0;
	if (g_once_init_enter (&mail_utils_type_id__once)) {
		GType mail_utils_type_id;
		mail_utils_type_id = mail_utils_get_type_once ();
		g_once_init_leave (&mail_utils_type_id__once, mail_utils_type_id);
	}
	return mail_utils_type_id__once;
}

gpointer
mail_utils_ref (gpointer instance)
{
	MailUtils * self;
	self = instance;
#line 21 "../src/Utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../src/Utils.vala"
	return instance;
#line 1391 "Utils.c"
}

void
mail_utils_unref (gpointer instance)
{
	MailUtils * self;
	self = instance;
#line 21 "../src/Utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../src/Utils.vala"
		MAIL_UTILS_GET_CLASS (self)->finalize (self);
#line 21 "../src/Utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1405 "Utils.c"
	}
}

